{
    "scan": {
        "analyzer-version-clang": "18.1.2",
        "analyzer-version-cppcheck": "2.13.0",
        "analyzer-version-gcc": "14.0.1",
        "analyzer-version-gcc-analyzer": "14.0.1",
        "analyzer-version-shellcheck": "0.10.0",
        "enabled-plugins": "clang, cppcheck, gcc, shellcheck",
        "exit-code": 0,
        "host": "ip-172-16-1-207.us-west-2.compute.internal",
        "mock-config": "fedora-41-x86_64",
        "project-name": "openssh-9.6p1-1.fc41.6",
        "store-results-to": "/tmp/tmpc62xia9y/openssh-9.6p1-1.fc41.6.tar.xz",
        "time-created": "2024-04-17 06:18:17",
        "time-finished": "2024-04-17 06:22:28",
        "tool": "csmock",
        "tool-args": "'/usr/bin/csmock' '-r' 'fedora-41-x86_64' '-t' 'shellcheck,clang,cppcheck,gcc' '-o' '/tmp/tmpc62xia9y/openssh-9.6p1-1.fc41.6.tar.xz' '--gcc-analyze' '/tmp/tmpc62xia9y/openssh-9.6p1-1.fc41.6.src.rpm'",
        "tool-version": "csmock-3.5.3-1.el9"
    },
    "defects": [
        {
            "checker": "SHELLCHECK_WARNING",
            "cwe": 758,
            "language": "shell",
            "tool": "shellcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/etc/profile.d/gnome-ssh-askpass.sh",
                    "line": 1,
                    "column": 1,
                    "event": "error[SC2148]",
                    "message": "Tips depend on target shell and yours is unknown. Add a shebang or a 'shell' directive.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "    1|-> SSH_ASKPASS=/usr/libexec/openssh/gnome-ssh-askpass",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "    2|   export SSH_ASKPASS",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘addr_or’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 238,
                    "column": 9,
                    "event": "warning[-Wanalyzer-overlapping-buffers]",
                    "message": "overlapping buffers passed as arguments to ‘memcpy’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 360,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘addr_host_to_all1s’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 364,
                    "column": 13,
                    "event": "note",
                    "message": "(2) calling ‘addr_hostmask’ from ‘addr_host_to_all1s’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 196,
                    "column": 1,
                    "event": "note",
                    "message": "(3) entry to ‘addr_hostmask’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 198,
                    "column": 13,
                    "event": "note",
                    "message": "(4) calling ‘addr_netmask’ from ‘addr_hostmask’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 167,
                    "column": 1,
                    "event": "note",
                    "message": "(5) entry to ‘addr_netmask’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 171,
                    "column": 39,
                    "event": "note",
                    "message": "(6) following ‘false’ branch (when ‘n’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 174,
                    "column": 9,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 198,
                    "column": 13,
                    "event": "note",
                    "message": "(8) returning to ‘addr_hostmask’ from ‘addr_netmask’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 198,
                    "column": 12,
                    "event": "note",
                    "message": "(9) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 198,
                    "column": 45,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 198,
                    "column": 45,
                    "event": "note",
                    "message": "(11) calling ‘addr_invert’ from ‘addr_hostmask’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 141,
                    "column": 1,
                    "event": "note",
                    "message": "(12) entry to ‘addr_invert’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 145,
                    "column": 12,
                    "event": "note",
                    "message": "(13) following ‘false’ branch (when ‘n’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 148,
                    "column": 18,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 148,
                    "column": 9,
                    "event": "note",
                    "message": "(15) following ‘case 2:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 149,
                    "column": 9,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 198,
                    "column": 45,
                    "event": "note",
                    "message": "(17) returning to ‘addr_hostmask’ from ‘addr_invert’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 198,
                    "column": 42,
                    "event": "note",
                    "message": "(18) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(19) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 364,
                    "column": 13,
                    "event": "note",
                    "message": "(20) returning to ‘addr_host_to_all1s’ from ‘addr_hostmask’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 364,
                    "column": 12,
                    "event": "note",
                    "message": "(21) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 366,
                    "column": 13,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 366,
                    "column": 13,
                    "event": "note",
                    "message": "(23) calling ‘addr_or’ from ‘addr_host_to_all1s’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 231,
                    "column": 1,
                    "event": "note",
                    "message": "(24) entry to ‘addr_or’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 235,
                    "column": 12,
                    "event": "note",
                    "message": "(25) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 238,
                    "column": 9,
                    "event": "note",
                    "message": "(26) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 238,
                    "column": 9,
                    "event": "note",
                    "message": "(27) overlapping buffers passed as arguments to ‘memcpy’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/addr.c",
                    "line": 27,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/string.h",
                    "line": 43,
                    "column": 14,
                    "event": "note",
                    "message": "the behavior of ‘memcpy’ is undefined for overlapping buffers",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  236|   \t\treturn (-1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  237|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  238|-> \tmemcpy(dst, a, sizeof(*dst));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  239|   \tswitch (a->af) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  240|   \tcase AF_INET:",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/audit-linux.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘audit_event’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/audit-linux.c",
                    "line": 274,
                    "column": 20,
                    "event": "warning[-Wimplicit-fallthrough=]",
                    "message": "this statement may fall through",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  274 |                 if (options.use_pam)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                    ^",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/audit-linux.c",
                    "line": 276,
                    "column": 9,
                    "event": "note",
                    "message": "here",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  276 |         case SSH_LOGIN_EXCEED_MAXTRIES:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |         ^~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  272|   \t\tbreak;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  273|   \tcase SSH_AUTH_FAIL_PASSWD:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  274|-> \t\tif (options.use_pam)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  275|   \t\t\tbreak;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  276|   \tcase SSH_LOGIN_EXCEED_MAXTRIES:",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/audit-linux.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘audit_unsupported_body’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/audit-linux.c",
                    "line": 313,
                    "column": 9,
                    "event": "warning[-Wold-style-declaration]",
                    "message": "‘static’ is not at beginning of declaration",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  313 |         const static char *name[] = { \"cipher\", \"mac\", \"comp\" };",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |         ^~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  311|   #ifdef AUDIT_CRYPTO_SESSION",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  312|   \tchar buf[AUDIT_LOG_SIZE];",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  313|-> \tconst static char *name[] = { \"cipher\", \"mac\", \"comp\" };",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  314|   \tchar *s;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  315|   \tint audit_fd;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/audit-linux.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "At top level",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/audit-linux.c",
                    "line": 331,
                    "column": 1,
                    "event": "warning[-Wold-style-declaration]",
                    "message": "‘static’ is not at beginning of declaration",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  331 | const static char *direction[] = { \"from-server\", \"from-client\", \"both\" };",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      | ^~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  329|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  330|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  331|-> const static char *direction[] = { \"from-server\", \"from-client\", \"both\" };",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  332|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  333|   void",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 476,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘krb5_cleanup_proc’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 268,
                    "column": 50,
                    "event": "warning[-Wanalyzer-null-dereference]",
                    "message": "dereference of NULL ‘0’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 246,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 247,
                    "column": 30,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 256,
                    "column": 20,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 259,
                    "column": 23,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 264,
                    "column": 27,
                    "event": "note",
                    "message": "(5) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 266,
                    "column": 25,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 266,
                    "column": 25,
                    "event": "note",
                    "message": "(7) when ‘strncpy’ copies the full source string",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 267,
                    "column": 49,
                    "event": "note",
                    "message": "(8) when ‘strchr’ returns NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 268,
                    "column": 50,
                    "event": "note",
                    "message": "(9) dereference of NULL ‘strchr(&krb5_ccname, 58)’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  266|   \t\t\tstrncpy(krb5_ccname, authctxt->krb5_ccname, sizeof(krb5_ccname) - 10);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  267|   \t\t\tkrb5_ccname_dir_start = strchr(krb5_ccname, ':') + 1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  268|-> \t\t\t*krb5_ccname_dir_start++ = '\\0';",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  269|   \t\t\tif (strcmp(krb5_ccname, \"DIR\") == 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  270|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 337,
                    "column": 17,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'p_n' is used in the enclosing expression, the value is never actually read from 'p_n'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 337,
                    "column": 17,
                    "event": "note",
                    "message": "Although the value stored to 'p_n' is used in the enclosing expression, the value is never actually read from 'p_n'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  335|   \t\treturn -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  336|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  337|-> \ttmp_template = p_n = p_o = xstrdup(template);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  338|   \tr = xstrdup(\"\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  339|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 476,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘ssh_krb5_expand_template’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 360,
                    "column": 30,
                    "event": "warning[-Wanalyzer-null-dereference]",
                    "message": "dereference of NULL ‘0’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 334,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch (when ‘template’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 337,
                    "column": 36,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 340,
                    "column": 23,
                    "event": "note",
                    "message": "(3) when ‘strstr’ returns non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 340,
                    "column": 42,
                    "event": "note",
                    "message": "(4) following ‘true’ branch (when ‘p_n’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 342,
                    "column": 21,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 343,
                    "column": 20,
                    "event": "note",
                    "message": "(6) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 346,
                    "column": 21,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 346,
                    "column": 20,
                    "event": "note",
                    "message": "(8) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 353,
                    "column": 26,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 353,
                    "column": 25,
                    "event": "note",
                    "message": "(10) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 359,
                    "column": 31,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 359,
                    "column": 31,
                    "event": "note",
                    "message": "(12) when ‘strchr’ returns NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-krb5.c",
                    "line": 360,
                    "column": 30,
                    "event": "note",
                    "message": "(13) dereference of NULL ‘strchr(p_n, 125)’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  358|   \t\t} else {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  359|   \t\t\tp_o = strchr(p_n, '}') + 1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  360|-> \t\t\t*p_o = '\\0';",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  361|   \t\t\tdebug_f(\"unsupported token %s in %s\", p_n, template);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  362|   \t\t\t/* unknown token, fallback to the default */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/auth-options.c",
                    "line": 343,
                    "column": 8,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/auth-options.c",
                    "line": 343,
                    "column": 8,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  341|   \twhile (*opts && *opts != ' ' && *opts != '\\t') {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  342|   \t\t/* flag options */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  343|-> \t\tif ((r = opt_flag(\"restrict\", 0, &opts)) != -1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  344|   \t\t\tret->restricted = 1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  345|   \t\t\tret->permit_port_forwarding_flag = 0;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/auth-options.c",
                    "line": 538,
                    "column": 14,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'errstr' during its initialization is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/auth-options.c",
                    "line": 538,
                    "column": 14,
                    "event": "note",
                    "message": "Value stored to 'errstr' during its initialization is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  536|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  537|   \tstruct sshauthopt *ret;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  538|-> \tconst char *errstr = \"internal error\";",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  539|   \tconst char *tmp;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  540|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/auth-pam.c",
                    "line": 882,
                    "column": 4,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'plen' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/auth-pam.c",
                    "line": 882,
                    "column": 4,
                    "event": "note",
                    "message": "Value stored to 'plen' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  880|   \t\t\t**prompts = xreallocarray(**prompts, 1, len);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  881|   \t\t\tstrlcpy(**prompts + plen, msg, len - plen);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  882|-> \t\t\tplen += mlen;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  883|   \t\t\t**echo_on = (type == PAM_PROMPT_ECHO_ON);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  884|   \t\t\tfree(msg);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/auth-pam.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sshpam_respond’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/auth-pam.c",
                    "line": 979,
                    "column": 15,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of ‘fake_password(*resp)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/auth-pam.c",
                    "line": 990,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘sshpam_respond’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-pam.c",
                    "line": 998,
                    "column": 9,
                    "event": "note",
                    "message": "(2) following ‘case 0:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-pam.c",
                    "line": 1007,
                    "column": 12,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-pam.c",
                    "line": 1007,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following ‘false’ branch (when ‘num == 1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-pam.c",
                    "line": 1011,
                    "column": 23,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-pam.c",
                    "line": 1011,
                    "column": 12,
                    "event": "note",
                    "message": "(6) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-pam.c",
                    "line": 1013,
                    "column": 28,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-pam.c",
                    "line": 1019,
                    "column": 24,
                    "event": "note",
                    "message": "(8) calling ‘fake_password’ from ‘sshpam_respond’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-pam.c",
                    "line": 970,
                    "column": 1,
                    "event": "note",
                    "message": "(9) entry to ‘fake_password’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-pam.c",
                    "line": 979,
                    "column": 15,
                    "event": "note",
                    "message": "(10) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-pam.c",
                    "line": 980,
                    "column": 12,
                    "event": "note",
                    "message": "(11) assuming ‘ret’ is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-pam.c",
                    "line": 980,
                    "column": 12,
                    "event": "note",
                    "message": "(12) following ‘false’ branch (when ‘ret’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-pam.c",
                    "line": 1019,
                    "column": 24,
                    "event": "note",
                    "message": "(14) returning to ‘sshpam_respond’ from ‘fake_password’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth-pam.c",
                    "line": 979,
                    "column": 15,
                    "event": "note",
                    "message": "(15) ‘fake_password(*resp)’ leaks here; was allocated at (10)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  977|   \t\tfatal(\"%s: password length too long: %zu\", __func__, l);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  978|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  979|-> \tret = malloc(l + 1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  980|   \tif (ret == NULL)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  981|   \t\treturn NULL;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 476,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/auth2-chall.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘input_userauth_info_response’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/auth2-chall.c",
                    "line": 328,
                    "column": 17,
                    "event": "warning[-Wanalyzer-null-dereference]",
                    "message": "dereference of NULL ‘response’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/auth2-chall.c",
                    "line": 300,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch (when ‘authctxt’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth2-chall.c",
                    "line": 302,
                    "column": 20,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth2-chall.c",
                    "line": 303,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth2-chall.c",
                    "line": 305,
                    "column": 23,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth2-chall.c",
                    "line": 305,
                    "column": 12,
                    "event": "note",
                    "message": "(5) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth2-chall.c",
                    "line": 308,
                    "column": 29,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth2-chall.c",
                    "line": 309,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth2-chall.c",
                    "line": 311,
                    "column": 32,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth2-chall.c",
                    "line": 311,
                    "column": 12,
                    "event": "note",
                    "message": "(9) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth2-chall.c",
                    "line": 313,
                    "column": 12,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth2-chall.c",
                    "line": 313,
                    "column": 12,
                    "event": "note",
                    "message": "(11) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth2-chall.c",
                    "line": 315,
                    "column": 12,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth2-chall.c",
                    "line": 315,
                    "column": 12,
                    "event": "note",
                    "message": "(13) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth2-chall.c",
                    "line": 322,
                    "column": 18,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth2-chall.c",
                    "line": 322,
                    "column": 12,
                    "event": "note",
                    "message": "(15) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth2-chall.c",
                    "line": 325,
                    "column": 25,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth2-chall.c",
                    "line": 327,
                    "column": 23,
                    "event": "note",
                    "message": "(17) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth2-chall.c",
                    "line": 328,
                    "column": 60,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth2-chall.c",
                    "line": 328,
                    "column": 60,
                    "event": "note",
                    "message": "(19) ‘response’ is NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/auth2-chall.c",
                    "line": 328,
                    "column": 17,
                    "event": "note",
                    "message": "(20) dereference of NULL ‘response + (long unsigned int)i * 8’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  326|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  327|   \tfor (i = 0; i < nresp; i++) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  328|-> \t\texplicit_bzero(response[i], strlen(response[i]));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  329|   \t\tfree(response[i]);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  330|   \t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/channels.c",
                    "line": 0,
                    "event": "internal warning",
                    "message": "child 13253 timed out after 30s",
                    "verbosity_level": 0
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 457,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/channels.c",
                    "line": 5060,
                    "event": "warning[uninitvar]",
                    "message": "Uninitialized variable: port",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5058|   \t\t\tbreak;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5059|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5060|-> \tif (display_number >= x11_max_displays || port < X11_PORT_MIN ) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5061|   \t\terror(\"Failed to allocate internet-domain X11 display socket.\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5062|   \t\treturn -1;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 483,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/channels.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘connect_local_xsocket_path’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/channels.c",
                    "line": 5098,
                    "column": 5,
                    "event": "warning[-Wmisleading-indentation]",
                    "message": "this ‘if’ clause does not guard...",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5098 |     if (len <= 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |     ^~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/channels.c",
                    "line": 5100,
                    "column": 9,
                    "event": "note",
                    "message": "...this statement, but the latter is misleadingly indented as if it were guarded by the ‘if’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5100 |         sock = socket(AF_UNIX, SOCK_STREAM, 0);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |         ^~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5096|   \tstruct sockaddr_un addr;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5097|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5098|->     if (len <= 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5099|           return -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5100|   \tsock = socket(AF_UNIX, SOCK_STREAM, 0);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 195,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/channels.c",
                    "line": 5107,
                    "column": 17,
                    "event": "warning[-Wsign-compare]",
                    "message": "comparison of integer expressions of different signedness: ‘int’ and ‘long unsigned int’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5107 |         if (len > sizeof addr.sun_path)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                 ^",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5105|   \tmemset(&addr, 0, sizeof(addr));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5106|   \taddr.sun_family = AF_UNIX;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5107|-> \tif (len > sizeof addr.sun_path)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5108|   \t\tlen = sizeof addr.sun_path;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5109|   \tmemcpy(addr.sun_path, pathname, len);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/cipher.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘cipher_init’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/cipher.c",
                    "line": 239,
                    "column": 32,
                    "event": "warning[-Wcalloc-transposed-args]",
                    "message": "‘calloc’ sizes specified with ‘sizeof’ in the earlier argument and not in the later argument",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  239 |         if ((cc = calloc(sizeof(*cc), 1)) == NULL)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                ^",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/cipher.c",
                    "line": 239,
                    "column": 32,
                    "event": "note",
                    "message": "earlier argument should specify number of elements, later size of each element",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  237|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  238|   \t*ccp = NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  239|-> \tif ((cc = calloc(sizeof(*cc), 1)) == NULL)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  240|   \t\treturn SSH_ERR_ALLOC_FAIL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  241|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/clientloop.c",
                    "line": 2443,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/clientloop.c",
                    "line": 2443,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2441|   \tif (ndone != ctx->nnew)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2442|   \t\tfatal_f(\"ndone != ctx->nnew (%zu / %zu)\", ndone, ctx->nnew);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2443|-> \tif ((r = sshpkt_get_end(ssh)) != 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2444|   \t\terror_f(\"protocol error\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2445|   \t\tgoto out;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 2,
            "events": [
                {
                    "file_name": "openssh-9.6p1/includes.h",
                    "line": 19,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/userauth_pubkey_from_pam.c",
                    "line": 36,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/config.h",
                    "line": 1914,
                    "column": 9,
                    "event": "warning",
                    "message": "\"SUPERUSER_PATH\" redefined",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1914 | #define SUPERUSER_PATH \"/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin\"",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |         ^~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/userauth_pubkey_from_pam.c",
                    "line": 35,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/defines.h",
                    "line": 337,
                    "column": 10,
                    "event": "note",
                    "message": "this is the location of the previous definition",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  337 | # define SUPERUSER_PATH _PATH_STDPATH",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |          ^~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1912|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1913|   /* Define if you want a different $PATH for the superuser */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1914|-> #define SUPERUSER_PATH \"/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin\"",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1915|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1916|   /* syslog_r function is safe to use in in a signal handler */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 563,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 136,
                    "column": 21,
                    "event": "warning[-Wunused-variable]",
                    "message": "unused variable ‘failed’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  136 |         const char *failed;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                     ^~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  134|   passphrase_dialog(char *message, int prompt_type)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  135|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  136|-> \tconst char *failed;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  137|   \tchar *passphrase, *local;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  138|   \tint result, grab_tries, grab_server, grab_pointer;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 477,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘passphrase_dialog’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 184,
                    "column": 17,
                    "event": "warning[-Wdeprecated-declarations]",
                    "message": "‘gtk_widget_modify_fg’ is deprecated: Use 'gtk_widget_override_color' instead",
                    "verbosity_level": 0
                },
                {
                    "file_name": "/usr/include/gtk-3.0/gtk/gtk.h",
                    "line": 277,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 61,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/gtk-3.0/gtk/deprecated/gtkstyle.h",
                    "line": 749,
                    "column": 13,
                    "event": "note",
                    "message": "declared here",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  182|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  183|   \tif (fg_set)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  184|-> \t\tgtk_widget_modify_fg(dialog, GTK_STATE_NORMAL, &fg);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  185|   \tif (bg_set)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  186|   \t\tgtk_widget_modify_bg(dialog, GTK_STATE_NORMAL, &bg);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 477,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 186,
                    "column": 17,
                    "event": "warning[-Wdeprecated-declarations]",
                    "message": "‘gtk_widget_modify_bg’ is deprecated: Use 'gtk_widget_override_background_color' instead",
                    "verbosity_level": 0
                },
                {
                    "file_name": "/usr/include/gtk-3.0/gtk/deprecated/gtkstyle.h",
                    "line": 753,
                    "column": 13,
                    "event": "note",
                    "message": "declared here",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  184|   \t\tgtk_widget_modify_fg(dialog, GTK_STATE_NORMAL, &fg);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  185|   \tif (bg_set)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  186|-> \t\tgtk_widget_modify_bg(dialog, GTK_STATE_NORMAL, &bg);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  187|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  188|   \tif (prompt_type == PROMPT_ENTRY || prompt_type == PROMPT_NONE) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 477,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 191,
                    "column": 25,
                    "event": "warning[-Wdeprecated-declarations]",
                    "message": "‘gtk_widget_modify_fg’ is deprecated: Use 'gtk_widget_override_color' instead",
                    "verbosity_level": 0
                },
                {
                    "file_name": "/usr/include/gtk-3.0/gtk/deprecated/gtkstyle.h",
                    "line": 749,
                    "column": 13,
                    "event": "note",
                    "message": "declared here",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  189|   \t\tentry = gtk_entry_new();",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  190|   \t\tif (fg_set)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  191|-> \t\t\tgtk_widget_modify_fg(entry, GTK_STATE_NORMAL, &fg);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  192|   \t\tif (bg_set)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  193|   \t\t\tgtk_widget_modify_bg(entry, GTK_STATE_NORMAL, &bg);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 477,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 193,
                    "column": 25,
                    "event": "warning[-Wdeprecated-declarations]",
                    "message": "‘gtk_widget_modify_bg’ is deprecated: Use 'gtk_widget_override_background_color' instead",
                    "verbosity_level": 0
                },
                {
                    "file_name": "/usr/include/gtk-3.0/gtk/deprecated/gtkstyle.h",
                    "line": 753,
                    "column": 13,
                    "event": "note",
                    "message": "declared here",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  191|   \t\t\tgtk_widget_modify_fg(entry, GTK_STATE_NORMAL, &fg);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  192|   \t\tif (bg_set)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  193|-> \t\t\tgtk_widget_modify_bg(entry, GTK_STATE_NORMAL, &bg);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  194|   \t\tgtk_box_pack_start(",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  195|   \t\t    GTK_BOX(gtk_dialog_get_content_area(GTK_DIALOG(dialog))),",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 457,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 243,
                    "column": 39,
                    "event": "warning[-Wmaybe-uninitialized]",
                    "message": "‘entry’ may be used uninitialized",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  243 |                 passphrase = g_strdup(gtk_entry_get_text(GTK_ENTRY(entry)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                       ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘main’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 140,
                    "column": 45,
                    "event": "note",
                    "message": "‘entry’ was declared here",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  140 |         GtkWidget *parent_window, *dialog, *entry, *err;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                             ^~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  241|   \t/* Report passphrase if user selected OK */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  242|   \tif (prompt_type == PROMPT_ENTRY) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  243|-> \t\tpassphrase = g_strdup(gtk_entry_get_text(GTK_ENTRY(entry)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  244|   \t\tif (result == GTK_RESPONSE_OK) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  245|   \t\t\tlocal = g_locale_from_utf8(passphrase,",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 688,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 246,
                    "column": 29,
                    "event": "warning[-Wanalyzer-null-argument]",
                    "message": "use of NULL where non-null expected",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 134,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘passphrase_dialog’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 188,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 189,
                    "column": 25,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 242,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following ‘true’ branch (when ‘prompt_type == 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/glib-2.0/glib/gstring.h",
                    "line": 37,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/glib-2.0/glib/giochannel.h",
                    "line": 36,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/glib-2.0/glib.h",
                    "line": 56,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/gtk-3.0/gdk/gdkconfig.h",
                    "line": 8,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/gtk-3.0/gdk/gdk.h",
                    "line": 30,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/gtk-3.0/gtk/gtk.h",
                    "line": 30,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 243,
                    "column": 39,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/glib-2.0/glib/gstrfuncs.h",
                    "line": 324,
                    "column": 38,
                    "event": "note",
                    "message": "in definition of macro ‘g_strdup’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/glib-2.0/glib/gstrfuncs.h",
                    "line": 324,
                    "column": 21,
                    "event": "note",
                    "message": "(6) inlined call to ‘g_strdup_inline’ from ‘passphrase_dialog’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 243,
                    "column": 30,
                    "event": "note",
                    "message": "in expansion of macro ‘g_strdup’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/glib-2.0/glib/gstrfuncs.h",
                    "line": 311,
                    "column": 6,
                    "event": "note",
                    "message": "(7) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘passphrase_dialog’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 244,
                    "column": 20,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 244,
                    "column": 20,
                    "event": "note",
                    "message": "(9) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 246,
                    "column": 29,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 246,
                    "column": 29,
                    "event": "note",
                    "message": "(11) argument 1 (‘<unknown>’) NULL where non-null expected",
                    "verbosity_level": 2
                },
                {
                    "file_name": "<built-in>",
                    "line": 0,
                    "event": "note",
                    "message": "argument 1 of ‘__builtin_strlen’ must be non-null",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  244|   \t\tif (result == GTK_RESPONSE_OK) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  245|   \t\t\tlocal = g_locale_from_utf8(passphrase,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  246|-> \t\t\t    strlen(passphrase), NULL, NULL, NULL);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  247|   \t\t\tif (local != NULL) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  248|   \t\t\t\tputs(local);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 688,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 256,
                    "column": 17,
                    "event": "warning[-Wanalyzer-null-argument]",
                    "message": "use of NULL where non-null expected",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 134,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘passphrase_dialog’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 188,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 189,
                    "column": 25,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 242,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following ‘true’ branch (when ‘prompt_type == 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 243,
                    "column": 39,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/glib-2.0/glib/gstrfuncs.h",
                    "line": 324,
                    "column": 38,
                    "event": "note",
                    "message": "in definition of macro ‘g_strdup’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/glib-2.0/glib/gstrfuncs.h",
                    "line": 324,
                    "column": 21,
                    "event": "note",
                    "message": "(6) inlined call to ‘g_strdup_inline’ from ‘passphrase_dialog’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 243,
                    "column": 30,
                    "event": "note",
                    "message": "in expansion of macro ‘g_strdup’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/glib-2.0/glib/gstrfuncs.h",
                    "line": 311,
                    "column": 6,
                    "event": "note",
                    "message": "(7) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘passphrase_dialog’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 244,
                    "column": 20,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 244,
                    "column": 20,
                    "event": "note",
                    "message": "(9) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 256,
                    "column": 17,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/contrib/gnome-ssh-askpass3.c",
                    "line": 256,
                    "column": 17,
                    "event": "note",
                    "message": "(11) argument 1 (‘<unknown>’) NULL where non-null expected",
                    "verbosity_level": 2
                },
                {
                    "file_name": "<built-in>",
                    "line": 0,
                    "event": "note",
                    "message": "argument 1 of ‘__builtin_strlen’ must be non-null",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  254|   \t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  255|   \t\t/* Zero passphrase in memory */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  256|-> \t\tmemset(passphrase, '\\b', strlen(passphrase));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  257|   \t\tgtk_entry_set_text(GTK_ENTRY(entry), passphrase);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  258|   \t\tmemset(passphrase, '\\0', strlen(passphrase));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/gss-genr.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘ssh_gssapi_kex_mechs’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/gss-genr.c",
                    "line": 172,
                    "column": 30,
                    "event": "warning[-Wstringop-truncation]",
                    "message": "‘strncpy’ output truncated before terminating nul copying as many bytes from a string as its length",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  172 |                         cp = strncpy(s, kex, strlen(kex));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                              ^",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/gss-genr.c",
                    "line": 172,
                    "column": 30,
                    "event": "note",
                    "message": "length computed here",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  172 |                         cp = strncpy(s, kex, strlen(kex));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                              ^~~~~~~~~~~~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  170|   \t\t\t    ssh_digest_bytes(SSH_DIGEST_MD5) * 2);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  171|   #pragma GCC diagnostic ignored \"-Wstringop-overflow\"",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  172|-> \t\t\tcp = strncpy(s, kex, strlen(kex));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  173|   #pragma pop",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  174|   \t\t\tfor ((p = strsep(&cp, \",\")); p && *p != '\\0';",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/gss-serv-krb5.c",
                    "line": 447,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'maj_status' is used in the enclosing expression, the value is never actually read from 'maj_status'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/gss-serv-krb5.c",
                    "line": 447,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'maj_status' is used in the enclosing expression, the value is never actually read from 'maj_status'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  445|   \tkrb5_free_principal(krb_context, princ);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  446|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  447|-> \tif ((maj_status = gss_krb5_copy_ccache(&min_status,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  448|   \t    client->creds, ccache))) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  449|   \t\tlogit(\"gss_krb5_copy_ccache() failed\");",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/gss-serv-krb5.c",
                    "line": 531,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'maj_status' is used in the enclosing expression, the value is never actually read from 'maj_status'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/gss-serv-krb5.c",
                    "line": 531,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'maj_status' is used in the enclosing expression, the value is never actually read from 'maj_status'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  529|   \tkrb5_free_principal(krb_context, principal);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  530|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  531|-> \tif ((maj_status = gss_krb5_copy_ccache(&min_status, client->creds,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  532|   \t    ccache))) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  533|   \t\tlogit(\"gss_krb5_copy_ccache() failed. Sorry!\");",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/hostfile.c",
                    "line": 623,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/hostfile.c",
                    "line": 623,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  621|   \t * Prepare temporary file for in-place deletion.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  622|   \t */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  623|-> \tif ((r = asprintf(&temp, \"%s.XXXXXXXXXXX\", filename)) == -1 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  624|   \t    (r = asprintf(&back, \"%s.old\", filename)) == -1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  625|   \t\tr = SSH_ERR_ALLOC_FAIL;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/hostfile.c",
                    "line": 624,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/hostfile.c",
                    "line": 624,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  622|   \t */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  623|   \tif ((r = asprintf(&temp, \"%s.XXXXXXXXXXX\", filename)) == -1 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  624|-> \t    (r = asprintf(&back, \"%s.old\", filename)) == -1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  625|   \t\tr = SSH_ERR_ALLOC_FAIL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  626|   \t\tgoto fail;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 457,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘kex_derive_keys’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1557,
                    "column": 51,
                    "event": "warning[-Wanalyzer-use-of-uninitialized-value]",
                    "message": "use of uninitialized value ‘keys[<unknown>]’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1526,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘kex_derive_keys’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1530,
                    "column": 17,
                    "event": "note",
                    "message": "(2) region created on stack here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1542,
                    "column": 19,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1546,
                    "column": 23,
                    "event": "note",
                    "message": "(5) following ‘true’ branch (when ‘i != 6’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1547,
                    "column": 26,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1547,
                    "column": 26,
                    "event": "note",
                    "message": "(7) calling ‘derive_key’ from ‘kex_derive_keys’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1460,
                    "column": 1,
                    "event": "note",
                    "message": "(8) entry to ‘derive_key’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1471,
                    "column": 12,
                    "event": "note",
                    "message": "(9) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 61,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/misc.h",
                    "line": 242,
                    "column": 31,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1473,
                    "column": 33,
                    "event": "note",
                    "message": "in expansion of macro ‘ROUNDUP’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1473,
                    "column": 12,
                    "event": "note",
                    "message": "(11) following ‘false’ branch (when ‘digest’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1479,
                    "column": 24,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1479,
                    "column": 12,
                    "event": "note",
                    "message": "(13) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1480,
                    "column": 13,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1479,
                    "column": 65,
                    "event": "note",
                    "message": "(15) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1481,
                    "column": 13,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1480,
                    "column": 67,
                    "event": "note",
                    "message": "(17) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1482,
                    "column": 13,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1481,
                    "column": 60,
                    "event": "note",
                    "message": "(19) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1483,
                    "column": 50,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1482,
                    "column": 52,
                    "event": "note",
                    "message": "(21) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1484,
                    "column": 13,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1483,
                    "column": 69,
                    "event": "note",
                    "message": "(23) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1489,
                    "column": 9,
                    "event": "note",
                    "message": "(24) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1547,
                    "column": 26,
                    "event": "note",
                    "message": "(25) returning to ‘kex_derive_keys’ from ‘derive_key’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1547,
                    "column": 20,
                    "event": "note",
                    "message": "(26) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1546,
                    "column": 33,
                    "event": "note",
                    "message": "(27) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1546,
                    "column": 23,
                    "event": "note",
                    "message": "(28) following ‘false’ branch (when ‘i == 6’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(29) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1554,
                    "column": 29,
                    "event": "note",
                    "message": "(30) following ‘true’ branch (when ‘mode != 2’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1555,
                    "column": 29,
                    "event": "note",
                    "message": "(31) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1555,
                    "column": 38,
                    "event": "note",
                    "message": "(32) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1557,
                    "column": 61,
                    "event": "note",
                    "message": "(33) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1557,
                    "column": 51,
                    "event": "note",
                    "message": "(34) use of uninitialized value ‘keys[<unknown>]’ here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1555|   \t\tctos = (!kex->server && mode == MODE_OUT) ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1556|   \t\t    (kex->server && mode == MODE_IN);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1557|-> \t\tkex->newkeys[mode]->enc.iv  = keys[ctos ? 0 : 1];",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1558|   \t\tkex->newkeys[mode]->enc.key = keys[ctos ? 2 : 3];",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1559|   \t\tkex->newkeys[mode]->mac.key = keys[ctos ? 4 : 5];",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 457,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1558,
                    "column": 51,
                    "event": "warning[-Wanalyzer-use-of-uninitialized-value]",
                    "message": "use of uninitialized value ‘keys[<unknown>]’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1526,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘kex_derive_keys’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1530,
                    "column": 17,
                    "event": "note",
                    "message": "(2) region created on stack here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1542,
                    "column": 19,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1546,
                    "column": 23,
                    "event": "note",
                    "message": "(5) following ‘true’ branch (when ‘i != 6’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1547,
                    "column": 26,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1547,
                    "column": 26,
                    "event": "note",
                    "message": "(7) calling ‘derive_key’ from ‘kex_derive_keys’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1460,
                    "column": 1,
                    "event": "note",
                    "message": "(8) entry to ‘derive_key’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1471,
                    "column": 12,
                    "event": "note",
                    "message": "(9) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.h",
                    "line": 242,
                    "column": 31,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1473,
                    "column": 33,
                    "event": "note",
                    "message": "in expansion of macro ‘ROUNDUP’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1473,
                    "column": 12,
                    "event": "note",
                    "message": "(11) following ‘false’ branch (when ‘digest’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1479,
                    "column": 24,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1479,
                    "column": 12,
                    "event": "note",
                    "message": "(13) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1480,
                    "column": 13,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1479,
                    "column": 65,
                    "event": "note",
                    "message": "(15) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1481,
                    "column": 13,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1480,
                    "column": 67,
                    "event": "note",
                    "message": "(17) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1482,
                    "column": 13,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1481,
                    "column": 60,
                    "event": "note",
                    "message": "(19) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1483,
                    "column": 50,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1482,
                    "column": 52,
                    "event": "note",
                    "message": "(21) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1484,
                    "column": 13,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1483,
                    "column": 69,
                    "event": "note",
                    "message": "(23) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1489,
                    "column": 9,
                    "event": "note",
                    "message": "(24) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1547,
                    "column": 26,
                    "event": "note",
                    "message": "(25) returning to ‘kex_derive_keys’ from ‘derive_key’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1547,
                    "column": 20,
                    "event": "note",
                    "message": "(26) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1546,
                    "column": 33,
                    "event": "note",
                    "message": "(27) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1546,
                    "column": 23,
                    "event": "note",
                    "message": "(28) following ‘false’ branch (when ‘i == 6’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(29) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1554,
                    "column": 29,
                    "event": "note",
                    "message": "(30) following ‘true’ branch (when ‘mode != 2’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1555,
                    "column": 29,
                    "event": "note",
                    "message": "(31) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1555,
                    "column": 59,
                    "event": "note",
                    "message": "(32) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1556,
                    "column": 34,
                    "event": "note",
                    "message": "(33) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1556,
                    "column": 34,
                    "event": "note",
                    "message": "(34) following ‘true’ branch (when ‘mode == 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(35) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1558,
                    "column": 61,
                    "event": "note",
                    "message": "(36) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1558,
                    "column": 29,
                    "event": "note",
                    "message": "(37) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kex.c",
                    "line": 1558,
                    "column": 51,
                    "event": "note",
                    "message": "(38) use of uninitialized value ‘keys[<unknown>]’ here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1556|   \t\t    (kex->server && mode == MODE_IN);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1557|   \t\tkex->newkeys[mode]->enc.iv  = keys[ctos ? 0 : 1];",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1558|-> \t\tkex->newkeys[mode]->enc.key = keys[ctos ? 2 : 3];",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1559|   \t\tkex->newkeys[mode]->mac.key = keys[ctos ? 4 : 5];",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1560|   \t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 563,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/kexdh.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘kex_dh_compute_key’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/kexdh.c",
                    "line": 95,
                    "column": 13,
                    "event": "warning[-Wunused-variable]",
                    "message": "unused variable ‘kout’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   95 |         int kout, r = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |             ^~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   93|   \tu_char *kbuf = NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   94|   \tsize_t klen = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   95|-> \tint kout, r = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   96|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   97|   #ifdef DEBUG_KEXDH",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/kexecdh.c",
                    "line": 273,
                    "column": 2,
                    "event": "warning[core.CallAndMessage]",
                    "message": "2nd function call argument is an uninitialized value",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/kexecdh.c",
                    "line": 284,
                    "column": 6,
                    "event": "note",
                    "message": "Calling 'kex_ecdh_dec_key_group'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kexecdh.c",
                    "line": 180,
                    "column": 19,
                    "event": "note",
                    "message": "'publen' declared without an initial value",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kexecdh.c",
                    "line": 185,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kexecdh.c",
                    "line": 185,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kexecdh.c",
                    "line": 187,
                    "column": 3,
                    "event": "note",
                    "message": "Control jumps to line 266",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kexecdh.c",
                    "line": 273,
                    "column": 2,
                    "event": "note",
                    "message": "2nd function call argument is an uninitialized value",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  271|   \tBN_clear_free(shared_secret);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  272|   \tfreezero(kbuf, klen);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  273|-> \tfreezero(pub, publen);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  274|   \tsshbuf_free(buf);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  275|   \treturn r;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 457,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/kexecdh.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘kex_ecdh_dec_key_group’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/kexecdh.c",
                    "line": 273,
                    "column": 9,
                    "event": "warning[-Wanalyzer-use-of-uninitialized-value]",
                    "message": "use of uninitialized value ‘publen’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/kexecdh.c",
                    "line": 180,
                    "column": 26,
                    "event": "note",
                    "message": "(1) region created on stack here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kexecdh.c",
                    "line": 180,
                    "column": 26,
                    "event": "note",
                    "message": "(2) capacity: 8 bytes",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/kexecdh.c",
                    "line": 273,
                    "column": 9,
                    "event": "note",
                    "message": "(3) use of uninitialized value ‘publen’ here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  271|   \tBN_clear_free(shared_secret);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  272|   \tfreezero(kbuf, klen);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  273|-> \tfreezero(pub, publen);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  274|   \tsshbuf_free(buf);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  275|   \treturn r;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/kexgssc.c",
                    "line": 214,
                    "column": 10,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/kexgssc.c",
                    "line": 214,
                    "column": 10,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  212|   \t\t\t\t\t\tsshpkt_disconnect(ssh, \"Protocol error: did not receive final token\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  213|   \t\t\t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  214|-> \t\t\t\tif ((r = sshpkt_get_end(ssh)) != 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  215|   \t\t\t\t\tfatal(\"Expecting end of packet.\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  216|   \t\t\t\t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/kexgssc.c",
                    "line": 283,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/kexgssc.c",
                    "line": 283,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  281|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  282|   \thashlen = sizeof(hash);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  283|-> \tif ((r = kex_gen_hash(",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  284|   \t    kex->hash_alg,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  285|   \t    kex->client_version,",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/krl.c",
                    "line": 0,
                    "event": "internal warning",
                    "message": "child 12764 timed out after 30s",
                    "verbosity_level": 0
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/log.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘do_log’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/log.c",
                    "line": 402,
                    "column": 53,
                    "event": "warning[-Wformat-truncation=]",
                    "message": "‘: ’ directive output may be truncated writing 2 bytes into a region of size between 1 and 1024",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  402 |                 snprintf(fmtbuf, sizeof(fmtbuf), \"%s: %s\", msgbuf, suffix);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                                     ^~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/bits/stdio2.h",
                    "line": 68,
                    "column": 10,
                    "event": "note",
                    "message": "‘__snprintf_chk’ output 3 or more bytes (assuming 1026) into a destination of size 1024",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   68 |   return __builtin___snprintf_chk (__s, __n, __USE_FORTIFY_LEVEL - 1,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |          ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   69 |                                    __glibc_objsize (__s), __fmt,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   70 |                                    __va_arg_pack ());",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                    ~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  400|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  401|   \tif (suffix != NULL) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  402|-> \t\tsnprintf(fmtbuf, sizeof(fmtbuf), \"%s: %s\", msgbuf, suffix);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  403|   \t\tstrlcpy(msgbuf, fmtbuf, sizeof(msgbuf));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  404|   \t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/log.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘do_log’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/log.c",
                    "line": 414,
                    "column": 58,
                    "event": "warning",
                    "message": "‘\r",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   ’ directive output may be truncated writing 2 bytes into a region of size between 1 and 1024 [-Wformat-truncation=]",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  414 |                 snprintf(msgbuf, sizeof msgbuf, \"%s%s%.*s\\r\\n\",",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                                          ^~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/bits/stdio2.h",
                    "line": 68,
                    "column": 10,
                    "event": "note",
                    "message": "‘__snprintf_chk’ output between 3 and 1026 bytes into a destination of size 1024",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   68 |   return __builtin___snprintf_chk (__s, __n, __USE_FORTIFY_LEVEL - 1,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |          ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   69 |                                    __glibc_objsize (__s), __fmt,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   70 |                                    __va_arg_pack ());",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                    ~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  412|   \t\tlog_handler = tmp_handler;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  413|   \t} else if (log_on_stderr) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  414|-> \t\tsnprintf(msgbuf, sizeof msgbuf, \"%s%s%.*s\\r\\n\",",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  415|   \t\t    (log_on_stderr > 1) ? progname : \"\",",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  416|   \t\t    (log_on_stderr > 1) ? \": \" : \"\",",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/match.c",
                    "line": 253,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'p' is used in the enclosing expression, the value is never actually read from 'p'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/match.c",
                    "line": 253,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'p' is used in the enclosing expression, the value is never actually read from 'p'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  251|   \t\treturn 0; /* shouldn't happen */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  252|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  253|-> \tif ((p = strchr(pattern, '@')) == NULL)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  254|   \t\treturn match_pattern(user, pattern);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  255|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 457,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/match.c",
                    "line": 295,
                    "event": "warning[uninitvar]",
                    "message": "Uninitialized variable: sproposals",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  293|   \t    (p = strsep(&cp, SEP)), i++) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  294|   \t\tfor (j = 0; j < nproposals; j++) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  295|-> \t\t\tif (strcmp(p, sproposals[j]) == 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  296|   \t\t\t\tret = xstrdup(p);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  297|   \t\t\t\tif (next != NULL)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/match.c",
                    "line": 307,
                    "column": 11,
                    "event": "warning[core.NonNullParamChecker]",
                    "message": "Null pointer passed to 1st parameter expecting 'nonnull'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/match.c",
                    "line": 280,
                    "column": 2,
                    "event": "note",
                    "message": "The value of 'cp' is assigned to 'c'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/match.c",
                    "line": 283,
                    "column": 36,
                    "event": "note",
                    "message": "Assuming 'p' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/match.c",
                    "line": 283,
                    "column": 38,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/match.c",
                    "line": 292,
                    "column": 36,
                    "event": "note",
                    "message": "Assuming 'p' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/match.c",
                    "line": 292,
                    "column": 38,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/match.c",
                    "line": 306,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'next' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/match.c",
                    "line": 306,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/match.c",
                    "line": 307,
                    "column": 11,
                    "event": "note",
                    "message": "Null pointer passed to 1st parameter expecting 'nonnull'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  305|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  306|   \tif (next != NULL)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  307|-> \t\t*next = strlen(c);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  308|   \tfree(c);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  309|   \tfree(s);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘fmt_timeframe’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 677,
                    "column": 40,
                    "event": "warning[-Wformat-truncation=]",
                    "message": "‘%02llu’ directive output may be truncated writing between 2 and 14 bytes into a region of size 9",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  677 |                 snprintf(buf, TF_LEN, \"%02lluw%01ud%02uh\", week, day, hrs);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                        ^~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 677,
                    "column": 39,
                    "event": "note",
                    "message": "directive argument in the range [1, 30500568904943]",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  677 |                 snprintf(buf, TF_LEN, \"%02lluw%01ud%02uh\", week, day, hrs);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                       ^~~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 677,
                    "column": 39,
                    "event": "note",
                    "message": "directive argument in the range [0, 6]",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 677,
                    "column": 39,
                    "event": "note",
                    "message": "directive argument in the range [0, 23]",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/bits/stdio2.h",
                    "line": 68,
                    "column": 10,
                    "event": "note",
                    "message": "‘__snprintf_chk’ output between 9 and 21 bytes into a destination of size 9",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   68 |   return __builtin___snprintf_chk (__s, __n, __USE_FORTIFY_LEVEL - 1,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |          ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   69 |                                    __glibc_objsize (__s), __fmt,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   70 |                                    __va_arg_pack ());",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                    ~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  675|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  676|   \tif (week > 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  677|-> \t\tsnprintf(buf, TF_LEN, \"%02lluw%01ud%02uh\", week, day, hrs);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  678|   \telse if (day > 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  679|   \t\tsnprintf(buf, TF_LEN, \"%01ud%02uh%02um\", day, hrs, min);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1296,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'i' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1296,
                    "column": 7,
                    "event": "note",
                    "message": "Value stored to 'i' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1294|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1295|   \t/* Expand string */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1296|-> \tfor (i = 0; *string != '\\0'; string++) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1297|   \t\t/* Optionally process ${ENVIRONMENT} expansions. */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1298|   \t\tif (dollar && string[0] == '$' && string[1] == '{') {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sanitise_stdfd’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1516,
                    "column": 28,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(open(\"/dev/null\", 2), dupfd)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1508,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1513,
                    "column": 24,
                    "event": "note",
                    "message": "(3) following ‘true’ branch (when ‘dupfd <= 2’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1515,
                    "column": 21,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1515,
                    "column": 20,
                    "event": "note",
                    "message": "(5) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1516,
                    "column": 29,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1516,
                    "column": 29,
                    "event": "note",
                    "message": "(7) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1516,
                    "column": 28,
                    "event": "note",
                    "message": "(8) ‘dup2(open(\"/dev/null\", 2), dupfd)’ leaks here; was opened at (7)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1514|   \t\t/* Only populate closed fds. */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1515|   \t\tif (fcntl(dupfd, F_GETFL) == -1 && errno == EBADF) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1516|-> \t\t\tif (dup2(nullfd, dupfd) == -1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1517|   \t\t\t\tfprintf(stderr, \"dup2: %s\\n\", strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1518|   \t\t\t\texit(1);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1516,
                    "column": 28,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘open(\"/dev/null\", 2)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1508,
                    "column": 31,
                    "event": "note",
                    "message": "(1) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1508,
                    "column": 12,
                    "event": "note",
                    "message": "(2) assuming ‘open(\"/dev/null\", 2)’ is a valid file descriptor (>= 0)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1508,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1513,
                    "column": 24,
                    "event": "note",
                    "message": "(5) following ‘true’ branch (when ‘dupfd <= 2’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1515,
                    "column": 21,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1513,
                    "column": 24,
                    "event": "note",
                    "message": "(7) following ‘true’ branch (when ‘dupfd <= 2’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1515,
                    "column": 21,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1516,
                    "column": 28,
                    "event": "note",
                    "message": "(9) ‘open(\"/dev/null\", 2)’ leaks here; was opened at (1)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1514|   \t\t/* Only populate closed fds. */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1515|   \t\tif (fcntl(dupfd, F_GETFL) == -1 && errno == EBADF) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1516|-> \t\t\tif (dup2(nullfd, dupfd) == -1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1517|   \t\t\t\tfprintf(stderr, \"dup2: %s\\n\", strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1518|   \t\t\t\texit(1);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1522,
                    "column": 12,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘open(\"/dev/null\", 2)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1508,
                    "column": 31,
                    "event": "note",
                    "message": "(1) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1508,
                    "column": 12,
                    "event": "note",
                    "message": "(2) assuming ‘open(\"/dev/null\", 2)’ is a valid file descriptor (>= 0)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1508,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1513,
                    "column": 24,
                    "event": "note",
                    "message": "(5) following ‘true’ branch (when ‘dupfd <= 2’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1515,
                    "column": 21,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1522,
                    "column": 12,
                    "event": "note",
                    "message": "(7) ‘open(\"/dev/null\", 2)’ leaks here; was opened at (1)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1520|   \t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1521|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1522|-> \tif (nullfd > STDERR_FILENO)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1523|   \t\tclose(nullfd);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1524|   \t/* coverity[leaked_handle : FALSE]*/",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1526,
                    "column": 1,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dupfd’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1508,
                    "column": 31,
                    "event": "note",
                    "message": "(1) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1508,
                    "column": 12,
                    "event": "note",
                    "message": "(2) assuming ‘open(\"/dev/null\", 2)’ is a valid file descriptor (>= 0)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1508,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1513,
                    "column": 24,
                    "event": "note",
                    "message": "(5) following ‘false’ branch (when ‘dupfd > 2’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1522,
                    "column": 12,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1522,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 1526,
                    "column": 1,
                    "event": "note",
                    "message": "(8) ...to here (9) ‘dupfd’ leaks here; was opened at (1)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1524|   \t/* coverity[leaked_handle : FALSE]*/",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1525|   \t/* coverity[leaked_handle : FALSE]*/",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1526|-> }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1527|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1528|   char *",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2113,
                    "column": 4,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'r' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2113,
                    "column": 4,
                    "event": "note",
                    "message": "Value stored to 'r' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2111|   \t\tsshbuf_reset(arg);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2112|   \t\tfor (j = 0; argv[i][j] != '\\0'; j++) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2113|-> \t\t\tr = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2114|   \t\t\tc = argv[i][j];",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2115|   \t\t\tswitch (c) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘stdfd_devnull’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2687,
                    "column": 23,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(open(\"/dev/null\", 2), 0)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2682,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2687,
                    "column": 12,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2687,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘true’ branch (when ‘do_stdin != 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2687,
                    "column": 26,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2687,
                    "column": 26,
                    "event": "note",
                    "message": "(5) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2687,
                    "column": 23,
                    "event": "note",
                    "message": "(6) ‘dup2(open(\"/dev/null\", 2), 0)’ leaks here; was opened at (5)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2685|   \t\treturn -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2686|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2687|-> \tif ((do_stdin && dup2(devnull, STDIN_FILENO) == -1) ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2688|   \t    (do_stdout && dup2(devnull, STDOUT_FILENO) == -1) ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2689|   \t    (do_stderr && dup2(devnull, STDERR_FILENO) == -1)) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2688,
                    "column": 24,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(open(\"/dev/null\", 2), 1)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2682,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2687,
                    "column": 12,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2687,
                    "column": 61,
                    "event": "note",
                    "message": "(3) following ‘true’ branch (when ‘do_stdout != 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2688,
                    "column": 27,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2688,
                    "column": 27,
                    "event": "note",
                    "message": "(5) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2688,
                    "column": 24,
                    "event": "note",
                    "message": "(6) ‘dup2(open(\"/dev/null\", 2), 1)’ leaks here; was opened at (5)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2686|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2687|   \tif ((do_stdin && dup2(devnull, STDIN_FILENO) == -1) ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2688|-> \t    (do_stdout && dup2(devnull, STDOUT_FILENO) == -1) ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2689|   \t    (do_stderr && dup2(devnull, STDERR_FILENO) == -1)) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2690|   \t\terror_f(\"dup2: %s\", strerror(errno));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2689,
                    "column": 24,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(open(\"/dev/null\", 2), 2)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2682,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2687,
                    "column": 12,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2688,
                    "column": 63,
                    "event": "note",
                    "message": "(3) following ‘true’ branch (when ‘do_stderr != 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2689,
                    "column": 27,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2689,
                    "column": 27,
                    "event": "note",
                    "message": "(5) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2689,
                    "column": 24,
                    "event": "note",
                    "message": "(6) ‘dup2(open(\"/dev/null\", 2), 2)’ leaks here; was opened at (5)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2687|   \tif ((do_stdin && dup2(devnull, STDIN_FILENO) == -1) ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2688|   \t    (do_stdout && dup2(devnull, STDOUT_FILENO) == -1) ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2689|-> \t    (do_stderr && dup2(devnull, STDERR_FILENO) == -1)) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2690|   \t\terror_f(\"dup2: %s\", strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2691|   \t\tret = -1;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2693,
                    "column": 12,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘open(\"/dev/null\", 2)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2682,
                    "column": 24,
                    "event": "note",
                    "message": "(1) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2682,
                    "column": 12,
                    "event": "note",
                    "message": "(2) assuming ‘open(\"/dev/null\", 2)’ is a valid file descriptor (>= 0)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2682,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2687,
                    "column": 12,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2693,
                    "column": 12,
                    "event": "note",
                    "message": "(5) ‘open(\"/dev/null\", 2)’ leaks here; was opened at (1)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2691|   \t\tret = -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2692|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2693|-> \tif (devnull > STDERR_FILENO)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2694|   \t\tclose(devnull);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2695|   \t/* coverity[leaked_handle : FALSE]*/",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘subprocess’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2725,
                    "column": 24,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of ‘f’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2738,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2743,
                    "column": 21,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2743,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2752,
                    "column": 14,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2752,
                    "column": 12,
                    "event": "note",
                    "message": "(5) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2756,
                    "column": 12,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2758,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2763,
                    "column": 20,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2769,
                    "column": 13,
                    "event": "note",
                    "message": "(9) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2769,
                    "column": 12,
                    "event": "note",
                    "message": "(10) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2776,
                    "column": 12,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2779,
                    "column": 9,
                    "event": "note",
                    "message": "(12) following ‘default:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2863,
                    "column": 9,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2864,
                    "column": 12,
                    "event": "note",
                    "message": "(14) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2866,
                    "column": 23,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2866,
                    "column": 23,
                    "event": "note",
                    "message": "(16) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2866,
                    "column": 17,
                    "event": "note",
                    "message": "(17) assuming ‘f’ is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2866,
                    "column": 17,
                    "event": "note",
                    "message": "(18) following ‘false’ branch (when ‘f’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 74,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 101,
                    "column": 33,
                    "event": "note",
                    "message": "(19) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2876,
                    "column": 9,
                    "event": "note",
                    "message": "in expansion of macro ‘debug3_f’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2877,
                    "column": 12,
                    "event": "note",
                    "message": "(20) following ‘false’ branch (when ‘child’ is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(21) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2725,
                    "column": 24,
                    "event": "note",
                    "message": "(22) ‘f’ leaks here; was allocated at (16)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2723|   \tif (drop_privs != NULL && (pw == NULL || restore_privs == NULL)) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2724|   \t\terror(\"%s: inconsistent arguments\", tag); /* XXX fatal? */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2725|-> \t\treturn 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2726|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2727|   \tif (pw == NULL && (pw = getpwuid(getuid())) == NULL) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2806,
                    "column": 20,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(open(\"/dev/null\", 2), 0)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2709,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘subprocess’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2738,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2743,
                    "column": 21,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2743,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2752,
                    "column": 14,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2752,
                    "column": 12,
                    "event": "note",
                    "message": "(6) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2756,
                    "column": 12,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2758,
                    "column": 12,
                    "event": "note",
                    "message": "(8) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2763,
                    "column": 20,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2769,
                    "column": 13,
                    "event": "note",
                    "message": "(10) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2769,
                    "column": 12,
                    "event": "note",
                    "message": "(11) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2776,
                    "column": 12,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2779,
                    "column": 9,
                    "event": "note",
                    "message": "(13) following ‘case 0:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2785,
                    "column": 9,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2787,
                    "column": 20,
                    "event": "note",
                    "message": "(15) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2798,
                    "column": 31,
                    "event": "note",
                    "message": "(17) following ‘true’ branch (when ‘i != 65’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2799,
                    "column": 25,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2799,
                    "column": 25,
                    "event": "note",
                    "message": "(19) calling ‘ssh_signal’ from ‘subprocess’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2658,
                    "column": 1,
                    "event": "note",
                    "message": "(20) entry to ‘ssh_signal’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2667,
                    "column": 12,
                    "event": "note",
                    "message": "(21) following ‘true’ branch (when ‘signum != 14’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2668,
                    "column": 29,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2799,
                    "column": 25,
                    "event": "note",
                    "message": "(23) returning to ‘subprocess’ from ‘ssh_signal’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2801,
                    "column": 20,
                    "event": "note",
                    "message": "(24) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2806,
                    "column": 21,
                    "event": "note",
                    "message": "(25) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2806,
                    "column": 21,
                    "event": "note",
                    "message": "(26) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2806,
                    "column": 20,
                    "event": "note",
                    "message": "(27) ‘dup2(open(\"/dev/null\", 2), 0)’ leaks here; was opened at (26)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2804|   \t\t\t_exit(1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2805|   \t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2806|-> \t\tif (dup2(devnull, STDIN_FILENO) == -1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2807|   \t\t\terror(\"%s: dup2: %s\", tag, strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2808|   \t\t\t_exit(1);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2806,
                    "column": 20,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘open(\"/dev/null\", 2)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2709,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘subprocess’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2738,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2743,
                    "column": 21,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2743,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2752,
                    "column": 14,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2752,
                    "column": 12,
                    "event": "note",
                    "message": "(6) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2756,
                    "column": 12,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2758,
                    "column": 12,
                    "event": "note",
                    "message": "(8) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2763,
                    "column": 20,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2769,
                    "column": 13,
                    "event": "note",
                    "message": "(10) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2769,
                    "column": 12,
                    "event": "note",
                    "message": "(11) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2776,
                    "column": 12,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2779,
                    "column": 9,
                    "event": "note",
                    "message": "(13) following ‘case 0:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2785,
                    "column": 9,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2787,
                    "column": 20,
                    "event": "note",
                    "message": "(15) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2798,
                    "column": 31,
                    "event": "note",
                    "message": "(17) following ‘true’ branch (when ‘i != 65’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2799,
                    "column": 25,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2799,
                    "column": 25,
                    "event": "note",
                    "message": "(19) calling ‘ssh_signal’ from ‘subprocess’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2658,
                    "column": 1,
                    "event": "note",
                    "message": "(20) entry to ‘ssh_signal’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2667,
                    "column": 12,
                    "event": "note",
                    "message": "(21) following ‘true’ branch (when ‘signum != 14’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2668,
                    "column": 29,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2799,
                    "column": 25,
                    "event": "note",
                    "message": "(23) returning to ‘subprocess’ from ‘ssh_signal’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2801,
                    "column": 32,
                    "event": "note",
                    "message": "(24) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2801,
                    "column": 20,
                    "event": "note",
                    "message": "(25) assuming ‘open(\"/dev/null\", 2)’ is a valid file descriptor (>= 0)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2801,
                    "column": 20,
                    "event": "note",
                    "message": "(26) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2806,
                    "column": 21,
                    "event": "note",
                    "message": "(27) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2806,
                    "column": 20,
                    "event": "note",
                    "message": "(28) ‘open(\"/dev/null\", 2)’ leaks here; was opened at (24)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2804|   \t\t\t_exit(1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2805|   \t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2806|-> \t\tif (dup2(devnull, STDIN_FILENO) == -1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2807|   \t\t\terror(\"%s: dup2: %s\", tag, strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2808|   \t\t\t_exit(1);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2813,
                    "column": 20,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘open(\"/dev/null\", 2)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2709,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘subprocess’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2738,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2743,
                    "column": 21,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2743,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2752,
                    "column": 14,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2752,
                    "column": 12,
                    "event": "note",
                    "message": "(6) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2756,
                    "column": 12,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2758,
                    "column": 12,
                    "event": "note",
                    "message": "(8) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2763,
                    "column": 20,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2769,
                    "column": 13,
                    "event": "note",
                    "message": "(10) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2769,
                    "column": 12,
                    "event": "note",
                    "message": "(11) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2776,
                    "column": 12,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2779,
                    "column": 9,
                    "event": "note",
                    "message": "(13) following ‘case 0:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2785,
                    "column": 9,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2787,
                    "column": 20,
                    "event": "note",
                    "message": "(15) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2798,
                    "column": 31,
                    "event": "note",
                    "message": "(17) following ‘true’ branch (when ‘i != 65’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2799,
                    "column": 25,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2799,
                    "column": 25,
                    "event": "note",
                    "message": "(19) calling ‘ssh_signal’ from ‘subprocess’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2658,
                    "column": 1,
                    "event": "note",
                    "message": "(20) entry to ‘ssh_signal’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2667,
                    "column": 12,
                    "event": "note",
                    "message": "(21) following ‘true’ branch (when ‘signum != 14’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2668,
                    "column": 29,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2799,
                    "column": 25,
                    "event": "note",
                    "message": "(23) returning to ‘subprocess’ from ‘ssh_signal’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2801,
                    "column": 32,
                    "event": "note",
                    "message": "(24) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2801,
                    "column": 20,
                    "event": "note",
                    "message": "(25) assuming ‘open(\"/dev/null\", 2)’ is a valid file descriptor (>= 0)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2801,
                    "column": 20,
                    "event": "note",
                    "message": "(26) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2806,
                    "column": 21,
                    "event": "note",
                    "message": "(27) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2806,
                    "column": 20,
                    "event": "note",
                    "message": "(28) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2813,
                    "column": 20,
                    "event": "note",
                    "message": "(29) ...to here (30) ‘open(\"/dev/null\", 2)’ leaks here; was opened at (24)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2811|   \t\t/* Set up stdout as requested; leave stderr in place for now. */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2812|   \t\tfd = -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2813|-> \t\tif ((flags & SSH_SUBPROCESS_STDOUT_CAPTURE) != 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2814|   \t\t\tfd = p[1];",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2815|   \t\telse if ((flags & SSH_SUBPROCESS_STDOUT_DISCARD) != 0)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2815,
                    "column": 33,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘open(\"/dev/null\", 2)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2709,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘subprocess’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2738,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2743,
                    "column": 21,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2743,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2752,
                    "column": 14,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2752,
                    "column": 12,
                    "event": "note",
                    "message": "(6) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2756,
                    "column": 12,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2758,
                    "column": 12,
                    "event": "note",
                    "message": "(8) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2763,
                    "column": 20,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2769,
                    "column": 13,
                    "event": "note",
                    "message": "(10) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2769,
                    "column": 12,
                    "event": "note",
                    "message": "(11) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2776,
                    "column": 12,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2779,
                    "column": 9,
                    "event": "note",
                    "message": "(13) following ‘case 0:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2785,
                    "column": 9,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2787,
                    "column": 20,
                    "event": "note",
                    "message": "(15) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2798,
                    "column": 31,
                    "event": "note",
                    "message": "(17) following ‘true’ branch (when ‘i != 65’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2799,
                    "column": 25,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2799,
                    "column": 25,
                    "event": "note",
                    "message": "(19) calling ‘ssh_signal’ from ‘subprocess’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2658,
                    "column": 1,
                    "event": "note",
                    "message": "(20) entry to ‘ssh_signal’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2667,
                    "column": 12,
                    "event": "note",
                    "message": "(21) following ‘true’ branch (when ‘signum != 14’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2668,
                    "column": 29,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2799,
                    "column": 25,
                    "event": "note",
                    "message": "(23) returning to ‘subprocess’ from ‘ssh_signal’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2801,
                    "column": 32,
                    "event": "note",
                    "message": "(24) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2801,
                    "column": 20,
                    "event": "note",
                    "message": "(25) assuming ‘open(\"/dev/null\", 2)’ is a valid file descriptor (>= 0)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2801,
                    "column": 20,
                    "event": "note",
                    "message": "(26) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2806,
                    "column": 21,
                    "event": "note",
                    "message": "(27) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2806,
                    "column": 20,
                    "event": "note",
                    "message": "(28) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2813,
                    "column": 20,
                    "event": "note",
                    "message": "(29) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2813,
                    "column": 20,
                    "event": "note",
                    "message": "(30) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2815,
                    "column": 33,
                    "event": "note",
                    "message": "(31) ...to here (32) ‘open(\"/dev/null\", 2)’ leaks here; was opened at (24)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2813|   \t\tif ((flags & SSH_SUBPROCESS_STDOUT_CAPTURE) != 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2814|   \t\t\tfd = p[1];",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2815|-> \t\telse if ((flags & SSH_SUBPROCESS_STDOUT_DISCARD) != 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2816|   \t\t\tfd = devnull;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2817|   \t\tif (fd != -1 && dup2(fd, STDOUT_FILENO) == -1) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2817,
                    "column": 30,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(fd, 1)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2709,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘subprocess’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2738,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2743,
                    "column": 21,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2743,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2752,
                    "column": 14,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2752,
                    "column": 12,
                    "event": "note",
                    "message": "(6) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2756,
                    "column": 12,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2758,
                    "column": 12,
                    "event": "note",
                    "message": "(8) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2763,
                    "column": 20,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2769,
                    "column": 13,
                    "event": "note",
                    "message": "(10) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2769,
                    "column": 12,
                    "event": "note",
                    "message": "(11) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2776,
                    "column": 12,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2779,
                    "column": 9,
                    "event": "note",
                    "message": "(13) following ‘case 0:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2785,
                    "column": 9,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2787,
                    "column": 20,
                    "event": "note",
                    "message": "(15) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2798,
                    "column": 31,
                    "event": "note",
                    "message": "(17) following ‘true’ branch (when ‘i != 65’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2799,
                    "column": 25,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2799,
                    "column": 25,
                    "event": "note",
                    "message": "(19) calling ‘ssh_signal’ from ‘subprocess’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2658,
                    "column": 1,
                    "event": "note",
                    "message": "(20) entry to ‘ssh_signal’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2667,
                    "column": 12,
                    "event": "note",
                    "message": "(21) following ‘true’ branch (when ‘signum != 14’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2668,
                    "column": 29,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2799,
                    "column": 25,
                    "event": "note",
                    "message": "(23) returning to ‘subprocess’ from ‘ssh_signal’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2801,
                    "column": 20,
                    "event": "note",
                    "message": "(24) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2806,
                    "column": 21,
                    "event": "note",
                    "message": "(25) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2806,
                    "column": 20,
                    "event": "note",
                    "message": "(26) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2813,
                    "column": 20,
                    "event": "note",
                    "message": "(27) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2813,
                    "column": 20,
                    "event": "note",
                    "message": "(28) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2814,
                    "column": 28,
                    "event": "note",
                    "message": "(29) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2817,
                    "column": 20,
                    "event": "note",
                    "message": "(30) following ‘true’ branch (when ‘fd != -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2817,
                    "column": 33,
                    "event": "note",
                    "message": "(31) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2817,
                    "column": 33,
                    "event": "note",
                    "message": "(32) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2817,
                    "column": 30,
                    "event": "note",
                    "message": "(33) ‘dup2(fd, 1)’ leaks here; was opened at (32)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2815|   \t\telse if ((flags & SSH_SUBPROCESS_STDOUT_DISCARD) != 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2816|   \t\t\tfd = devnull;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2817|-> \t\tif (fd != -1 && dup2(fd, STDOUT_FILENO) == -1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2818|   \t\t\terror(\"%s: dup2: %s\", tag, strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2819|   \t\t\t_exit(1);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2840,
                    "column": 66,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(0, 2)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2709,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘subprocess’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2738,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2743,
                    "column": 21,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2743,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2752,
                    "column": 14,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2752,
                    "column": 12,
                    "event": "note",
                    "message": "(6) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2756,
                    "column": 12,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2758,
                    "column": 12,
                    "event": "note",
                    "message": "(8) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2763,
                    "column": 20,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2769,
                    "column": 13,
                    "event": "note",
                    "message": "(10) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2769,
                    "column": 12,
                    "event": "note",
                    "message": "(11) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2776,
                    "column": 12,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2779,
                    "column": 9,
                    "event": "note",
                    "message": "(13) following ‘case 0:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2785,
                    "column": 9,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2787,
                    "column": 20,
                    "event": "note",
                    "message": "(15) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2798,
                    "column": 31,
                    "event": "note",
                    "message": "(17) following ‘true’ branch (when ‘i != 65’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2799,
                    "column": 25,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2799,
                    "column": 25,
                    "event": "note",
                    "message": "(19) calling ‘ssh_signal’ from ‘subprocess’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2658,
                    "column": 1,
                    "event": "note",
                    "message": "(20) entry to ‘ssh_signal’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2667,
                    "column": 12,
                    "event": "note",
                    "message": "(21) following ‘true’ branch (when ‘signum != 14’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2668,
                    "column": 29,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2799,
                    "column": 25,
                    "event": "note",
                    "message": "(23) returning to ‘subprocess’ from ‘ssh_signal’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2801,
                    "column": 20,
                    "event": "note",
                    "message": "(24) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2806,
                    "column": 21,
                    "event": "note",
                    "message": "(25) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2806,
                    "column": 20,
                    "event": "note",
                    "message": "(26) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2813,
                    "column": 20,
                    "event": "note",
                    "message": "(27) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2829,
                    "column": 20,
                    "event": "note",
                    "message": "(28) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2834,
                    "column": 21,
                    "event": "note",
                    "message": "(29) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2834,
                    "column": 20,
                    "event": "note",
                    "message": "(30) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2840,
                    "column": 28,
                    "event": "note",
                    "message": "(31) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2840,
                    "column": 20,
                    "event": "note",
                    "message": "(32) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2841,
                    "column": 21,
                    "event": "note",
                    "message": "(33) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2841,
                    "column": 21,
                    "event": "note",
                    "message": "(34) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/misc.c",
                    "line": 2840,
                    "column": 66,
                    "event": "note",
                    "message": "(35) ‘dup2(0, 2)’ leaks here; was opened at (34)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2838|   \t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2839|   \t\t/* stdin is pointed to /dev/null at this point */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2840|-> \t\tif ((flags & SSH_SUBPROCESS_STDOUT_DISCARD) != 0 &&",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2841|   \t\t    dup2(STDIN_FILENO, STDERR_FILENO) == -1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2842|   \t\t\terror(\"%s: dup2: %s\", tag, strerror(errno));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 9001,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-keycat.c",
                    "line": 57,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/misc.h",
                    "line": 148,
                    "column": 5,
                    "event": "warning[-Wattributes]",
                    "message": "‘bounded’ attribute directive ignored",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  148 |     __attribute__((__bounded__( __minbytes__, 1, 8)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |     ^~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  146|   /* Functions to extract or store big-endian words of various sizes */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  147|   u_int64_t\tget_u64(const void *)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  148|->     __attribute__((__bounded__( __minbytes__, 1, 8)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  149|   u_int32_t\tget_u32(const void *)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  150|       __attribute__((__bounded__( __minbytes__, 1, 4)));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 9001,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.h",
                    "line": 150,
                    "column": 5,
                    "event": "warning[-Wattributes]",
                    "message": "‘bounded’ attribute directive ignored",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  150 |     __attribute__((__bounded__( __minbytes__, 1, 4)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |     ^~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  148|       __attribute__((__bounded__( __minbytes__, 1, 8)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  149|   u_int32_t\tget_u32(const void *)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  150|->     __attribute__((__bounded__( __minbytes__, 1, 4)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  151|   u_int16_t\tget_u16(const void *)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  152|       __attribute__((__bounded__( __minbytes__, 1, 2)));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 9001,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.h",
                    "line": 152,
                    "column": 5,
                    "event": "warning[-Wattributes]",
                    "message": "‘bounded’ attribute directive ignored",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  152 |     __attribute__((__bounded__( __minbytes__, 1, 2)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |     ^~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  150|       __attribute__((__bounded__( __minbytes__, 1, 4)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  151|   u_int16_t\tget_u16(const void *)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  152|->     __attribute__((__bounded__( __minbytes__, 1, 2)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  153|   void\t\tput_u64(void *, u_int64_t)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  154|       __attribute__((__bounded__( __minbytes__, 1, 8)));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 9001,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.h",
                    "line": 154,
                    "column": 5,
                    "event": "warning[-Wattributes]",
                    "message": "‘bounded’ attribute directive ignored",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  154 |     __attribute__((__bounded__( __minbytes__, 1, 8)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |     ^~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  152|       __attribute__((__bounded__( __minbytes__, 1, 2)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  153|   void\t\tput_u64(void *, u_int64_t)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  154|->     __attribute__((__bounded__( __minbytes__, 1, 8)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  155|   void\t\tput_u32(void *, u_int32_t)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  156|       __attribute__((__bounded__( __minbytes__, 1, 4)));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 9001,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.h",
                    "line": 156,
                    "column": 5,
                    "event": "warning[-Wattributes]",
                    "message": "‘bounded’ attribute directive ignored",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  156 |     __attribute__((__bounded__( __minbytes__, 1, 4)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |     ^~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  154|       __attribute__((__bounded__( __minbytes__, 1, 8)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  155|   void\t\tput_u32(void *, u_int32_t)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  156|->     __attribute__((__bounded__( __minbytes__, 1, 4)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  157|   void\t\tput_u16(void *, u_int16_t)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  158|       __attribute__((__bounded__( __minbytes__, 1, 2)));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 9001,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.h",
                    "line": 158,
                    "column": 5,
                    "event": "warning[-Wattributes]",
                    "message": "‘bounded’ attribute directive ignored",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  158 |     __attribute__((__bounded__( __minbytes__, 1, 2)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |     ^~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  156|       __attribute__((__bounded__( __minbytes__, 1, 4)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  157|   void\t\tput_u16(void *, u_int16_t)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  158|->     __attribute__((__bounded__( __minbytes__, 1, 2)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  159|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  160|   /* Little-endian store/load, used by umac.c */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 9001,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.h",
                    "line": 162,
                    "column": 5,
                    "event": "warning[-Wattributes]",
                    "message": "‘bounded’ attribute directive ignored",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  162 |     __attribute__((__bounded__(__minbytes__, 1, 4)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |     ^~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  160|   /* Little-endian store/load, used by umac.c */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  161|   u_int32_t\tget_u32_le(const void *)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  162|->     __attribute__((__bounded__(__minbytes__, 1, 4)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  163|   void\t\tput_u32_le(void *, u_int32_t)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  164|       __attribute__((__bounded__(__minbytes__, 1, 4)));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 9001,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/misc.h",
                    "line": 164,
                    "column": 5,
                    "event": "warning[-Wattributes]",
                    "message": "‘bounded’ attribute directive ignored",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  164 |     __attribute__((__bounded__(__minbytes__, 1, 4)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |     ^~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  162|       __attribute__((__bounded__(__minbytes__, 1, 4)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  163|   void\t\tput_u32_le(void *, u_int32_t)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  164|->     __attribute__((__bounded__(__minbytes__, 1, 4)));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  165|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  166|   struct bwlimit {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 704,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘mm_answer_sign’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 727,
                    "column": 39,
                    "event": "warning[-Wdiscarded-qualifiers]",
                    "message": "assignment discards ‘const’ qualifier from pointer target type",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  725|   \t\tif (ssh->compat & SSH_RH_RSASIGSHA && strcmp(alg, \"ssh-rsa\") == 0",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  726|   \t\t\t\t&& (sshkey_type_plain(key->type) == KEY_RSA)) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  727|-> \t\t\teffective_alg = safe_rsa;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  728|   \t\t} else {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  729|   \t\t\teffective_alg = alg;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 704,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 738,
                    "column": 39,
                    "event": "warning[-Wdiscarded-qualifiers]",
                    "message": "assignment discards ‘const’ qualifier from pointer target type",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  736|   \t\tif (ssh->compat & SSH_RH_RSASIGSHA && strcmp(alg, \"ssh-rsa\") == 0",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  737|   \t\t\t\t&& (sshkey_type_plain(key->type) == KEY_RSA)) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  738|-> \t\t\teffective_alg = safe_rsa;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  739|   \t\t} else {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  740|   \t\t\teffective_alg = alg;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 195,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘mm_answer_keyverify’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1506,
                    "column": 18,
                    "event": "warning[-Wsign-compare]",
                    "message": "comparison of integer expressions of different signedness: ‘int’ and ‘u_int’ {aka ‘unsigned int’}",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1506 |         if (type != key_blobtype)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                  ^~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1504|   \t  !monitor_allowed_key(blob, bloblen))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1505|   \t\tfatal_f(\"bad key, not previously allowed\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1506|-> \tif (type != key_blobtype)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1507|   \t\tfatal_f(\"bad key type\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1508|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘mm_answer_pty’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1676,
                    "column": 12,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(*<unknown>.ttyfd, 0)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1661,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1663,
                    "column": 21,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1667,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1669,
                    "column": 30,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1671,
                    "column": 12,
                    "event": "note",
                    "message": "(5) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1672,
                    "column": 18,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1671,
                    "column": 45,
                    "event": "note",
                    "message": "(7) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1676,
                    "column": 13,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1676,
                    "column": 13,
                    "event": "note",
                    "message": "(9) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1676,
                    "column": 12,
                    "event": "note",
                    "message": "(10) ‘dup2(*<unknown>.ttyfd, 0)’ leaks here; was opened at (9)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1674|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1675|   \t/* We need to trick ttyslot */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1676|-> \tif (dup2(s->ttyfd, 0) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1677|   \t\tfatal_f(\"dup2\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1678|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1698,
                    "column": 12,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘open(\"/dev/null\", 0)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1661,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1663,
                    "column": 21,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1667,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1669,
                    "column": 30,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1671,
                    "column": 12,
                    "event": "note",
                    "message": "(5) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1672,
                    "column": 18,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1671,
                    "column": 45,
                    "event": "note",
                    "message": "(7) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1676,
                    "column": 13,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1676,
                    "column": 12,
                    "event": "note",
                    "message": "(9) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1679,
                    "column": 41,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1685,
                    "column": 12,
                    "event": "note",
                    "message": "(11) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1687,
                    "column": 9,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1691,
                    "column": 12,
                    "event": "note",
                    "message": "(13) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1692,
                    "column": 13,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1691,
                    "column": 46,
                    "event": "note",
                    "message": "(15) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1696,
                    "column": 20,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1696,
                    "column": 20,
                    "event": "note",
                    "message": "(17) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1696,
                    "column": 12,
                    "event": "note",
                    "message": "(18) assuming ‘open(\"/dev/null\", 0)’ is a valid file descriptor (>= 0)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1696,
                    "column": 12,
                    "event": "note",
                    "message": "(19) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor.c",
                    "line": 1698,
                    "column": 12,
                    "event": "note",
                    "message": "(20) ...to here (21) ‘open(\"/dev/null\", 0)’ leaks here; was opened at (17)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1696|   \tif ((fd0 = open(_PATH_DEVNULL, O_RDONLY)) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1697|   \t\tfatal_f(\"open(/dev/null): %s\", strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1698|-> \tif (fd0 != 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1699|   \t\terror_f(\"fd0 %d != 0\", fd0);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1700|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/monitor_wrap.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘mm_pty_allocate’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/monitor_wrap.c",
                    "line": 618,
                    "column": 24,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘tmp1’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/monitor_wrap.c",
                    "line": 613,
                    "column": 21,
                    "event": "note",
                    "message": "(1) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor_wrap.c",
                    "line": 613,
                    "column": 12,
                    "event": "note",
                    "message": "(2) assuming ‘tmp1’ is a valid file descriptor (>= 0)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor_wrap.c",
                    "line": 613,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘false’ branch (when ‘tmp1 != -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor_wrap.c",
                    "line": 614,
                    "column": 33,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor_wrap.c",
                    "line": 613,
                    "column": 52,
                    "event": "note",
                    "message": "(5) following ‘true’ branch (when ‘tmp2 == -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor_wrap.c",
                    "line": 62,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 106,
                    "column": 33,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor_wrap.c",
                    "line": 615,
                    "column": 17,
                    "event": "note",
                    "message": "in expansion of macro ‘error_f’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/monitor_wrap.c",
                    "line": 616,
                    "column": 20,
                    "event": "note",
                    "message": "(7) following ‘false’ branch (when ‘tmp1 < 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/monitor_wrap.c",
                    "line": 618,
                    "column": 24,
                    "event": "note",
                    "message": "(8) ...to here (9) ‘tmp1’ leaks here; was opened at (1)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  616|   \t\tif (tmp1 >= 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  617|   \t\t\tclose(tmp1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  618|-> \t\treturn 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  619|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  620|   \tclose(tmp1);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 349,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 349,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  347|   \tcctx->env = NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  348|   \tenv_len = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  349|-> \tif ((r = sshbuf_skip_string(m)) != 0 || /* reserved */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  350|   \t    (r = sshbuf_get_u32(m, &cctx->want_tty)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  351|   \t    (r = sshbuf_get_u32(m, &cctx->want_x_fwd)) != 0 ||",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 350,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 350,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  348|   \tenv_len = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  349|   \tif ((r = sshbuf_skip_string(m)) != 0 || /* reserved */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  350|-> \t    (r = sshbuf_get_u32(m, &cctx->want_tty)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  351|   \t    (r = sshbuf_get_u32(m, &cctx->want_x_fwd)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  352|   \t    (r = sshbuf_get_u32(m, &cctx->want_agent_fwd)) != 0 ||",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 351,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 351,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  349|   \tif ((r = sshbuf_skip_string(m)) != 0 || /* reserved */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  350|   \t    (r = sshbuf_get_u32(m, &cctx->want_tty)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  351|-> \t    (r = sshbuf_get_u32(m, &cctx->want_x_fwd)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  352|   \t    (r = sshbuf_get_u32(m, &cctx->want_agent_fwd)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  353|   \t    (r = sshbuf_get_u32(m, &cctx->want_subsys)) != 0 ||",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 352,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 352,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  350|   \t    (r = sshbuf_get_u32(m, &cctx->want_tty)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  351|   \t    (r = sshbuf_get_u32(m, &cctx->want_x_fwd)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  352|-> \t    (r = sshbuf_get_u32(m, &cctx->want_agent_fwd)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  353|   \t    (r = sshbuf_get_u32(m, &cctx->want_subsys)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  354|   \t    (r = sshbuf_get_u32(m, &escape_char)) != 0 ||",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 353,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 353,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  351|   \t    (r = sshbuf_get_u32(m, &cctx->want_x_fwd)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  352|   \t    (r = sshbuf_get_u32(m, &cctx->want_agent_fwd)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  353|-> \t    (r = sshbuf_get_u32(m, &cctx->want_subsys)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  354|   \t    (r = sshbuf_get_u32(m, &escape_char)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  355|   \t    (r = sshbuf_get_cstring(m, &cctx->term, NULL)) != 0 ||",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 354,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 354,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  352|   \t    (r = sshbuf_get_u32(m, &cctx->want_agent_fwd)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  353|   \t    (r = sshbuf_get_u32(m, &cctx->want_subsys)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  354|-> \t    (r = sshbuf_get_u32(m, &escape_char)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  355|   \t    (r = sshbuf_get_cstring(m, &cctx->term, NULL)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  356|   \t    (r = sshbuf_get_cstring(m, &cmd, NULL)) != 0) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 355,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 355,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  353|   \t    (r = sshbuf_get_u32(m, &cctx->want_subsys)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  354|   \t    (r = sshbuf_get_u32(m, &escape_char)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  355|-> \t    (r = sshbuf_get_cstring(m, &cctx->term, NULL)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  356|   \t    (r = sshbuf_get_cstring(m, &cmd, NULL)) != 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  357|    malf:",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 356,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 356,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  354|   \t    (r = sshbuf_get_u32(m, &escape_char)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  355|   \t    (r = sshbuf_get_cstring(m, &cctx->term, NULL)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  356|-> \t    (r = sshbuf_get_cstring(m, &cmd, NULL)) != 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  357|    malf:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  358|   \t\tfree(cmd);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 370,
                    "column": 8,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 370,
                    "column": 8,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  368|   #define MUX_MAX_ENV_VARS\t4096",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  369|   \twhile (sshbuf_len(m) > 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  370|-> \t\tif ((r = sshbuf_get_cstring(m, &cp, NULL)) != 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  371|   \t\t\tgoto malf;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  372|   \t\tif (!env_permitted(cp)) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 696,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 696,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  694|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  695|   \t/* XXX - lport/cport check redundant */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  696|-> \tif ((r = sshbuf_get_u32(m, &ftype)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  697|   \t    (r = sshbuf_get_cstring(m, &listen_addr, NULL)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  698|   \t    (r = sshbuf_get_u32(m, &lport)) != 0 ||",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 697,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 697,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  695|   \t/* XXX - lport/cport check redundant */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  696|   \tif ((r = sshbuf_get_u32(m, &ftype)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  697|-> \t    (r = sshbuf_get_cstring(m, &listen_addr, NULL)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  698|   \t    (r = sshbuf_get_u32(m, &lport)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  699|   \t    (r = sshbuf_get_cstring(m, &connect_addr, NULL)) != 0 ||",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 698,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 698,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  696|   \tif ((r = sshbuf_get_u32(m, &ftype)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  697|   \t    (r = sshbuf_get_cstring(m, &listen_addr, NULL)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  698|-> \t    (r = sshbuf_get_u32(m, &lport)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  699|   \t    (r = sshbuf_get_cstring(m, &connect_addr, NULL)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  700|   \t    (r = sshbuf_get_u32(m, &cport)) != 0 ||",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 699,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 699,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  697|   \t    (r = sshbuf_get_cstring(m, &listen_addr, NULL)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  698|   \t    (r = sshbuf_get_u32(m, &lport)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  699|-> \t    (r = sshbuf_get_cstring(m, &connect_addr, NULL)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  700|   \t    (r = sshbuf_get_u32(m, &cport)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  701|   \t    (lport != (u_int)PORT_STREAMLOCAL && lport > 65535) ||",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 700,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 700,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  698|   \t    (r = sshbuf_get_u32(m, &lport)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  699|   \t    (r = sshbuf_get_cstring(m, &connect_addr, NULL)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  700|-> \t    (r = sshbuf_get_u32(m, &cport)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  701|   \t    (lport != (u_int)PORT_STREAMLOCAL && lport > 65535) ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  702|   \t    (cport != (u_int)PORT_STREAMLOCAL && cport > 65535)) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 861,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 861,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  859|   \tmemset(&fwd, 0, sizeof(fwd));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  860|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  861|-> \tif ((r = sshbuf_get_u32(m, &ftype)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  862|   \t    (r = sshbuf_get_cstring(m, &listen_addr, NULL)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  863|   \t    (r = sshbuf_get_u32(m, &lport)) != 0 ||",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 862,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 862,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  860|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  861|   \tif ((r = sshbuf_get_u32(m, &ftype)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  862|-> \t    (r = sshbuf_get_cstring(m, &listen_addr, NULL)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  863|   \t    (r = sshbuf_get_u32(m, &lport)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  864|   \t    (r = sshbuf_get_cstring(m, &connect_addr, NULL)) != 0 ||",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 863,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 863,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  861|   \tif ((r = sshbuf_get_u32(m, &ftype)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  862|   \t    (r = sshbuf_get_cstring(m, &listen_addr, NULL)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  863|-> \t    (r = sshbuf_get_u32(m, &lport)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  864|   \t    (r = sshbuf_get_cstring(m, &connect_addr, NULL)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  865|   \t    (r = sshbuf_get_u32(m, &cport)) != 0 ||",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 864,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 864,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  862|   \t    (r = sshbuf_get_cstring(m, &listen_addr, NULL)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  863|   \t    (r = sshbuf_get_u32(m, &lport)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  864|-> \t    (r = sshbuf_get_cstring(m, &connect_addr, NULL)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  865|   \t    (r = sshbuf_get_u32(m, &cport)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  866|   \t    (lport != (u_int)PORT_STREAMLOCAL && lport > 65535) ||",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 865,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 865,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  863|   \t    (r = sshbuf_get_u32(m, &lport)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  864|   \t    (r = sshbuf_get_cstring(m, &connect_addr, NULL)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  865|-> \t    (r = sshbuf_get_u32(m, &cport)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  866|   \t    (lport != (u_int)PORT_STREAMLOCAL && lport > 65535) ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  867|   \t    (cport != (u_int)PORT_STREAMLOCAL && cport > 65535)) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 969,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 969,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  967|   \tstruct mux_stdio_confirm_ctx *cctx;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  968|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  969|-> \tif ((r = sshbuf_skip_string(m)) != 0 || /* reserved */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  970|   \t    (r = sshbuf_get_cstring(m, &chost, NULL)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  971|   \t    (r = sshbuf_get_u32(m, &_cport)) != 0) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 970,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 970,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  968|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  969|   \tif ((r = sshbuf_skip_string(m)) != 0 || /* reserved */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  970|-> \t    (r = sshbuf_get_cstring(m, &chost, NULL)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  971|   \t    (r = sshbuf_get_u32(m, &_cport)) != 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  972|   \t\tfree(chost);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 971,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 971,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  969|   \tif ((r = sshbuf_skip_string(m)) != 0 || /* reserved */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  970|   \t    (r = sshbuf_get_cstring(m, &chost, NULL)) != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  971|-> \t    (r = sshbuf_get_u32(m, &_cport)) != 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  972|   \t\tfree(chost);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  973|   \t\terror_f(\"malformed message\");",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 1180,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 1180,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1178|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1179|   \t/* Channel code ensures that we receive whole packets */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1180|-> \tif ((r = sshbuf_froms(c->input, &in)) != 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1181|    malf:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1182|   \t\terror_f(\"malformed message\");",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 1186,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 1186,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1184|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1185|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1186|-> \tif ((r = sshbuf_get_u32(in, &type)) != 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1187|   \t\tgoto malf;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1188|   \tdebug3_f(\"channel %d packet type 0x%08x len %zu\", c->self,",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 1199,
                    "column": 8,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/mux.c",
                    "line": 1199,
                    "column": 8,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1197|   \t\t\tgoto out;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1198|   \t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1199|-> \t\tif ((r = sshbuf_get_u32(in, &rid)) != 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1200|   \t\t\tgoto malf;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1201|   \t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 270,
                    "column": 51,
                    "event": "warning[core.uninitialized.Assign]",
                    "message": "Assigned value is garbage or undefined",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 191,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 191,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 195,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 195,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 202,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 202,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 205,
                    "column": 13,
                    "event": "note",
                    "message": "Field 'gl_offs' is < SSIZE_MAX",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 205,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 205,
                    "column": 44,
                    "event": "note",
                    "message": "Field 'gl_pathc' is < SSIZE_MAX",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 205,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 205,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 211,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 211,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 216,
                    "column": 10,
                    "event": "note",
                    "message": "'bufnext' is < 'bufend'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 216,
                    "column": 10,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 216,
                    "column": 30,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 216,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 226",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 228,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 228,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 229,
                    "column": 10,
                    "event": "note",
                    "message": "Calling 'globexp1'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 245,
                    "column": 27,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 248,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 248,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 249,
                    "column": 10,
                    "event": "note",
                    "message": "Calling 'globexp2'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 270,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 270,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 270,
                    "column": 51,
                    "event": "note",
                    "message": "Assigned value is garbage or undefined",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  268|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  269|   \t/* copy part up to the brace */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  270|-> \tfor (lm = patbuf, pm = pattern; pm != ptr; *lm++ = *pm++)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  271|   \t\t;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  272|   \t*lm = EOS;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 520,
                    "column": 19,
                    "event": "warning[core.UndefinedBinaryOperatorResult]",
                    "message": "The left operand of '==' is a garbage value",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 191,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 191,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 202,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 202,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 205,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'gl_offs' is < SSIZE_MAX",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 205,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 205,
                    "column": 37,
                    "event": "note",
                    "message": "Assuming field 'gl_pathc' is < SSIZE_MAX",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 205,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 206,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 205,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 211,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 211,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 212,
                    "column": 10,
                    "event": "note",
                    "message": "'bufnext' is < 'bufend'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 212,
                    "column": 10,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 212,
                    "column": 30,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 212,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 212,
                    "column": 10,
                    "event": "note",
                    "message": "'bufnext' is < 'bufend'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 212,
                    "column": 10,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 212,
                    "column": 30,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 212,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 226",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 228,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 228,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 231,
                    "column": 10,
                    "event": "note",
                    "message": "Calling 'glob0'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 482,
                    "column": 13,
                    "event": "note",
                    "message": "Calling 'globtilde'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 373,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 373,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 373,
                    "column": 27,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 373,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 379,
                    "column": 6,
                    "event": "note",
                    "message": "'h' is < 'eb'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 379,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 379,
                    "column": 27,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 389,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 397,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 397,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 397,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 398,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 398,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 414,
                    "column": 19,
                    "event": "note",
                    "message": "'b' is < 'eb'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 414,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 414,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 414,
                    "column": 19,
                    "event": "note",
                    "message": "'b' is < 'eb'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 414,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 414,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 414,
                    "column": 19,
                    "event": "note",
                    "message": "'b' is < 'eb'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 414,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 414,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 418",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 418,
                    "column": 9,
                    "event": "note",
                    "message": "'b' is < 'eb'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 418,
                    "column": 9,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 418,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 420",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 482,
                    "column": 13,
                    "event": "note",
                    "message": "Returning from 'globtilde'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 487,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 488,
                    "column": 3,
                    "event": "note",
                    "message": "Control jumps to 'case 91:'  at line 489",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 491,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 491,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 493,
                    "column": 8,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 494,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 493,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 501,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 505,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 505,
                    "column": 23,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 520,
                    "column": 28,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 504,
                    "column": 4,
                    "event": "note",
                    "message": "Loop condition is true. Execution continues on line 505",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 505,
                    "column": 23,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 520,
                    "column": 28,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 504,
                    "column": 4,
                    "event": "note",
                    "message": "Loop condition is true. Execution continues on line 505",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 505,
                    "column": 23,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 520,
                    "column": 19,
                    "event": "note",
                    "message": "The left operand of '==' is a garbage value",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  518|   \t\t\t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  519|   \t\t\t\t*bufnext++ = CHAR(c);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  520|-> \t\t\t\tif (*qpatnext == RANGE &&",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  521|   \t\t\t\t    (c = qpatnext[1]) != RBRACKET) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  522|   \t\t\t\t\t*bufnext++ = M_RNG;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘globextend’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 835,
                    "column": 23,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of ‘pathv’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 810,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 813,
                    "column": 47,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 813,
                    "column": 47,
                    "event": "note",
                    "message": "(3) following ‘false’ branch (when ‘newn <= 2305843009213693950’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 830,
                    "column": 35,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 830,
                    "column": 17,
                    "event": "note",
                    "message": "(5) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 831,
                    "column": 12,
                    "event": "note",
                    "message": "(6) assuming ‘pathv’ is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 831,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘false’ branch (when ‘pathv’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 833,
                    "column": 18,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 833,
                    "column": 12,
                    "event": "note",
                    "message": "(9) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 835,
                    "column": 23,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 836,
                    "column": 44,
                    "event": "note",
                    "message": "(11) following ‘true’ branch (when ‘i != 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 837,
                    "column": 34,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 843,
                    "column": 20,
                    "event": "note",
                    "message": "(13) following ‘false’ branch (when ‘statv’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 845,
                    "column": 26,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 835,
                    "column": 23,
                    "event": "note",
                    "message": "(15) ‘pathv’ leaks here; was allocated at (5)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  833|   \tif (pglob->gl_pathv == NULL && pglob->gl_offs > 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  834|   \t\t/* first time around -- clear initial gl_offs items */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  835|-> \t\tpathv += pglob->gl_offs;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  836|   \t\tfor (i = pglob->gl_offs; i > 0; i--)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  837|   \t\t\t*--pathv = NULL;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 847,
                    "column": 31,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of ‘statv’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 810,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 813,
                    "column": 47,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 813,
                    "column": 47,
                    "event": "note",
                    "message": "(3) following ‘false’ branch (when ‘newn <= 2305843009213693950’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 830,
                    "column": 35,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 831,
                    "column": 12,
                    "event": "note",
                    "message": "(5) following ‘false’ branch (when ‘pathv’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 833,
                    "column": 18,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 841,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 842,
                    "column": 43,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 842,
                    "column": 25,
                    "event": "note",
                    "message": "(9) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 843,
                    "column": 20,
                    "event": "note",
                    "message": "(10) assuming ‘statv’ is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 843,
                    "column": 20,
                    "event": "note",
                    "message": "(11) following ‘false’ branch (when ‘statv’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 845,
                    "column": 26,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 845,
                    "column": 20,
                    "event": "note",
                    "message": "(13) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 847,
                    "column": 31,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 848,
                    "column": 52,
                    "event": "note",
                    "message": "(15) following ‘true’ branch (when ‘i != 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 849,
                    "column": 42,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 852,
                    "column": 20,
                    "event": "note",
                    "message": "(17) following ‘false’ branch (when ‘sb’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 855,
                    "column": 31,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 856,
                    "column": 28,
                    "event": "note",
                    "message": "(19) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/includes.h",
                    "line": 154,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 61,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 858,
                    "column": 33,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/glob.c",
                    "line": 847,
                    "column": 31,
                    "event": "note",
                    "message": "(21) ‘statv’ leaks here; was allocated at (9)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  845|   \t\tif (pglob->gl_statv == NULL && pglob->gl_offs > 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  846|   \t\t\t/* first time around -- clear initial gl_offs items */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  847|-> \t\t\tstatv += pglob->gl_offs;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  848|   \t\t\tfor (i = pglob->gl_offs; i > 0; i--)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  849|   \t\t\t\t*--statv = NULL;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 477,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 68,
                    "column": 1,
                    "event": "warning[-Wdeprecated-declarations]",
                    "message": "‘security_context_t’ is deprecated",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   66|   /* Send audit message */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   67|   static int",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   68|-> sshd_selinux_send_audit_message(int success, security_context_t default_context,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   69|   \t\t       security_context_t selected_context)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   70|   {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 477,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 69,
                    "column": 24,
                    "event": "warning[-Wdeprecated-declarations]",
                    "message": "‘security_context_t’ is deprecated",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   67|   static int",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   68|   sshd_selinux_send_audit_message(int success, security_context_t default_context,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   69|-> \t\t       security_context_t selected_context)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   70|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   71|   \tint rc=0;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 477,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 115,
                    "column": 1,
                    "event": "warning[-Wdeprecated-declarations]",
                    "message": "‘security_context_t’ is deprecated",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  113|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  114|   static int",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  115|-> mls_range_allowed(security_context_t src, security_context_t dst)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  116|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  117|   \tstruct av_decision avd;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 477,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 142,
                    "column": 9,
                    "event": "warning[-Wdeprecated-declarations]",
                    "message": "‘security_context_t’ is deprecated",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  140|   static int",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  141|   get_user_context(const char *sename, const char *role, const char *lvl,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  142|-> \tsecurity_context_t *sc) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  143|   #ifdef HAVE_GET_DEFAULT_CONTEXT_WITH_LEVEL",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  144|   \tif (lvl == NULL || lvl[0] == '\\0' || get_default_context_with_level(sename, lvl, NULL, sc) != 0) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 477,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘get_user_context’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 180,
                    "column": 17,
                    "event": "warning[-Wdeprecated-declarations]",
                    "message": "‘security_context_t’ is deprecated",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  178|   \t\t/* verify that the requested range is obtained */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  179|   \t\tcontext_t con;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  180|-> \t\tsecurity_context_t obtained_raw;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  181|   \t\tsecurity_context_t requested_raw;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  182|   \t\tcon = context_new(*sc);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 477,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 181,
                    "column": 17,
                    "event": "warning[-Wdeprecated-declarations]",
                    "message": "‘security_context_t’ is deprecated",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  179|   \t\tcontext_t con;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  180|   \t\tsecurity_context_t obtained_raw;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  181|-> \t\tsecurity_context_t requested_raw;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  182|   \t\tcon = context_new(*sc);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  183|   \t\tif (!con) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 217,
                    "column": 2,
                    "event": "warning[unix.Malloc]",
                    "message": "Potential memory leak",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 391,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 394,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'use_pam' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 394,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 412,
                    "column": 6,
                    "event": "note",
                    "message": "Calling 'sshd_selinux_getctxbyname'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 252,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 252,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 261,
                    "column": 6,
                    "event": "note",
                    "message": "'r' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 261,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 269,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'r' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 269,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 271,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'inetd' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 271,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 289,
                    "column": 8,
                    "event": "note",
                    "message": "'reqlvl' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 289,
                    "column": 8,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 289,
                    "column": 26,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 289,
                    "column": 37,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 290,
                    "column": 8,
                    "event": "note",
                    "message": "Calling 'get_user_context'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 144,
                    "column": 6,
                    "event": "note",
                    "message": "'lvl' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 144,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 144,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 144,
                    "column": 39,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 144,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 156,
                    "column": 6,
                    "event": "note",
                    "message": "'role' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 156,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 156,
                    "column": 22,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 156,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 159,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 159,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 165,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'con' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 165,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 171,
                    "column": 9,
                    "event": "note",
                    "message": "Memory is allocated",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 173,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 173,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 177,
                    "column": 6,
                    "event": "note",
                    "message": "'lvl' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 177,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 177,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 183,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'con' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 183,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 184,
                    "column": 4,
                    "event": "note",
                    "message": "Control jumps to line 215",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 217,
                    "column": 2,
                    "event": "note",
                    "message": "Potential memory leak",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  215|   \tfreecon(*sc);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  216|   \t*sc = NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  217|-> \treturn -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  218|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  219|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 477,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "At top level",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 240,
                    "column": 1,
                    "event": "warning[-Wdeprecated-declarations]",
                    "message": "‘security_context_t’ is deprecated",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  238|   /* Return the default security context for the given username */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  239|   static int",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  240|-> sshd_selinux_getctxbyname(char *pwname, security_context_t *default_sc,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  241|       security_context_t *user_sc, int inetd, Authctxt *the_authctxt)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  242|   {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 477,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 241,
                    "column": 5,
                    "event": "warning[-Wdeprecated-declarations]",
                    "message": "‘security_context_t’ is deprecated",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  239|   static int",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  240|   sshd_selinux_getctxbyname(char *pwname, security_context_t *default_sc,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  241|->     security_context_t *user_sc, int inetd, Authctxt *the_authctxt)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  242|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  243|   \tchar *sename, *lvl;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 477,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sshd_selinux_getctxbyname’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 272,
                    "column": 25,
                    "event": "warning[-Wdeprecated-declarations]",
                    "message": "‘security_context_t’ is deprecated",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  270|   \t\t/* If launched from xinetd, we must use current level */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  271|   \t\tif (inetd) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  272|-> \t\t\tsecurity_context_t sshdsc=NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  273|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  274|   \t\t\tif (getcon_raw(&sshdsc) < 0)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 477,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 293,
                    "column": 33,
                    "event": "warning[-Wdeprecated-declarations]",
                    "message": "‘security_context_t’ is deprecated",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  291|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  292|   \t\t\tif (r == 0 && reqlvl != NULL && reqlvl[0]) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  293|-> \t\t\t\tsecurity_context_t default_level_sc = *default_sc;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  294|   \t\t\t\tif (role != NULL && role[0]) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  295|   \t\t\t\t\tif (get_user_context(sename, role, lvl, &default_level_sc) < 0)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 299,
                    "column": 9,
                    "event": "warning[unix.Malloc]",
                    "message": "Potential leak of memory pointed to by 'default_level_sc'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 391,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 394,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'use_pam' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 394,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 412,
                    "column": 6,
                    "event": "note",
                    "message": "Calling 'sshd_selinux_getctxbyname'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 252,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 252,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 261,
                    "column": 6,
                    "event": "note",
                    "message": "'r' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 261,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 269,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'r' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 269,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 271,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'inetd' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 271,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 289,
                    "column": 8,
                    "event": "note",
                    "message": "'reqlvl' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 289,
                    "column": 8,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 289,
                    "column": 26,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 289,
                    "column": 37,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 292,
                    "column": 8,
                    "event": "note",
                    "message": "'r' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 292,
                    "column": 8,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 292,
                    "column": 18,
                    "event": "note",
                    "message": "'reqlvl' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 292,
                    "column": 8,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 292,
                    "column": 4,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 294,
                    "column": 9,
                    "event": "note",
                    "message": "'role' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 294,
                    "column": 9,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 294,
                    "column": 5,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 295,
                    "column": 10,
                    "event": "note",
                    "message": "Calling 'get_user_context'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 144,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'lvl' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 144,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 144,
                    "column": 21,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 144,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 144,
                    "column": 39,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 144,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 156,
                    "column": 6,
                    "event": "note",
                    "message": "'role' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 156,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 156,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 159,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 159,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 165,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'con' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 165,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 173,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 173,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 177,
                    "column": 6,
                    "event": "note",
                    "message": "'lvl' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 177,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 177,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 183,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'con' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 183,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 187,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 187,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 191,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 191,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 199,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 199,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 204,
                    "column": 10,
                    "event": "note",
                    "message": "Memory is allocated",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 295,
                    "column": 10,
                    "event": "note",
                    "message": "Returned allocated memory via 4th parameter",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 295,
                    "column": 6,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 299,
                    "column": 9,
                    "event": "note",
                    "message": "Potential leak of memory pointed to by 'default_level_sc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  297|   \t\t\t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  298|   \t\t\t\t/* verify that the requested range is contained in the user range */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  299|-> \t\t\t\tif (mls_range_allowed(default_level_sc, *user_sc)) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  300|   \t\t\t\t\tlogit(\"permit MLS level %s (user range %s)\", reqlvl, lvl);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  301|   \t\t\t\t} else {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 477,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sshd_selinux_setup_exec_context’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 386,
                    "column": 9,
                    "event": "warning[-Wdeprecated-declarations]",
                    "message": "‘security_context_t’ is deprecated",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  384|       int(pam_setenv)(char *, const char *), void *the_authctxt, int use_pam)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  385|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  386|-> \tsecurity_context_t user_ctx = NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  387|   \tint r = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  388|   \tsecurity_context_t default_ctx = NULL;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 477,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 388,
                    "column": 9,
                    "event": "warning[-Wdeprecated-declarations]",
                    "message": "‘security_context_t’ is deprecated",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  386|   \tsecurity_context_t user_ctx = NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  387|   \tint r = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  388|-> \tsecurity_context_t default_ctx = NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  389|   \tAuthctxt *authctxt = (Authctxt *) the_authctxt;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  390|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 447,
                    "column": 6,
                    "event": "warning[unix.Malloc]",
                    "message": "Potential leak of memory pointed to by 'user_ctx'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 391,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 394,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'use_pam' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 394,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 412,
                    "column": 6,
                    "event": "note",
                    "message": "Calling 'sshd_selinux_getctxbyname'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 252,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 252,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 261,
                    "column": 6,
                    "event": "note",
                    "message": "'r' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 261,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 269,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'r' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 269,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 271,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'inetd' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 271,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 289,
                    "column": 8,
                    "event": "note",
                    "message": "'reqlvl' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 289,
                    "column": 23,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 289,
                    "column": 41,
                    "event": "note",
                    "message": "'role' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 289,
                    "column": 41,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 289,
                    "column": 57,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 289,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 290,
                    "column": 8,
                    "event": "note",
                    "message": "Calling 'get_user_context'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 144,
                    "column": 6,
                    "event": "note",
                    "message": "'lvl' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 144,
                    "column": 18,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 149,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 149,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 156,
                    "column": 6,
                    "event": "note",
                    "message": "'role' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 156,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 156,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 159,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 159,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 165,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'con' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 165,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 171,
                    "column": 9,
                    "event": "note",
                    "message": "Memory is allocated",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 173,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 173,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 177,
                    "column": 6,
                    "event": "note",
                    "message": "'lvl' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 177,
                    "column": 18,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 290,
                    "column": 8,
                    "event": "note",
                    "message": "Returned allocated memory via 4th parameter",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 292,
                    "column": 8,
                    "event": "note",
                    "message": "'r' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 292,
                    "column": 8,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 292,
                    "column": 18,
                    "event": "note",
                    "message": "'reqlvl' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 292,
                    "column": 33,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 312,
                    "column": 6,
                    "event": "note",
                    "message": "'r' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 312,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 322,
                    "column": 6,
                    "event": "note",
                    "message": "'role' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 322,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 324,
                    "column": 6,
                    "event": "note",
                    "message": "'con' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 324,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 412,
                    "column": 6,
                    "event": "note",
                    "message": "Returned allocated memory via 3rd parameter",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 413,
                    "column": 6,
                    "event": "note",
                    "message": "'r' is >= 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 413,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 415,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'r' is >= 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 415,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 426,
                    "column": 6,
                    "event": "note",
                    "message": "'user_ctx' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 426,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 429,
                    "column": 6,
                    "event": "note",
                    "message": "'r' is >= 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 429,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 429,
                    "column": 15,
                    "event": "note",
                    "message": "Assuming 'user_ctx' is equal to 'default_ctx'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 429,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 434,
                    "column": 6,
                    "event": "note",
                    "message": "'r' is >= 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 434,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 445,
                    "column": 6,
                    "event": "note",
                    "message": "'user_ctx' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 445,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 445,
                    "column": 26,
                    "event": "note",
                    "message": "'user_ctx' is equal to 'default_ctx'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 445,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 447,
                    "column": 6,
                    "event": "note",
                    "message": "Potential leak of memory pointed to by 'user_ctx'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  445|   \tif (user_ctx != NULL && user_ctx != default_ctx)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  446|   \t\tfreecon(user_ctx);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  447|-> \tif (default_ctx != NULL)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  448|   \t\tfreecon(default_ctx);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  449|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 477,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sshd_selinux_copy_context’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux-sshd.c",
                    "line": 461,
                    "column": 9,
                    "event": "warning[-Wdeprecated-declarations]",
                    "message": "‘security_context_t’ is deprecated",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  459|   \t\treturn;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  460|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  461|-> \tif (getexeccon((security_context_t *)&ctx) != 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  462|   \t\tlogit_f(\"getexeccon failed with %s\", strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  463|   \t\treturn;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 1164,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-linux.c",
                    "line": 67,
                    "column": 1,
                    "event": "warning[-Wunused-function]",
                    "message": "‘ssh_selinux_getctxbyname’ defined but not used",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   67 | ssh_selinux_getctxbyname(char *pwname)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      | ^~~~~~~~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   65|   /* Return the default security context for the given username */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   66|   static char *",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   67|-> ssh_selinux_getctxbyname(char *pwname)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   68|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   69|   \tchar *sc = NULL, *sename = NULL, *lvl = NULL;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-net.c",
                    "line": 365,
                    "column": 2,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'buf' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/port-net.c",
                    "line": 365,
                    "column": 2,
                    "event": "note",
                    "message": "Value stored to 'buf' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  363|   \tif (*dlen < sizeof(af))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  364|   \t\treturn (NULL);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  365|-> \tbuf = *data;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  366|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  367|   #if defined(SSH_TUN_PREPEND_AF)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/readpassphrase.c",
                    "line": 72,
                    "column": 2,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'nr' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/readpassphrase.c",
                    "line": 72,
                    "column": 2,
                    "event": "note",
                    "message": "Value stored to 'nr' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   70|   \tfor (i = 0; i < _NSIG; i++)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   71|   \t\tsigno[i] = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   72|-> \tnr = -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   73|   \tsave_errno = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   74|   \tneed_restart = 0;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/readpassphrase.c",
                    "line": 73,
                    "column": 2,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'save_errno' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/readpassphrase.c",
                    "line": 73,
                    "column": 2,
                    "event": "note",
                    "message": "Value stored to 'save_errno' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   71|   \t\tsigno[i] = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   72|   \tnr = -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   73|-> \tsave_errno = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   74|   \tneed_restart = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   75|   \t/*",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/readpassphrase.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘readpassphrase’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/readpassphrase.c",
                    "line": 94,
                    "column": 12,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘open(\"/dev/tty\", 2)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/readpassphrase.c",
                    "line": 64,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch (when ‘bufsiz != 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/readpassphrase.c",
                    "line": 70,
                    "column": 23,
                    "event": "note",
                    "message": "(3) following ‘true’ branch (when ‘i != 65’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/readpassphrase.c",
                    "line": 71,
                    "column": 26,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/readpassphrase.c",
                    "line": 79,
                    "column": 12,
                    "event": "note",
                    "message": "(5) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/readpassphrase.c",
                    "line": 80,
                    "column": 31,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/readpassphrase.c",
                    "line": 80,
                    "column": 31,
                    "event": "note",
                    "message": "(7) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/readpassphrase.c",
                    "line": 79,
                    "column": 33,
                    "event": "note",
                    "message": "(8) assuming ‘open(\"/dev/tty\", 2)’ is a valid file descriptor (>= 0)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/readpassphrase.c",
                    "line": 79,
                    "column": 33,
                    "event": "note",
                    "message": "(9) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/readpassphrase.c",
                    "line": 94,
                    "column": 12,
                    "event": "note",
                    "message": "(10) ...to here (11) ‘open(\"/dev/tty\", 2)’ leaks here; was opened at (7)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   92|   \t * generate SIGTTOU, so do it *before* installing the signal handlers.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   93|   \t */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   94|-> \tif (input != STDIN_FILENO && tcgetattr(input, &oterm) == 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   95|   \t\tmemcpy(&term, &oterm, sizeof(term));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   96|   \t\tif (!(flags & RPP_ECHO_ON))",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 441,
                    "column": 2,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'a' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 441,
                    "column": 2,
                    "event": "note",
                    "message": "Value stored to 'a' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  439|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  440|   \t/* Clean up */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  441|-> \ta = b = c = d = e = f = g = h = T1 = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  442|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  443|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 441,
                    "column": 6,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'b' is used in the enclosing expression, the value is never actually read from 'b'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 441,
                    "column": 6,
                    "event": "note",
                    "message": "Although the value stored to 'b' is used in the enclosing expression, the value is never actually read from 'b'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  439|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  440|   \t/* Clean up */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  441|-> \ta = b = c = d = e = f = g = h = T1 = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  442|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  443|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 441,
                    "column": 10,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'c' is used in the enclosing expression, the value is never actually read from 'c'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 441,
                    "column": 10,
                    "event": "note",
                    "message": "Although the value stored to 'c' is used in the enclosing expression, the value is never actually read from 'c'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  439|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  440|   \t/* Clean up */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  441|-> \ta = b = c = d = e = f = g = h = T1 = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  442|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  443|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 441,
                    "column": 14,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'd' is used in the enclosing expression, the value is never actually read from 'd'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 441,
                    "column": 14,
                    "event": "note",
                    "message": "Although the value stored to 'd' is used in the enclosing expression, the value is never actually read from 'd'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  439|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  440|   \t/* Clean up */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  441|-> \ta = b = c = d = e = f = g = h = T1 = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  442|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  443|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 441,
                    "column": 18,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'e' is used in the enclosing expression, the value is never actually read from 'e'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 441,
                    "column": 18,
                    "event": "note",
                    "message": "Although the value stored to 'e' is used in the enclosing expression, the value is never actually read from 'e'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  439|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  440|   \t/* Clean up */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  441|-> \ta = b = c = d = e = f = g = h = T1 = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  442|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  443|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 441,
                    "column": 22,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'f' is used in the enclosing expression, the value is never actually read from 'f'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 441,
                    "column": 22,
                    "event": "note",
                    "message": "Although the value stored to 'f' is used in the enclosing expression, the value is never actually read from 'f'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  439|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  440|   \t/* Clean up */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  441|-> \ta = b = c = d = e = f = g = h = T1 = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  442|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  443|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 441,
                    "column": 26,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'g' is used in the enclosing expression, the value is never actually read from 'g'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 441,
                    "column": 26,
                    "event": "note",
                    "message": "Although the value stored to 'g' is used in the enclosing expression, the value is never actually read from 'g'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  439|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  440|   \t/* Clean up */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  441|-> \ta = b = c = d = e = f = g = h = T1 = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  442|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  443|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 441,
                    "column": 30,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'h' is used in the enclosing expression, the value is never actually read from 'h'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 441,
                    "column": 30,
                    "event": "note",
                    "message": "Although the value stored to 'h' is used in the enclosing expression, the value is never actually read from 'h'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  439|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  440|   \t/* Clean up */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  441|-> \ta = b = c = d = e = f = g = h = T1 = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  442|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  443|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 441,
                    "column": 34,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'T1' is used in the enclosing expression, the value is never actually read from 'T1'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 441,
                    "column": 34,
                    "event": "note",
                    "message": "Although the value stored to 'T1' is used in the enclosing expression, the value is never actually read from 'T1'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  439|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  440|   \t/* Clean up */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  441|-> \ta = b = c = d = e = f = g = h = T1 = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  442|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  443|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 548,
                    "column": 4,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'usedspace' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 548,
                    "column": 4,
                    "event": "note",
                    "message": "Value stored to 'usedspace' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  546|   \t\t\tcontext->bitcount[0] += (u_int64_t)len << 3;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  547|   \t\t\t/* Clean up: */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  548|-> \t\t\tusedspace = freespace = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  549|   \t\t\treturn;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  550|   \t\t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 548,
                    "column": 16,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'freespace' is used in the enclosing expression, the value is never actually read from 'freespace'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 548,
                    "column": 16,
                    "event": "note",
                    "message": "Although the value stored to 'freespace' is used in the enclosing expression, the value is never actually read from 'freespace'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  546|   \t\t\tcontext->bitcount[0] += (u_int64_t)len << 3;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  547|   \t\t\t/* Clean up: */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  548|-> \t\t\tusedspace = freespace = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  549|   \t\t\treturn;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  550|   \t\t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 565,
                    "column": 2,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'usedspace' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 565,
                    "column": 2,
                    "event": "note",
                    "message": "Value stored to 'usedspace' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  563|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  564|   \t/* Clean up: */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  565|-> \tusedspace = freespace = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  566|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  567|   DEF_WEAK(SHA256Update);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 565,
                    "column": 14,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'freespace' is used in the enclosing expression, the value is never actually read from 'freespace'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 565,
                    "column": 14,
                    "event": "note",
                    "message": "Although the value stored to 'freespace' is used in the enclosing expression, the value is never actually read from 'freespace'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  563|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  564|   \t/* Clean up: */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  565|-> \tusedspace = freespace = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  566|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  567|   DEF_WEAK(SHA256Update);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 609,
                    "column": 2,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'usedspace' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 609,
                    "column": 2,
                    "event": "note",
                    "message": "Value stored to 'usedspace' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  607|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  608|   \t/* Clean up: */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  609|-> \tusedspace = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  610|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  611|   DEF_WEAK(SHA256Pad);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 722,
                    "column": 2,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'a' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 722,
                    "column": 2,
                    "event": "note",
                    "message": "Value stored to 'a' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  720|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  721|   \t/* Clean up */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  722|-> \ta = b = c = d = e = f = g = h = T1 = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  723|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  724|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 722,
                    "column": 6,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'b' is used in the enclosing expression, the value is never actually read from 'b'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 722,
                    "column": 6,
                    "event": "note",
                    "message": "Although the value stored to 'b' is used in the enclosing expression, the value is never actually read from 'b'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  720|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  721|   \t/* Clean up */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  722|-> \ta = b = c = d = e = f = g = h = T1 = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  723|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  724|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 722,
                    "column": 10,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'c' is used in the enclosing expression, the value is never actually read from 'c'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 722,
                    "column": 10,
                    "event": "note",
                    "message": "Although the value stored to 'c' is used in the enclosing expression, the value is never actually read from 'c'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  720|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  721|   \t/* Clean up */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  722|-> \ta = b = c = d = e = f = g = h = T1 = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  723|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  724|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 722,
                    "column": 14,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'd' is used in the enclosing expression, the value is never actually read from 'd'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 722,
                    "column": 14,
                    "event": "note",
                    "message": "Although the value stored to 'd' is used in the enclosing expression, the value is never actually read from 'd'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  720|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  721|   \t/* Clean up */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  722|-> \ta = b = c = d = e = f = g = h = T1 = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  723|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  724|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 722,
                    "column": 18,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'e' is used in the enclosing expression, the value is never actually read from 'e'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 722,
                    "column": 18,
                    "event": "note",
                    "message": "Although the value stored to 'e' is used in the enclosing expression, the value is never actually read from 'e'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  720|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  721|   \t/* Clean up */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  722|-> \ta = b = c = d = e = f = g = h = T1 = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  723|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  724|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 722,
                    "column": 22,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'f' is used in the enclosing expression, the value is never actually read from 'f'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 722,
                    "column": 22,
                    "event": "note",
                    "message": "Although the value stored to 'f' is used in the enclosing expression, the value is never actually read from 'f'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  720|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  721|   \t/* Clean up */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  722|-> \ta = b = c = d = e = f = g = h = T1 = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  723|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  724|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 722,
                    "column": 26,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'g' is used in the enclosing expression, the value is never actually read from 'g'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 722,
                    "column": 26,
                    "event": "note",
                    "message": "Although the value stored to 'g' is used in the enclosing expression, the value is never actually read from 'g'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  720|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  721|   \t/* Clean up */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  722|-> \ta = b = c = d = e = f = g = h = T1 = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  723|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  724|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 722,
                    "column": 30,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'h' is used in the enclosing expression, the value is never actually read from 'h'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 722,
                    "column": 30,
                    "event": "note",
                    "message": "Although the value stored to 'h' is used in the enclosing expression, the value is never actually read from 'h'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  720|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  721|   \t/* Clean up */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  722|-> \ta = b = c = d = e = f = g = h = T1 = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  723|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  724|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 722,
                    "column": 34,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'T1' is used in the enclosing expression, the value is never actually read from 'T1'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 722,
                    "column": 34,
                    "event": "note",
                    "message": "Although the value stored to 'T1' is used in the enclosing expression, the value is never actually read from 'T1'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  720|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  721|   \t/* Clean up */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  722|-> \ta = b = c = d = e = f = g = h = T1 = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  723|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  724|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 829,
                    "column": 4,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'usedspace' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 829,
                    "column": 4,
                    "event": "note",
                    "message": "Value stored to 'usedspace' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  827|   \t\t\tADDINC128(context->bitcount, len << 3);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  828|   \t\t\t/* Clean up: */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  829|-> \t\t\tusedspace = freespace = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  830|   \t\t\treturn;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  831|   \t\t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 829,
                    "column": 16,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'freespace' is used in the enclosing expression, the value is never actually read from 'freespace'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 829,
                    "column": 16,
                    "event": "note",
                    "message": "Although the value stored to 'freespace' is used in the enclosing expression, the value is never actually read from 'freespace'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  827|   \t\t\tADDINC128(context->bitcount, len << 3);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  828|   \t\t\t/* Clean up: */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  829|-> \t\t\tusedspace = freespace = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  830|   \t\t\treturn;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  831|   \t\t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 846,
                    "column": 2,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'usedspace' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 846,
                    "column": 2,
                    "event": "note",
                    "message": "Value stored to 'usedspace' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  844|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  845|   \t/* Clean up: */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  846|-> \tusedspace = freespace = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  847|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  848|   DEF_WEAK(SHA512Update);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 846,
                    "column": 14,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'freespace' is used in the enclosing expression, the value is never actually read from 'freespace'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 846,
                    "column": 14,
                    "event": "note",
                    "message": "Although the value stored to 'freespace' is used in the enclosing expression, the value is never actually read from 'freespace'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  844|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  845|   \t/* Clean up: */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  846|-> \tusedspace = freespace = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  847|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  848|   DEF_WEAK(SHA512Update);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 890,
                    "column": 2,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'usedspace' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sha2.c",
                    "line": 890,
                    "column": 2,
                    "event": "note",
                    "message": "Value stored to 'usedspace' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  888|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  889|   \t/* Clean up: */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  890|-> \tusedspace = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  891|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  892|   DEF_WEAK(SHA512Pad);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/vis.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘stravis’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/vis.c",
                    "line": 229,
                    "column": 23,
                    "event": "warning[-Wuse-after-free]",
                    "message": "pointer ‘buf_15’ may be used after ‘realloc’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  229 |                 *outp = buf;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                 ~~~~~~^~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/vis.c",
                    "line": 227,
                    "column": 17,
                    "event": "note",
                    "message": "call to ‘realloc’ here",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  227 |         *outp = realloc(buf, len + 1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                 ^~~~~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  227|   \t*outp = realloc(buf, len + 1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  228|   \tif (*outp == NULL) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  229|-> \t\t*outp = buf;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  230|   \t\terrno = serrno;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  231|   \t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1120,
                    "column": 3,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'len' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1120,
                    "column": 3,
                    "event": "note",
                    "message": "Value stored to 'len' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1118|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1119|   \tif (comp && comp->enabled) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1120|-> \t\tlen = sshbuf_len(state->outgoing_packet);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1121|   \t\t/* skip header, compress only payload */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1122|   \t\tif ((r = sshbuf_consume(state->outgoing_packet, 5)) != 0)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1321,
                    "column": 11,
                    "event": "warning[unix.Malloc]",
                    "message": "Use of memory after it is freed",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1455,
                    "column": 11,
                    "event": "note",
                    "message": "Calling 'ssh_packet_read_seqnr'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1367,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1367,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1371,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1373,
                    "column": 12,
                    "event": "note",
                    "message": "Calling 'ssh_packet_read_poll_seqnr'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1753,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1756,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'r' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1756,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1758,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1758,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1766,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1766,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1787,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'kex' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1787,
                    "column": 24,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1791,
                    "column": 3,
                    "event": "note",
                    "message": "Control jumps to 'case 192:'  at line 1811",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1812,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1812,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1815,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1815,
                    "column": 8,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1816,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1815,
                    "column": 8,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1817,
                    "column": 13,
                    "event": "note",
                    "message": "Calling 'sshpkt_send'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 2838,
                    "column": 11,
                    "event": "note",
                    "message": "Field 'state' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 2838,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 2838,
                    "column": 20,
                    "event": "note",
                    "message": "Assuming field 'mux' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 2838,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 2840,
                    "column": 9,
                    "event": "note",
                    "message": "Calling 'ssh_packet_send2'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1275,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1275,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1278,
                    "column": 15,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1278,
                    "column": 45,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1285,
                    "column": 7,
                    "event": "note",
                    "message": "'need_rekey' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1285,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1285,
                    "column": 21,
                    "event": "note",
                    "message": "Assuming field 'rekeying' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1285,
                    "column": 38,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1310,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'type' is not equal to SSH2_MSG_KEXINIT",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1310,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1313,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1313,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1317,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'type' is equal to SSH2_MSG_NEWKEYS",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1317,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1320,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1327,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1327,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1335,
                    "column": 4,
                    "event": "note",
                    "message": "Assuming field 'tqe_next' is equal to null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sys-queue.h",
                    "line": 597,
                    "column": 6,
                    "event": "note",
                    "message": "expanded from macro 'TAILQ_REMOVE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1335,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sys-queue.h",
                    "line": 597,
                    "column": 2,
                    "event": "note",
                    "message": "expanded from macro 'TAILQ_REMOVE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1335,
                    "column": 4,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sys-queue.h",
                    "line": 596,
                    "column": 40,
                    "event": "note",
                    "message": "expanded from macro 'TAILQ_REMOVE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1337,
                    "column": 4,
                    "event": "note",
                    "message": "Memory is released",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1338,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1338,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1320,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1321,
                    "column": 11,
                    "event": "note",
                    "message": "Use of memory after it is freed",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1319|   \t\tstate->rekey_time = monotime();",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1320|   \t\twhile ((p = TAILQ_FIRST(&state->outgoing))) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1321|-> \t\t\ttype = p->type;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1322|   \t\t\t/*",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1323|   \t\t\t * If this packet triggers a rekex, then skip the",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1723,
                    "column": 3,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'r' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1723,
                    "column": 3,
                    "event": "note",
                    "message": "Value stored to 'r' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1721|   \t\treturn r;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1722|   \tif (*typep == SSH2_MSG_USERAUTH_SUCCESS && !state->server_side)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1723|-> \t\tr = ssh_packet_enable_delayed_compress(ssh);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1724|   \telse",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1725|   \t\tr = 0;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1725,
                    "column": 3,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'r' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/packet.c",
                    "line": 1725,
                    "column": 3,
                    "event": "note",
                    "message": "Value stored to 'r' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1723|   \t\tr = ssh_packet_enable_delayed_compress(ssh);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1724|   \telse",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1725|-> \t\tr = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1726|   #ifdef PACKET_DEBUG",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1727|   \tfprintf(stderr, \"read/plain[%d]:\\r\\n\", *typep);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_ssh_agent_auth.c",
                    "line": 153,
                    "column": 13,
                    "event": "warning[core.NonNullParamChecker]",
                    "message": "Null pointer passed to 2nd parameter expecting 'nonnull'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_ssh_agent_auth.c",
                    "line": 98,
                    "column": 5,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_ssh_agent_auth.c",
                    "line": 63,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'UNUSED'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_ssh_agent_auth.c",
                    "line": 112,
                    "column": 46,
                    "event": "note",
                    "message": "Assuming 'i' is <= 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_ssh_agent_auth.c",
                    "line": 112,
                    "column": 5,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 135",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_ssh_agent_auth.c",
                    "line": 135,
                    "column": 45,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_ssh_agent_auth.c",
                    "line": 141,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming 'ruser_ptr' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_ssh_agent_auth.c",
                    "line": 141,
                    "column": 5,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_ssh_agent_auth.c",
                    "line": 152,
                    "column": 13,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_ssh_agent_auth.c",
                    "line": 152,
                    "column": 48,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_ssh_agent_auth.c",
                    "line": 152,
                    "column": 13,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_ssh_agent_auth.c",
                    "line": 152,
                    "column": 9,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_ssh_agent_auth.c",
                    "line": 153,
                    "column": 13,
                    "event": "note",
                    "message": "Null pointer passed to 2nd parameter expecting 'nonnull'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  151|   #ifdef ENABLE_SUDO_HACK",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  152|           if( (strlen(sudo_service_name) > 0) && strncasecmp(servicename, sudo_service_name, sizeof(sudo_service_name) - 1) == 0 && getenv(\"SUDO_USER\") ) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  153|->             strncpy(ruser, getenv(\"SUDO_USER\"), sizeof(ruser) - 1 );",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  154|               verbose( \"Using environment variable SUDO_USER (%s)\", ruser );",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  155|           } else",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_authorized_keys.c",
                    "line": 108,
                    "column": 13,
                    "event": "warning[unix.cstring.BadSizeArg]",
                    "message": "Potential buffer overflow. Replace with 'sizeof(auth_keys_file_buf) - strlen(auth_keys_file_buf) - 1' or use a safer 'strlcat' API",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_authorized_keys.c",
                    "line": 108,
                    "column": 13,
                    "event": "note",
                    "message": "Potential buffer overflow. Replace with 'sizeof(auth_keys_file_buf) - strlen(auth_keys_file_buf) - 1' or use a safer 'strlcat' API",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  106|        */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  107|       strncat(auth_keys_file_buf, authorized_keys_file_input,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  108|->             sizeof(auth_keys_file_buf) - 1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  109|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  110|       if(allow_user_owned_authorized_keys_file)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 244,
                    "column": 11,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(open(\"/dev/null\", 2), 0)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 179,
                    "column": 7,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 184,
                    "column": 30,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 184,
                    "column": 5,
                    "event": "note",
                    "message": "(3) when ‘strncpy’ copies the full source string",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 201,
                    "column": 7,
                    "event": "note",
                    "message": "(4) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 207,
                    "column": 8,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 207,
                    "column": 7,
                    "event": "note",
                    "message": "(6) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 214,
                    "column": 8,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 214,
                    "column": 8,
                    "event": "note",
                    "message": "(8) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 214,
                    "column": 7,
                    "event": "note",
                    "message": "(9) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 91,
                    "column": 33,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 219,
                    "column": 5,
                    "event": "note",
                    "message": "in expansion of macro ‘debug’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 228,
                    "column": 5,
                    "event": "note",
                    "message": "(11) following ‘case 0:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 235,
                    "column": 22,
                    "event": "note",
                    "message": "(13) following ‘true’ branch (when ‘i != 65’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 236,
                    "column": 13,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 239,
                    "column": 11,
                    "event": "note",
                    "message": "(15) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 244,
                    "column": 12,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 244,
                    "column": 12,
                    "event": "note",
                    "message": "(17) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 244,
                    "column": 11,
                    "event": "note",
                    "message": "(18) ‘dup2(open(\"/dev/null\", 2), 0)’ leaks here; was opened at (17)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  242|               _exit(1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  243|           }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  244|->         if(dup2(devnull, STDIN_FILENO) == -1 || dup2(p[1], STDOUT_FILENO) == -1",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  245|              || dup2(devnull, STDERR_FILENO) == -1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  246|               error(\"%s: dup2: %s\", __func__, strerror(errno));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘pamsshagentauth_user_key_command_allowed2’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 244,
                    "column": 11,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘open(\"/dev/null\", 2)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 179,
                    "column": 7,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 184,
                    "column": 30,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 184,
                    "column": 5,
                    "event": "note",
                    "message": "(3) when ‘strncpy’ copies the full source string",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 201,
                    "column": 7,
                    "event": "note",
                    "message": "(4) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 207,
                    "column": 8,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 207,
                    "column": 7,
                    "event": "note",
                    "message": "(6) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 214,
                    "column": 8,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 214,
                    "column": 8,
                    "event": "note",
                    "message": "(8) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 214,
                    "column": 7,
                    "event": "note",
                    "message": "(9) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 49,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 91,
                    "column": 33,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 219,
                    "column": 5,
                    "event": "note",
                    "message": "in expansion of macro ‘debug’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 228,
                    "column": 5,
                    "event": "note",
                    "message": "(11) following ‘case 0:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 235,
                    "column": 22,
                    "event": "note",
                    "message": "(13) following ‘true’ branch (when ‘i != 65’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 236,
                    "column": 13,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 239,
                    "column": 23,
                    "event": "note",
                    "message": "(15) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 239,
                    "column": 11,
                    "event": "note",
                    "message": "(16) assuming ‘open(\"/dev/null\", 2)’ is a valid file descriptor (>= 0)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 239,
                    "column": 11,
                    "event": "note",
                    "message": "(17) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 244,
                    "column": 12,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 244,
                    "column": 11,
                    "event": "note",
                    "message": "(19) ‘open(\"/dev/null\", 2)’ leaks here; was opened at (15)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  242|               _exit(1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  243|           }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  244|->         if(dup2(devnull, STDIN_FILENO) == -1 || dup2(p[1], STDOUT_FILENO) == -1",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  245|              || dup2(devnull, STDERR_FILENO) == -1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  246|               error(\"%s: dup2: %s\", __func__, strerror(errno));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 244,
                    "column": 46,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(p[1], 1)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 179,
                    "column": 7,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 184,
                    "column": 30,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 184,
                    "column": 5,
                    "event": "note",
                    "message": "(3) when ‘strncpy’ copies the full source string",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 201,
                    "column": 7,
                    "event": "note",
                    "message": "(4) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 207,
                    "column": 8,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 207,
                    "column": 7,
                    "event": "note",
                    "message": "(6) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 214,
                    "column": 8,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 214,
                    "column": 8,
                    "event": "note",
                    "message": "(8) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 214,
                    "column": 7,
                    "event": "note",
                    "message": "(9) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 91,
                    "column": 33,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 219,
                    "column": 5,
                    "event": "note",
                    "message": "in expansion of macro ‘debug’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 228,
                    "column": 5,
                    "event": "note",
                    "message": "(11) following ‘case 0:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 235,
                    "column": 22,
                    "event": "note",
                    "message": "(13) following ‘true’ branch (when ‘i != 65’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 236,
                    "column": 13,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 239,
                    "column": 11,
                    "event": "note",
                    "message": "(15) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 244,
                    "column": 12,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 244,
                    "column": 11,
                    "event": "note",
                    "message": "(17) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 244,
                    "column": 49,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 244,
                    "column": 49,
                    "event": "note",
                    "message": "(19) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 244,
                    "column": 46,
                    "event": "note",
                    "message": "(20) ‘dup2(p[1], 1)’ leaks here; was opened at (19)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  242|               _exit(1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  243|           }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  244|->         if(dup2(devnull, STDIN_FILENO) == -1 || dup2(p[1], STDOUT_FILENO) == -1",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  245|              || dup2(devnull, STDERR_FILENO) == -1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  246|               error(\"%s: dup2: %s\", __func__, strerror(errno));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 244,
                    "column": 49,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘open(\"/dev/null\", 2)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 179,
                    "column": 7,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 184,
                    "column": 30,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 184,
                    "column": 5,
                    "event": "note",
                    "message": "(3) when ‘strncpy’ copies the full source string",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 201,
                    "column": 7,
                    "event": "note",
                    "message": "(4) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 207,
                    "column": 8,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 207,
                    "column": 7,
                    "event": "note",
                    "message": "(6) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 214,
                    "column": 8,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 214,
                    "column": 8,
                    "event": "note",
                    "message": "(8) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 214,
                    "column": 7,
                    "event": "note",
                    "message": "(9) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 91,
                    "column": 33,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 219,
                    "column": 5,
                    "event": "note",
                    "message": "in expansion of macro ‘debug’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 228,
                    "column": 5,
                    "event": "note",
                    "message": "(11) following ‘case 0:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 235,
                    "column": 22,
                    "event": "note",
                    "message": "(13) following ‘true’ branch (when ‘i != 65’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 236,
                    "column": 13,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 239,
                    "column": 23,
                    "event": "note",
                    "message": "(15) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 239,
                    "column": 11,
                    "event": "note",
                    "message": "(16) assuming ‘open(\"/dev/null\", 2)’ is a valid file descriptor (>= 0)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 239,
                    "column": 11,
                    "event": "note",
                    "message": "(17) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 244,
                    "column": 12,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 244,
                    "column": 11,
                    "event": "note",
                    "message": "(19) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 244,
                    "column": 49,
                    "event": "note",
                    "message": "(20) ...to here (21) ‘open(\"/dev/null\", 2)’ leaks here; was opened at (15)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  242|               _exit(1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  243|           }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  244|->         if(dup2(devnull, STDIN_FILENO) == -1 || dup2(p[1], STDOUT_FILENO) == -1",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  245|              || dup2(devnull, STDERR_FILENO) == -1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  246|               error(\"%s: dup2: %s\", __func__, strerror(errno));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 245,
                    "column": 12,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(open(\"/dev/null\", 2), 2)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 179,
                    "column": 7,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 184,
                    "column": 30,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 184,
                    "column": 5,
                    "event": "note",
                    "message": "(3) when ‘strncpy’ copies the full source string",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 201,
                    "column": 7,
                    "event": "note",
                    "message": "(4) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 207,
                    "column": 8,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 207,
                    "column": 7,
                    "event": "note",
                    "message": "(6) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 214,
                    "column": 8,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 214,
                    "column": 8,
                    "event": "note",
                    "message": "(8) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 214,
                    "column": 7,
                    "event": "note",
                    "message": "(9) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 91,
                    "column": 33,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 219,
                    "column": 5,
                    "event": "note",
                    "message": "in expansion of macro ‘debug’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 228,
                    "column": 5,
                    "event": "note",
                    "message": "(11) following ‘case 0:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 235,
                    "column": 22,
                    "event": "note",
                    "message": "(13) following ‘true’ branch (when ‘i != 65’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 236,
                    "column": 13,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 239,
                    "column": 11,
                    "event": "note",
                    "message": "(15) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 244,
                    "column": 12,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 244,
                    "column": 11,
                    "event": "note",
                    "message": "(17) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 245,
                    "column": 15,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 245,
                    "column": 15,
                    "event": "note",
                    "message": "(19) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 245,
                    "column": 12,
                    "event": "note",
                    "message": "(20) ‘dup2(open(\"/dev/null\", 2), 2)’ leaks here; was opened at (19)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  243|           }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  244|           if(dup2(devnull, STDIN_FILENO) == -1 || dup2(p[1], STDOUT_FILENO) == -1",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  245|->            || dup2(devnull, STDERR_FILENO) == -1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  246|               error(\"%s: dup2: %s\", __func__, strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  247|               _exit(1);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 245,
                    "column": 12,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘open(\"/dev/null\", 2)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 179,
                    "column": 7,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 184,
                    "column": 30,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 184,
                    "column": 5,
                    "event": "note",
                    "message": "(3) when ‘strncpy’ copies the full source string",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 201,
                    "column": 7,
                    "event": "note",
                    "message": "(4) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 207,
                    "column": 8,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 207,
                    "column": 7,
                    "event": "note",
                    "message": "(6) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 214,
                    "column": 8,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 214,
                    "column": 8,
                    "event": "note",
                    "message": "(8) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 214,
                    "column": 7,
                    "event": "note",
                    "message": "(9) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 91,
                    "column": 33,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 219,
                    "column": 5,
                    "event": "note",
                    "message": "in expansion of macro ‘debug’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 228,
                    "column": 5,
                    "event": "note",
                    "message": "(11) following ‘case 0:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 235,
                    "column": 22,
                    "event": "note",
                    "message": "(13) following ‘true’ branch (when ‘i != 65’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 236,
                    "column": 13,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 239,
                    "column": 23,
                    "event": "note",
                    "message": "(15) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 239,
                    "column": 11,
                    "event": "note",
                    "message": "(16) assuming ‘open(\"/dev/null\", 2)’ is a valid file descriptor (>= 0)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 239,
                    "column": 11,
                    "event": "note",
                    "message": "(17) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 244,
                    "column": 12,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 244,
                    "column": 11,
                    "event": "note",
                    "message": "(19) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 245,
                    "column": 15,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/pam_user_key_allowed2.c",
                    "line": 245,
                    "column": 12,
                    "event": "note",
                    "message": "(21) ‘open(\"/dev/null\", 2)’ leaks here; was opened at (15)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  243|           }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  244|           if(dup2(devnull, STDIN_FILENO) == -1 || dup2(p[1], STDOUT_FILENO) == -1",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  245|->            || dup2(devnull, STDERR_FILENO) == -1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  246|               error(\"%s: dup2: %s\", __func__, strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  247|               _exit(1);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 1735,
                    "column": 5,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'p' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 1735,
                    "column": 5,
                    "event": "note",
                    "message": "Value stored to 'p' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1733|   \t\t\t\t\t    lookup_opcode_name(opcode));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1734|   \t\t\t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1735|-> \t\t\t\tp = cleanhostname(p);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1736|   \t\t\t\t/*",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1737|   \t\t\t\t * don't want to use permitopen_port to avoid",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘read_config_file_depth’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 2472,
                    "column": 19,
                    "event": "warning[-Wanalyzer-file-leak]",
                    "message": "leak of FILE ‘fopen(filename, \"r\")’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 2466,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 2469,
                    "column": 18,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 2469,
                    "column": 18,
                    "event": "note",
                    "message": "(3) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 2469,
                    "column": 12,
                    "event": "note",
                    "message": "(4) assuming ‘fopen(filename, \"r\")’ is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 2469,
                    "column": 12,
                    "event": "note",
                    "message": "(5) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 2472,
                    "column": 19,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 2472,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 2475,
                    "column": 21,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 2472,
                    "column": 19,
                    "event": "note",
                    "message": "(9) ‘fopen(filename, \"r\")’ leaks here; was opened at (3)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2470|   \t\treturn 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2471|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2472|-> \tif (flags & SSHCONF_CHECKPERM) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2473|   \t\tstruct stat sb;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2474|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 2472,
                    "column": 19,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of ‘fopen(filename, \"r\")’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 2466,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 2469,
                    "column": 18,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 2469,
                    "column": 18,
                    "event": "note",
                    "message": "(3) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 2469,
                    "column": 12,
                    "event": "note",
                    "message": "(4) assuming ‘fopen(filename, \"r\")’ is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 2469,
                    "column": 12,
                    "event": "note",
                    "message": "(5) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 2472,
                    "column": 19,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 2472,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 2475,
                    "column": 21,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readconf.c",
                    "line": 2472,
                    "column": 19,
                    "event": "note",
                    "message": "(9) ‘fopen(filename, \"r\")’ leaks here; was allocated at (3)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2470|   \t\treturn 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2471|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2472|-> \tif (flags & SSHCONF_CHECKPERM) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2473|   \t\tstruct stat sb;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2474|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/readpass.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘ssh_askpass’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/readpass.c",
                    "line": 76,
                    "column": 20,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(p[1], 1)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/readpass.c",
                    "line": 62,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch (when ‘askpass’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readpass.c",
                    "line": 64,
                    "column": 13,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readpass.c",
                    "line": 64,
                    "column": 13,
                    "event": "note",
                    "message": "(3) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readpass.c",
                    "line": 64,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readpass.c",
                    "line": 68,
                    "column": 20,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readpass.c",
                    "line": 69,
                    "column": 12,
                    "event": "note",
                    "message": "(6) following ‘false’ branch (when ‘pid != -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readpass.c",
                    "line": 74,
                    "column": 12,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readpass.c",
                    "line": 74,
                    "column": 12,
                    "event": "note",
                    "message": "(8) following ‘true’ branch (when ‘pid == 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readpass.c",
                    "line": 75,
                    "column": 17,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readpass.c",
                    "line": 76,
                    "column": 21,
                    "event": "note",
                    "message": "(10) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/readpass.c",
                    "line": 76,
                    "column": 20,
                    "event": "note",
                    "message": "(11) ‘dup2(p[1], 1)’ leaks here; was opened at (10)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   74|   \tif (pid == 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   75|   \t\tclose(p[0]);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   76|-> \t\tif (dup2(p[1], STDOUT_FILENO) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   77|   \t\t\tfatal_f(\"dup2: %s\", strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   78|   \t\tif (env_hint != NULL)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sk_enroll’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 255,
                    "column": 9,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of ‘response’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 243,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch (when ‘enroll_response’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 247,
                    "column": 26,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 248,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 250,
                    "column": 25,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 250,
                    "column": 25,
                    "event": "note",
                    "message": "(5) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 250,
                    "column": 12,
                    "event": "note",
                    "message": "(6) assuming ‘response’ is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 250,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘false’ branch (when ‘response’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 254,
                    "column": 25,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 255,
                    "column": 9,
                    "event": "note",
                    "message": "(9) following ‘default:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 255,
                    "column": 9,
                    "event": "note",
                    "message": "(11) ‘response’ leaks here; was allocated at (5)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  253|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  254|   \tresponse->flags = flags;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  255|-> \tswitch(alg) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  256|   \tcase SSH_SK_ECDSA:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  257|   \t\tif (pack_key_ecdsa(response) != 0)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 265,
                    "column": 3,
                    "event": "warning[unix.Malloc]",
                    "message": "Potential leak of memory pointed to by 'response'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 243,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'enroll_response' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 243,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 248,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 248,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 250,
                    "column": 18,
                    "event": "note",
                    "message": "Memory is allocated",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 250,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 250,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 255,
                    "column": 2,
                    "event": "note",
                    "message": "Control jumps to the 'default' case at line 264",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 265,
                    "column": 3,
                    "event": "note",
                    "message": "Potential leak of memory pointed to by 'response'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  263|   \t\tbreak;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  264|   \tdefault:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  265|-> \t\tskdebug(__func__, \"unsupported key type %d\", alg);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  266|   \t\treturn -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  267|   \t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 280,
                    "column": 3,
                    "event": "warning[unix.Malloc]",
                    "message": "Attempt to free released memory",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 243,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'enroll_response' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 243,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 248,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 248,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 250,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 250,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 255,
                    "column": 2,
                    "event": "note",
                    "message": "Control jumps to 'case 1:'  at line 260",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 261,
                    "column": 7,
                    "event": "note",
                    "message": "Calling 'pack_key_ed25519'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 195,
                    "column": 30,
                    "event": "note",
                    "message": "Memory is allocated",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 195,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 195,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 202,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 202,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 204,
                    "column": 3,
                    "event": "note",
                    "message": "Control jumps to line 210",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 210,
                    "column": 6,
                    "event": "note",
                    "message": "'ret' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 210,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 211,
                    "column": 3,
                    "event": "note",
                    "message": "Memory is released",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 261,
                    "column": 7,
                    "event": "note",
                    "message": "Returning; memory was released",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 261,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 262,
                    "column": 4,
                    "event": "note",
                    "message": "Control jumps to line 279",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 279,
                    "column": 6,
                    "event": "note",
                    "message": "'response' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 279,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 280,
                    "column": 3,
                    "event": "note",
                    "message": "Attempt to free released memory",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  278|    out:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  279|   \tif (response != NULL) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  280|-> \t\tfree(response->public_key);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  281|   \t\tfree(response->key_handle);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  282|   \t\tfree(response->signature);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 415,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 280,
                    "column": 17,
                    "event": "warning[-Wanalyzer-double-free]",
                    "message": "double-‘free’ of ‘*response.public_key’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 234,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘sk_enroll’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 243,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following ‘false’ branch (when ‘enroll_response’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 247,
                    "column": 26,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 248,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 250,
                    "column": 25,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 250,
                    "column": 12,
                    "event": "note",
                    "message": "(6) following ‘false’ branch (when ‘response’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 254,
                    "column": 25,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 255,
                    "column": 9,
                    "event": "note",
                    "message": "(8) following ‘case 1:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 260,
                    "column": 9,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 261,
                    "column": 21,
                    "event": "note",
                    "message": "(10) calling ‘pack_key_ed25519’ from ‘sk_enroll’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 179,
                    "column": 1,
                    "event": "note",
                    "message": "(11) entry to ‘pack_key_ed25519’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 195,
                    "column": 37,
                    "event": "note",
                    "message": "(12) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 195,
                    "column": 12,
                    "event": "note",
                    "message": "(13) assuming ‘malloc(32)’ is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 195,
                    "column": 12,
                    "event": "note",
                    "message": "(14) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 199,
                    "column": 9,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 202,
                    "column": 12,
                    "event": "note",
                    "message": "(16) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 204,
                    "column": 17,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 211,
                    "column": 17,
                    "event": "note",
                    "message": "(18) first ‘free’ here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 261,
                    "column": 21,
                    "event": "note",
                    "message": "(19) returning to ‘sk_enroll’ from ‘pack_key_ed25519’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 261,
                    "column": 20,
                    "event": "note",
                    "message": "(20) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 262,
                    "column": 25,
                    "event": "note",
                    "message": "(21) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 280,
                    "column": 17,
                    "event": "note",
                    "message": "(22) second ‘free’ here; first ‘free’ was at (18)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  278|    out:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  279|   \tif (response != NULL) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  280|-> \t\tfree(response->public_key);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  281|   \t\tfree(response->key_handle);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  282|   \t\tfree(response->signature);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 522,
                    "column": 3,
                    "event": "warning[unix.Malloc]",
                    "message": "Potential leak of memory pointed to by 'response'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 492,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'sign_response' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 492,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 497,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 497,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 499,
                    "column": 18,
                    "event": "note",
                    "message": "Memory is allocated",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 499,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 499,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 508,
                    "column": 2,
                    "event": "note",
                    "message": "Control jumps to the 'default' case at line 521",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 522,
                    "column": 3,
                    "event": "note",
                    "message": "Potential leak of memory pointed to by 'response'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  520|   \t\tbreak;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  521|   \tdefault:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  522|-> \t\tskdebug(__func__, \"unsupported key type %d\", alg);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  523|   \t\treturn -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  524|   \t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sk_sign’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 523,
                    "column": 24,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of ‘response’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 492,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch (when ‘sign_response’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 496,
                    "column": 24,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 497,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 499,
                    "column": 25,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 499,
                    "column": 25,
                    "event": "note",
                    "message": "(5) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 499,
                    "column": 12,
                    "event": "note",
                    "message": "(6) assuming ‘response’ is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 499,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘false’ branch (when ‘response’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 42,
                    "column": 33,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 503,
                    "column": 9,
                    "event": "note",
                    "message": "in expansion of macro ‘SHA256Init’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 508,
                    "column": 9,
                    "event": "note",
                    "message": "(9) following ‘default:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/regress/misc/sk-dummy/sk-dummy.c",
                    "line": 523,
                    "column": 24,
                    "event": "note",
                    "message": "(10) ...to here (11) ‘response’ leaks here; was allocated at (5)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  521|   \tdefault:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  522|   \t\tskdebug(__func__, \"unsupported key type %d\", alg);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  523|-> \t\treturn -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  524|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  525|   \t*sign_response = response;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 476,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/scp.c",
                    "line": 1018,
                    "event": "warning[nullPointer]",
                    "message": "Possible null pointer dereference: done",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1016|   \tfree(active);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1017|   \tfor (i = 0; i < ndone; i++)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1018|-> \t\tfree(done[i]);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1019|   \tfree(done);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1020|   \treturn ret;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/scp.c",
                    "line": 1468,
                    "column": 5,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'fd' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/scp.c",
                    "line": 1468,
                    "column": 5,
                    "event": "note",
                    "message": "Value stored to 'fd' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1466|   next:\t\t\tif (fd != -1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1467|   \t\t\t\t(void) close(fd);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1468|-> \t\t\t\tfd = -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1469|   \t\t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1470|   \t\t\tcontinue;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/scp.c",
                    "line": 1501,
                    "column": 4,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'fd' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/scp.c",
                    "line": 1501,
                    "column": 4,
                    "event": "note",
                    "message": "Value stored to 'fd' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1499|   \t\t\tif (close(fd) == -1 && !haderr)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1500|   \t\t\t\thaderr = errno;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1501|-> \t\t\tfd = -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1502|   \t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1503|   \t\tif (!haderr)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/scp.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘rsource’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/scp.c",
                    "line": 1553,
                    "column": 56,
                    "event": "warning[-Wformat-truncation=]",
                    "message": "‘%s’ directive output may be truncated writing up to 255 bytes into a region of size between 2 and 4095",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1553 |                 (void) snprintf(path, sizeof path, \"%s/%s\", name, dp->d_name);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                                        ^~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/bits/stdio2.h",
                    "line": 68,
                    "column": 10,
                    "event": "note",
                    "message": "‘__snprintf_chk’ output between 2 and 4350 bytes into a destination of size 4096",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   68 |   return __builtin___snprintf_chk (__s, __n, __USE_FORTIFY_LEVEL - 1,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |          ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   69 |                                    __glibc_objsize (__s), __fmt,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   70 |                                    __va_arg_pack ());",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                    ~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1551|   \t\t\tcontinue;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1552|   \t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1553|-> \t\t(void) snprintf(path, sizeof path, \"%s/%s\", name, dp->d_name);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1554|   \t\tvect[0] = path;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1555|   \t\tsource(1, vect);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/scp.c",
                    "line": 2013,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'filename' is used in the enclosing expression, the value is never actually read from 'filename'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/scp.c",
                    "line": 2013,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'filename' is used in the enclosing expression, the value is never actually read from 'filename'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2011|   \tint i, r, targetisdir, err = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2012|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2013|-> \tif ((filename = basename(src)) == NULL)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2014|   \t\tfatal(\"basename %s: %s\", src, strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2015|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/servconf.c",
                    "line": 1620,
                    "column": 3,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'ca_only' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/servconf.c",
                    "line": 1620,
                    "column": 3,
                    "event": "note",
                    "message": "Value stored to 'ca_only' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1618|   \tcase sPubkeyAuthentication:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1619|   \t\tintptr = &options->pubkey_authentication;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1620|-> \t\tca_only = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1621|   \t\tgoto parse_flag;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1622|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/servconf.c",
                    "line": 2374,
                    "column": 10,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'port' is used in the enclosing expression, the value is never actually read from 'port'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/servconf.c",
                    "line": 2374,
                    "column": 10,
                    "event": "note",
                    "message": "Although the value stored to 'port' is used in the enclosing expression, the value is never actually read from 'port'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2372|   \t\t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2373|   \t\t\tif (arg == NULL ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2374|-> \t\t\t    ((port = permitopen_port(arg)) < 0)) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2375|   \t\t\t\tfatal(\"%s line %d: %s bad port number\",",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2376|   \t\t\t\t    filename, linenum, keyword);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘do_exec_no_pty’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 478,
                    "column": 20,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(pin[0], 0)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2316,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘session_input_channel_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2321,
                    "column": 18,
                    "event": "note",
                    "message": "(2) calling ‘session_by_channel’ from ‘session_input_channel_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 1939,
                    "column": 1,
                    "event": "note",
                    "message": "(3) entry to ‘session_by_channel’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 1942,
                    "column": 23,
                    "event": "note",
                    "message": "(4) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 1943,
                    "column": 30,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2321,
                    "column": 18,
                    "event": "note",
                    "message": "(6) returning to ‘session_input_channel_req’ from ‘session_by_channel’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2321,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 86,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 103,
                    "column": 33,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2325,
                    "column": 9,
                    "event": "note",
                    "message": "in expansion of macro ‘debug_f’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2331,
                    "column": 12,
                    "event": "note",
                    "message": "(9) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2332,
                    "column": 21,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2332,
                    "column": 20,
                    "event": "note",
                    "message": "(11) following ‘true’ branch (when the strings are equal)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2333,
                    "column": 35,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2333,
                    "column": 35,
                    "event": "note",
                    "message": "(13) calling ‘session_shell_req’ from ‘session_input_channel_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2143,
                    "column": 1,
                    "event": "note",
                    "message": "(14) entry to ‘session_shell_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2147,
                    "column": 12,
                    "event": "note",
                    "message": "(15) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2150,
                    "column": 9,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2152,
                    "column": 16,
                    "event": "note",
                    "message": "(17) calling ‘do_exec’ from ‘session_shell_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 677,
                    "column": 1,
                    "event": "note",
                    "message": "(18) entry to ‘do_exec’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 92,
                    "column": 33,
                    "event": "note",
                    "message": "(19) following ‘false’ branch (when ‘tty’ is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 746,
                    "column": 9,
                    "event": "note",
                    "message": "in expansion of macro ‘verbose’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 756,
                    "column": 12,
                    "event": "note",
                    "message": "(21) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 758,
                    "column": 12,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 769,
                    "column": 13,
                    "event": "note",
                    "message": "(23) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 769,
                    "column": 12,
                    "event": "note",
                    "message": "(24) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 772,
                    "column": 14,
                    "event": "note",
                    "message": "(25) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 772,
                    "column": 12,
                    "event": "note",
                    "message": "(26) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 775,
                    "column": 23,
                    "event": "note",
                    "message": "(27) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 775,
                    "column": 23,
                    "event": "note",
                    "message": "(28) calling ‘do_exec_no_pty’ from ‘do_exec’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 395,
                    "column": 1,
                    "event": "note",
                    "message": "(29) entry to ‘do_exec_no_pty’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 401,
                    "column": 12,
                    "event": "note",
                    "message": "(30) following ‘false’ branch (when ‘s’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 405,
                    "column": 13,
                    "event": "note",
                    "message": "(31) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 405,
                    "column": 13,
                    "event": "note",
                    "message": "(32) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 405,
                    "column": 12,
                    "event": "note",
                    "message": "(33) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 409,
                    "column": 13,
                    "event": "note",
                    "message": "(34) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 409,
                    "column": 13,
                    "event": "note",
                    "message": "(35) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 409,
                    "column": 12,
                    "event": "note",
                    "message": "(36) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 415,
                    "column": 13,
                    "event": "note",
                    "message": "(37) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 415,
                    "column": 13,
                    "event": "note",
                    "message": "(38) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 415,
                    "column": 12,
                    "event": "note",
                    "message": "(39) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 442,
                    "column": 9,
                    "event": "note",
                    "message": "(40) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 445,
                    "column": 9,
                    "event": "note",
                    "message": "(41) following ‘case 0:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 462,
                    "column": 9,
                    "event": "note",
                    "message": "(42) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 478,
                    "column": 21,
                    "event": "note",
                    "message": "(43) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 478,
                    "column": 20,
                    "event": "note",
                    "message": "(44) ‘dup2(pin[0], 0)’ leaks here; was opened at (43)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  476|   \t\t */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  477|   \t\tclose(pin[1]);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  478|-> \t\tif (dup2(pin[0], 0) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  479|   \t\t\tperror(\"dup2 stdin\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  480|   \t\tclose(pin[0]);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 484,
                    "column": 20,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(pout[1], 1)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2316,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘session_input_channel_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2321,
                    "column": 18,
                    "event": "note",
                    "message": "(2) calling ‘session_by_channel’ from ‘session_input_channel_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 1939,
                    "column": 1,
                    "event": "note",
                    "message": "(3) entry to ‘session_by_channel’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 1942,
                    "column": 23,
                    "event": "note",
                    "message": "(4) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 1943,
                    "column": 30,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2321,
                    "column": 18,
                    "event": "note",
                    "message": "(6) returning to ‘session_input_channel_req’ from ‘session_by_channel’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2321,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 103,
                    "column": 33,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2325,
                    "column": 9,
                    "event": "note",
                    "message": "in expansion of macro ‘debug_f’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2331,
                    "column": 12,
                    "event": "note",
                    "message": "(9) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2332,
                    "column": 21,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2332,
                    "column": 20,
                    "event": "note",
                    "message": "(11) following ‘true’ branch (when the strings are equal)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2333,
                    "column": 35,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2333,
                    "column": 35,
                    "event": "note",
                    "message": "(13) calling ‘session_shell_req’ from ‘session_input_channel_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2143,
                    "column": 1,
                    "event": "note",
                    "message": "(14) entry to ‘session_shell_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2147,
                    "column": 12,
                    "event": "note",
                    "message": "(15) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2150,
                    "column": 9,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2152,
                    "column": 16,
                    "event": "note",
                    "message": "(17) calling ‘do_exec’ from ‘session_shell_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 677,
                    "column": 1,
                    "event": "note",
                    "message": "(18) entry to ‘do_exec’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 92,
                    "column": 33,
                    "event": "note",
                    "message": "(19) following ‘false’ branch (when ‘tty’ is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 746,
                    "column": 9,
                    "event": "note",
                    "message": "in expansion of macro ‘verbose’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 756,
                    "column": 12,
                    "event": "note",
                    "message": "(21) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 758,
                    "column": 12,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 769,
                    "column": 13,
                    "event": "note",
                    "message": "(23) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 769,
                    "column": 12,
                    "event": "note",
                    "message": "(24) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 772,
                    "column": 14,
                    "event": "note",
                    "message": "(25) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 772,
                    "column": 12,
                    "event": "note",
                    "message": "(26) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 775,
                    "column": 23,
                    "event": "note",
                    "message": "(27) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 775,
                    "column": 23,
                    "event": "note",
                    "message": "(28) calling ‘do_exec_no_pty’ from ‘do_exec’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 395,
                    "column": 1,
                    "event": "note",
                    "message": "(29) entry to ‘do_exec_no_pty’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 401,
                    "column": 12,
                    "event": "note",
                    "message": "(30) following ‘false’ branch (when ‘s’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 405,
                    "column": 13,
                    "event": "note",
                    "message": "(31) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 405,
                    "column": 13,
                    "event": "note",
                    "message": "(32) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 405,
                    "column": 12,
                    "event": "note",
                    "message": "(33) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 409,
                    "column": 13,
                    "event": "note",
                    "message": "(34) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 409,
                    "column": 13,
                    "event": "note",
                    "message": "(35) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 409,
                    "column": 12,
                    "event": "note",
                    "message": "(36) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 415,
                    "column": 13,
                    "event": "note",
                    "message": "(37) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 415,
                    "column": 13,
                    "event": "note",
                    "message": "(38) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 415,
                    "column": 12,
                    "event": "note",
                    "message": "(39) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 442,
                    "column": 9,
                    "event": "note",
                    "message": "(40) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 445,
                    "column": 9,
                    "event": "note",
                    "message": "(41) following ‘case 0:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 462,
                    "column": 9,
                    "event": "note",
                    "message": "(42) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 484,
                    "column": 21,
                    "event": "note",
                    "message": "(43) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 484,
                    "column": 20,
                    "event": "note",
                    "message": "(44) ‘dup2(pout[1], 1)’ leaks here; was opened at (43)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  482|   \t\t/* Redirect stdout. */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  483|   \t\tclose(pout[0]);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  484|-> \t\tif (dup2(pout[1], 1) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  485|   \t\t\tperror(\"dup2 stdout\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  486|   \t\tclose(pout[1]);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 490,
                    "column": 20,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(perr[1], 2)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2316,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘session_input_channel_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2321,
                    "column": 18,
                    "event": "note",
                    "message": "(2) calling ‘session_by_channel’ from ‘session_input_channel_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 1939,
                    "column": 1,
                    "event": "note",
                    "message": "(3) entry to ‘session_by_channel’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 1942,
                    "column": 23,
                    "event": "note",
                    "message": "(4) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 1943,
                    "column": 30,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2321,
                    "column": 18,
                    "event": "note",
                    "message": "(6) returning to ‘session_input_channel_req’ from ‘session_by_channel’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2321,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 103,
                    "column": 33,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2325,
                    "column": 9,
                    "event": "note",
                    "message": "in expansion of macro ‘debug_f’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2331,
                    "column": 12,
                    "event": "note",
                    "message": "(9) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2332,
                    "column": 21,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2332,
                    "column": 20,
                    "event": "note",
                    "message": "(11) following ‘true’ branch (when the strings are equal)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2333,
                    "column": 35,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2333,
                    "column": 35,
                    "event": "note",
                    "message": "(13) calling ‘session_shell_req’ from ‘session_input_channel_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2143,
                    "column": 1,
                    "event": "note",
                    "message": "(14) entry to ‘session_shell_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2147,
                    "column": 12,
                    "event": "note",
                    "message": "(15) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2150,
                    "column": 9,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2152,
                    "column": 16,
                    "event": "note",
                    "message": "(17) calling ‘do_exec’ from ‘session_shell_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 677,
                    "column": 1,
                    "event": "note",
                    "message": "(18) entry to ‘do_exec’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 92,
                    "column": 33,
                    "event": "note",
                    "message": "(19) following ‘false’ branch (when ‘tty’ is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 746,
                    "column": 9,
                    "event": "note",
                    "message": "in expansion of macro ‘verbose’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 756,
                    "column": 12,
                    "event": "note",
                    "message": "(21) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 758,
                    "column": 12,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 769,
                    "column": 13,
                    "event": "note",
                    "message": "(23) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 769,
                    "column": 12,
                    "event": "note",
                    "message": "(24) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 772,
                    "column": 14,
                    "event": "note",
                    "message": "(25) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 772,
                    "column": 12,
                    "event": "note",
                    "message": "(26) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 775,
                    "column": 23,
                    "event": "note",
                    "message": "(27) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 775,
                    "column": 23,
                    "event": "note",
                    "message": "(28) calling ‘do_exec_no_pty’ from ‘do_exec’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 395,
                    "column": 1,
                    "event": "note",
                    "message": "(29) entry to ‘do_exec_no_pty’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 401,
                    "column": 12,
                    "event": "note",
                    "message": "(30) following ‘false’ branch (when ‘s’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 405,
                    "column": 13,
                    "event": "note",
                    "message": "(31) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 405,
                    "column": 13,
                    "event": "note",
                    "message": "(32) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 405,
                    "column": 12,
                    "event": "note",
                    "message": "(33) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 409,
                    "column": 13,
                    "event": "note",
                    "message": "(34) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 409,
                    "column": 13,
                    "event": "note",
                    "message": "(35) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 409,
                    "column": 12,
                    "event": "note",
                    "message": "(36) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 415,
                    "column": 13,
                    "event": "note",
                    "message": "(37) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 415,
                    "column": 13,
                    "event": "note",
                    "message": "(38) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 415,
                    "column": 12,
                    "event": "note",
                    "message": "(39) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 442,
                    "column": 9,
                    "event": "note",
                    "message": "(40) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 445,
                    "column": 9,
                    "event": "note",
                    "message": "(41) following ‘case 0:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 462,
                    "column": 9,
                    "event": "note",
                    "message": "(42) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 490,
                    "column": 21,
                    "event": "note",
                    "message": "(43) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 490,
                    "column": 20,
                    "event": "note",
                    "message": "(44) ‘dup2(perr[1], 2)’ leaks here; was opened at (43)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  488|   \t\t/* Redirect stderr. */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  489|   \t\tclose(perr[0]);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  490|-> \t\tif (dup2(perr[1], 2) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  491|   \t\t\tperror(\"dup2 stderr\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  492|   \t\tclose(perr[1]);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘do_exec_pty’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 620,
                    "column": 20,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(ttyfd, 0)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2316,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘session_input_channel_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2321,
                    "column": 18,
                    "event": "note",
                    "message": "(2) calling ‘session_by_channel’ from ‘session_input_channel_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 1939,
                    "column": 1,
                    "event": "note",
                    "message": "(3) entry to ‘session_by_channel’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 1942,
                    "column": 23,
                    "event": "note",
                    "message": "(4) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 1943,
                    "column": 30,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2321,
                    "column": 18,
                    "event": "note",
                    "message": "(6) returning to ‘session_input_channel_req’ from ‘session_by_channel’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2321,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 103,
                    "column": 33,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2325,
                    "column": 9,
                    "event": "note",
                    "message": "in expansion of macro ‘debug_f’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2331,
                    "column": 12,
                    "event": "note",
                    "message": "(9) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2332,
                    "column": 21,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2332,
                    "column": 20,
                    "event": "note",
                    "message": "(11) following ‘true’ branch (when the strings are equal)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2333,
                    "column": 35,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2333,
                    "column": 35,
                    "event": "note",
                    "message": "(13) calling ‘session_shell_req’ from ‘session_input_channel_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2143,
                    "column": 1,
                    "event": "note",
                    "message": "(14) entry to ‘session_shell_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2147,
                    "column": 12,
                    "event": "note",
                    "message": "(15) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2150,
                    "column": 9,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2152,
                    "column": 16,
                    "event": "note",
                    "message": "(17) calling ‘do_exec’ from ‘session_shell_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 677,
                    "column": 1,
                    "event": "note",
                    "message": "(18) entry to ‘do_exec’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 92,
                    "column": 33,
                    "event": "note",
                    "message": "(19) following ‘false’ branch (when ‘tty’ is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 746,
                    "column": 9,
                    "event": "note",
                    "message": "in expansion of macro ‘verbose’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 756,
                    "column": 12,
                    "event": "note",
                    "message": "(21) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 758,
                    "column": 12,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 769,
                    "column": 13,
                    "event": "note",
                    "message": "(23) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 769,
                    "column": 12,
                    "event": "note",
                    "message": "(24) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 772,
                    "column": 14,
                    "event": "note",
                    "message": "(25) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 772,
                    "column": 12,
                    "event": "note",
                    "message": "(26) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 773,
                    "column": 23,
                    "event": "note",
                    "message": "(27) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 773,
                    "column": 23,
                    "event": "note",
                    "message": "(28) calling ‘do_exec_pty’ from ‘do_exec’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 566,
                    "column": 1,
                    "event": "note",
                    "message": "(29) entry to ‘do_exec_pty’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 571,
                    "column": 12,
                    "event": "note",
                    "message": "(30) following ‘false’ branch (when ‘s’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 573,
                    "column": 15,
                    "event": "note",
                    "message": "(31) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 583,
                    "column": 12,
                    "event": "note",
                    "message": "(32) following ‘false’ branch (when ‘fdout != -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 590,
                    "column": 26,
                    "event": "note",
                    "message": "(33) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 590,
                    "column": 12,
                    "event": "note",
                    "message": "(34) following ‘false’ branch (when ‘ptymaster != -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 599,
                    "column": 24,
                    "event": "note",
                    "message": "(35) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 599,
                    "column": 9,
                    "event": "note",
                    "message": "(36) following ‘case 0:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 607,
                    "column": 9,
                    "event": "note",
                    "message": "(37) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 620,
                    "column": 21,
                    "event": "note",
                    "message": "(38) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 620,
                    "column": 20,
                    "event": "note",
                    "message": "(39) ‘dup2(ttyfd, 0)’ leaks here; was opened at (38)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  618|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  619|   \t\t/* Redirect stdin/stdout/stderr from the pseudo tty. */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  620|-> \t\tif (dup2(ttyfd, 0) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  621|   \t\t\terror(\"dup2 stdin: %s\", strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  622|   \t\tif (dup2(ttyfd, 1) == -1)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 622,
                    "column": 20,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(ttyfd, 1)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2316,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘session_input_channel_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2321,
                    "column": 18,
                    "event": "note",
                    "message": "(2) calling ‘session_by_channel’ from ‘session_input_channel_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 1939,
                    "column": 1,
                    "event": "note",
                    "message": "(3) entry to ‘session_by_channel’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 1942,
                    "column": 23,
                    "event": "note",
                    "message": "(4) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 1943,
                    "column": 30,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2321,
                    "column": 18,
                    "event": "note",
                    "message": "(6) returning to ‘session_input_channel_req’ from ‘session_by_channel’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2321,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 103,
                    "column": 33,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2325,
                    "column": 9,
                    "event": "note",
                    "message": "in expansion of macro ‘debug_f’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2331,
                    "column": 12,
                    "event": "note",
                    "message": "(9) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2332,
                    "column": 21,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2332,
                    "column": 20,
                    "event": "note",
                    "message": "(11) following ‘true’ branch (when the strings are equal)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2333,
                    "column": 35,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2333,
                    "column": 35,
                    "event": "note",
                    "message": "(13) calling ‘session_shell_req’ from ‘session_input_channel_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2143,
                    "column": 1,
                    "event": "note",
                    "message": "(14) entry to ‘session_shell_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2147,
                    "column": 12,
                    "event": "note",
                    "message": "(15) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2150,
                    "column": 9,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2152,
                    "column": 16,
                    "event": "note",
                    "message": "(17) calling ‘do_exec’ from ‘session_shell_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 677,
                    "column": 1,
                    "event": "note",
                    "message": "(18) entry to ‘do_exec’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 92,
                    "column": 33,
                    "event": "note",
                    "message": "(19) following ‘false’ branch (when ‘tty’ is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 746,
                    "column": 9,
                    "event": "note",
                    "message": "in expansion of macro ‘verbose’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 756,
                    "column": 12,
                    "event": "note",
                    "message": "(21) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 758,
                    "column": 12,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 769,
                    "column": 13,
                    "event": "note",
                    "message": "(23) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 769,
                    "column": 12,
                    "event": "note",
                    "message": "(24) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 772,
                    "column": 14,
                    "event": "note",
                    "message": "(25) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 772,
                    "column": 12,
                    "event": "note",
                    "message": "(26) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 773,
                    "column": 23,
                    "event": "note",
                    "message": "(27) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 773,
                    "column": 23,
                    "event": "note",
                    "message": "(28) calling ‘do_exec_pty’ from ‘do_exec’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 566,
                    "column": 1,
                    "event": "note",
                    "message": "(29) entry to ‘do_exec_pty’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 571,
                    "column": 12,
                    "event": "note",
                    "message": "(30) following ‘false’ branch (when ‘s’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 573,
                    "column": 15,
                    "event": "note",
                    "message": "(31) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 583,
                    "column": 12,
                    "event": "note",
                    "message": "(32) following ‘false’ branch (when ‘fdout != -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 590,
                    "column": 26,
                    "event": "note",
                    "message": "(33) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 590,
                    "column": 12,
                    "event": "note",
                    "message": "(34) following ‘false’ branch (when ‘ptymaster != -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 599,
                    "column": 24,
                    "event": "note",
                    "message": "(35) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 599,
                    "column": 9,
                    "event": "note",
                    "message": "(36) following ‘case 0:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 607,
                    "column": 9,
                    "event": "note",
                    "message": "(37) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 622,
                    "column": 21,
                    "event": "note",
                    "message": "(38) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 622,
                    "column": 20,
                    "event": "note",
                    "message": "(39) ‘dup2(ttyfd, 1)’ leaks here; was opened at (38)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  620|   \t\tif (dup2(ttyfd, 0) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  621|   \t\t\terror(\"dup2 stdin: %s\", strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  622|-> \t\tif (dup2(ttyfd, 1) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  623|   \t\t\terror(\"dup2 stdout: %s\", strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  624|   \t\tif (dup2(ttyfd, 2) == -1)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 624,
                    "column": 20,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(ttyfd, 2)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2316,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘session_input_channel_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2321,
                    "column": 18,
                    "event": "note",
                    "message": "(2) calling ‘session_by_channel’ from ‘session_input_channel_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 1939,
                    "column": 1,
                    "event": "note",
                    "message": "(3) entry to ‘session_by_channel’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 1942,
                    "column": 23,
                    "event": "note",
                    "message": "(4) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 1943,
                    "column": 30,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2321,
                    "column": 18,
                    "event": "note",
                    "message": "(6) returning to ‘session_input_channel_req’ from ‘session_by_channel’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2321,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 103,
                    "column": 33,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2325,
                    "column": 9,
                    "event": "note",
                    "message": "in expansion of macro ‘debug_f’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2331,
                    "column": 12,
                    "event": "note",
                    "message": "(9) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2332,
                    "column": 21,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2332,
                    "column": 20,
                    "event": "note",
                    "message": "(11) following ‘true’ branch (when the strings are equal)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2333,
                    "column": 35,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2333,
                    "column": 35,
                    "event": "note",
                    "message": "(13) calling ‘session_shell_req’ from ‘session_input_channel_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2143,
                    "column": 1,
                    "event": "note",
                    "message": "(14) entry to ‘session_shell_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2147,
                    "column": 12,
                    "event": "note",
                    "message": "(15) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2150,
                    "column": 9,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 2152,
                    "column": 16,
                    "event": "note",
                    "message": "(17) calling ‘do_exec’ from ‘session_shell_req’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 677,
                    "column": 1,
                    "event": "note",
                    "message": "(18) entry to ‘do_exec’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 92,
                    "column": 33,
                    "event": "note",
                    "message": "(19) following ‘false’ branch (when ‘tty’ is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 746,
                    "column": 9,
                    "event": "note",
                    "message": "in expansion of macro ‘verbose’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 756,
                    "column": 12,
                    "event": "note",
                    "message": "(21) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 758,
                    "column": 12,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 769,
                    "column": 13,
                    "event": "note",
                    "message": "(23) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 769,
                    "column": 12,
                    "event": "note",
                    "message": "(24) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 772,
                    "column": 14,
                    "event": "note",
                    "message": "(25) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 772,
                    "column": 12,
                    "event": "note",
                    "message": "(26) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 773,
                    "column": 23,
                    "event": "note",
                    "message": "(27) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 773,
                    "column": 23,
                    "event": "note",
                    "message": "(28) calling ‘do_exec_pty’ from ‘do_exec’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 566,
                    "column": 1,
                    "event": "note",
                    "message": "(29) entry to ‘do_exec_pty’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 571,
                    "column": 12,
                    "event": "note",
                    "message": "(30) following ‘false’ branch (when ‘s’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 573,
                    "column": 15,
                    "event": "note",
                    "message": "(31) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 583,
                    "column": 12,
                    "event": "note",
                    "message": "(32) following ‘false’ branch (when ‘fdout != -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 590,
                    "column": 26,
                    "event": "note",
                    "message": "(33) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 590,
                    "column": 12,
                    "event": "note",
                    "message": "(34) following ‘false’ branch (when ‘ptymaster != -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 599,
                    "column": 24,
                    "event": "note",
                    "message": "(35) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 599,
                    "column": 9,
                    "event": "note",
                    "message": "(36) following ‘case 0:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 607,
                    "column": 9,
                    "event": "note",
                    "message": "(37) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 624,
                    "column": 21,
                    "event": "note",
                    "message": "(38) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/session.c",
                    "line": 624,
                    "column": 20,
                    "event": "note",
                    "message": "(39) ‘dup2(ttyfd, 2)’ leaks here; was opened at (38)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  622|   \t\tif (dup2(ttyfd, 1) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  623|   \t\t\terror(\"dup2 stdout: %s\", strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  624|-> \t\tif (dup2(ttyfd, 2) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  625|   \t\t\terror(\"dup2 stderr: %s\", strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  626|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sftp-client.c",
                    "line": 0,
                    "event": "internal warning",
                    "message": "child 16107 timed out after 30s",
                    "verbosity_level": 0
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sftp_glob’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 155,
                    "column": 24,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of ‘s’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 137,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘sftp_glob’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 154,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 167,
                    "column": 20,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 167,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 168,
                    "column": 18,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 167,
                    "column": 76,
                    "event": "note",
                    "message": "(6) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 168,
                    "column": 43,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 168,
                    "column": 35,
                    "event": "note",
                    "message": "(8) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 169,
                    "column": 18,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 168,
                    "column": 58,
                    "event": "note",
                    "message": "(10) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 169,
                    "column": 47,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 169,
                    "column": 34,
                    "event": "note",
                    "message": "(12) following ‘true’ branch (when ‘s’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 170,
                    "column": 18,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 169,
                    "column": 70,
                    "event": "note",
                    "message": "(14) following ‘true’ branch (when ‘l != 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 170,
                    "column": 37,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 170,
                    "column": 33,
                    "event": "note",
                    "message": "(16) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 171,
                    "column": 21,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 171,
                    "column": 21,
                    "event": "note",
                    "message": "(18) calling ‘fudge_stat’ from ‘sftp_glob’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 124,
                    "column": 1,
                    "event": "note",
                    "message": "(19) entry to ‘fudge_stat’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 128,
                    "column": 12,
                    "event": "note",
                    "message": "(20) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 131,
                    "column": 9,
                    "event": "note",
                    "message": "(21) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 171,
                    "column": 21,
                    "event": "note",
                    "message": "(22) returning to ‘sftp_glob’ from ‘fudge_stat’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 171,
                    "column": 20,
                    "event": "note",
                    "message": "(23) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 173,
                    "column": 34,
                    "event": "note",
                    "message": "(24) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 173,
                    "column": 34,
                    "event": "note",
                    "message": "(25) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 173,
                    "column": 34,
                    "event": "note",
                    "message": "(26) when ‘realloc’ succeeds, moving buffer",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 173,
                    "column": 28,
                    "event": "note",
                    "message": "(27) following ‘true’ branch (when ‘s’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 174,
                    "column": 42,
                    "event": "note",
                    "message": "(28) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 155,
                    "column": 24,
                    "event": "note",
                    "message": "(29) ‘s’ leaks here; was allocated at (25)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  153|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  154|   \tif ((r = glob(pattern, flags | GLOB_ALTDIRFUNC, errfunc, pglob)) != 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  155|-> \t\treturn r;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  156|   \t/*",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  157|   \t * When both GLOB_NOCHECK and GLOB_MARK are active, a single gl_pathv",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sftp-glob.c",
                    "line": 173,
                    "event": "error[memleakOnRealloc]",
                    "message": "Common realloc mistake: 's' nulled but not freed upon failure",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  171|   \t\tif (fudge_stat(s, &sb) == 0 && S_ISDIR(sb.st_mode)) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  172|   \t\t\t/* NOCHECK on a directory; annotate */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  173|-> \t\t\tif ((s = realloc(s, l + 2)) != NULL) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  174|   \t\t\t\tmemcpy(s + l, \"/\", 2);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  175|   \t\t\t\tpglob->gl_pathv[0] = s;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sftp-server.c",
                    "line": 833,
                    "event": "error[memleakOnRealloc]",
                    "message": "Common realloc mistake: 'buf' nulled but not freed upon failure",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  831|   \tif (len > buflen) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  832|   \t\tdebug3_f(\"allocate %zu => %u\", buflen, len);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  833|-> \t\tif ((buf = realloc(buf, len)) == NULL)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  834|   \t\t\tfatal_f(\"realloc failed\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  835|   \t\tbuflen = len;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sftp-server.c",
                    "line": 1720,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'user_pw' is used in the enclosing expression, the value is never actually read from 'user_pw'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sftp-server.c",
                    "line": 1720,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'user_pw' is used in the enclosing expression, the value is never actually read from 'user_pw'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1718|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1719|   \tdebug3(\"request %u: home-directory \\\"%s\\\"\", id, username);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1720|-> \tif ((user_pw = getpwnam(username)) == NULL) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1721|   \t\tsend_status(id, SSH2_FX_FAILURE);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1722|   \t\tgoto out;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1401,
                    "column": 2,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'optidx' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1401,
                    "column": 2,
                    "event": "note",
                    "message": "Value stored to 'optidx' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1399|   \t*rflag = *sflag = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1400|   \t*path1 = *path2 = NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1401|-> \toptidx = 1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1402|   \tswitch (cmdnum) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1403|   \tcase I_GET:",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1495,
                    "column": 13,
                    "event": "warning[core.NonNullParamChecker]",
                    "message": "Null pointer passed to 1st parameter expecting 'nonnull'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1361,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1371",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1374,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1374,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1374,
                    "column": 21,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1374,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1377,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1377,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1381,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming field 'c' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1381,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1385",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1386,
                    "column": 2,
                    "event": "note",
                    "message": "Null pointer value stored to 'cmd'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1389,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1389,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1392,
                    "column": 13,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1392,
                    "column": 9,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1402,
                    "column": 2,
                    "event": "note",
                    "message": "Control jumps to 'case I_LLS:'  at line 1493",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1495,
                    "column": 13,
                    "event": "note",
                    "message": "Null pointer passed to 1st parameter expecting 'nonnull'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1493|   \tcase I_LLS:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1494|   \t\t/* Skip ls command and following whitespace */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1495|-> \t\tcp = cp + strlen(cmd) + strspn(cp, WHITESPACE);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1496|   \tcase I_SHELL:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1497|   \t\t/* Uses the rest of the line */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 688,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘parse_args’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1495,
                    "column": 27,
                    "event": "warning[-Wanalyzer-null-argument]",
                    "message": "use of NULL where non-null expected",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2434,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘main’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2598,
                    "column": 14,
                    "event": "note",
                    "message": "(2) when ‘isatty’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2598,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2601,
                    "column": 12,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2606,
                    "column": 12,
                    "event": "note",
                    "message": "(5) following ‘true’ branch (when ‘sftp_direct’ is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2607,
                    "column": 28,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2607,
                    "column": 20,
                    "event": "note",
                    "message": "(7) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2609,
                    "column": 22,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2635,
                    "column": 20,
                    "event": "note",
                    "message": "(9) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2640,
                    "column": 20,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2648,
                    "column": 20,
                    "event": "note",
                    "message": "(11) following ‘true’ branch (when ‘sftp_server’ is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2649,
                    "column": 25,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2653,
                    "column": 17,
                    "event": "note",
                    "message": "(13) following ‘false’ branch (when ‘sftp_server’ is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2656,
                    "column": 17,
                    "event": "note",
                    "message": "(15) calling ‘connect_to_server’ from ‘main’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2359,
                    "column": 1,
                    "event": "note",
                    "message": "(16) entry to ‘connect_to_server’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2374,
                    "column": 12,
                    "event": "note",
                    "message": "(17) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2376,
                    "column": 27,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2380,
                    "column": 12,
                    "event": "note",
                    "message": "(19) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2382,
                    "column": 25,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2382,
                    "column": 17,
                    "event": "note",
                    "message": "(21) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2407,
                    "column": 9,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2656,
                    "column": 17,
                    "event": "note",
                    "message": "(23) returning to ‘main’ from ‘connect_to_server’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2668,
                    "column": 12,
                    "event": "note",
                    "message": "(24) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2671,
                    "column": 13,
                    "event": "note",
                    "message": "(25) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2678,
                    "column": 15,
                    "event": "note",
                    "message": "(26) calling ‘interactive_loop’ from ‘main’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2206,
                    "column": 1,
                    "event": "note",
                    "message": "(27) entry to ‘interactive_loop’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2250,
                    "column": 12,
                    "event": "note",
                    "message": "(28) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2252,
                    "column": 20,
                    "event": "note",
                    "message": "(29) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2254,
                    "column": 12,
                    "event": "note",
                    "message": "(30) following ‘true’ branch (when ‘file1’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2255,
                    "column": 23,
                    "event": "note",
                    "message": "(31) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2258,
                    "column": 20,
                    "event": "note",
                    "message": "(32) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2259,
                    "column": 29,
                    "event": "note",
                    "message": "(33) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2262,
                    "column": 29,
                    "event": "note",
                    "message": "(34) calling ‘parse_dispatch_command’ from ‘interactive_loop’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1549,
                    "column": 1,
                    "event": "note",
                    "message": "(35) entry to ‘parse_dispatch_command’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1565,
                    "column": 18,
                    "event": "note",
                    "message": "(36) calling ‘parse_args’ from ‘parse_dispatch_command’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1341,
                    "column": 1,
                    "event": "note",
                    "message": "(37) entry to ‘parse_args’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1374,
                    "column": 12,
                    "event": "note",
                    "message": "(38) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1377,
                    "column": 21,
                    "event": "note",
                    "message": "(39) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1377,
                    "column": 21,
                    "event": "note",
                    "message": "(40) calling ‘makeargv’ from ‘parse_args’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1194,
                    "column": 1,
                    "event": "note",
                    "message": "(41) entry to ‘makeargv’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1204,
                    "column": 12,
                    "event": "note",
                    "message": "(42) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1209,
                    "column": 12,
                    "event": "note",
                    "message": "(43) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1209,
                    "column": 12,
                    "event": "note",
                    "message": "(44) following ‘false’ branch (when ‘terminated’ is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1211,
                    "column": 12,
                    "event": "note",
                    "message": "(45) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1211,
                    "column": 12,
                    "event": "note",
                    "message": "(46) following ‘false’ branch (when ‘lastquote’ is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(47) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1216,
                    "column": 20,
                    "event": "note",
                    "message": "(48) following ‘false’ branch (when ‘argc != 129’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 31,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1220,
                    "column": 21,
                    "event": "note",
                    "message": "(49) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1241,
                    "column": 27,
                    "event": "note",
                    "message": "(50) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1291,
                    "column": 27,
                    "event": "note",
                    "message": "(51) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1296,
                    "column": 27,
                    "event": "note",
                    "message": "(52) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1297,
                    "column": 48,
                    "event": "note",
                    "message": "(53) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1297,
                    "column": 28,
                    "event": "note",
                    "message": "(54) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1307,
                    "column": 2,
                    "event": "note",
                    "message": "(55) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1377,
                    "column": 21,
                    "event": "note",
                    "message": "(56) returning to ‘parse_args’ from ‘makeargv’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1377,
                    "column": 12,
                    "event": "note",
                    "message": "(57) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(58) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1381,
                    "column": 31,
                    "event": "note",
                    "message": "(59) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1382,
                    "column": 25,
                    "event": "note",
                    "message": "(60) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1392,
                    "column": 19,
                    "event": "note",
                    "message": "(61) following ‘false’ branch (when ‘cmdnum != -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1398,
                    "column": 61,
                    "event": "note",
                    "message": "(62) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1402,
                    "column": 9,
                    "event": "note",
                    "message": "(63) following ‘case 11:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1493,
                    "column": 9,
                    "event": "note",
                    "message": "(64) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1495,
                    "column": 27,
                    "event": "note",
                    "message": "(65) argument 1 (‘<unknown>’) NULL where non-null expected",
                    "verbosity_level": 2
                },
                {
                    "file_name": "<built-in>",
                    "line": 0,
                    "event": "note",
                    "message": "argument 1 of ‘__builtin_strlen’ must be non-null",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1493|   \tcase I_LLS:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1494|   \t\t/* Skip ls command and following whitespace */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1495|-> \t\tcp = cp + strlen(cmd) + strspn(cp, WHITESPACE);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1496|   \tcase I_SHELL:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1497|   \t\t/* Uses the rest of the line */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1537,
                    "column": 8,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'optidx' is used in the enclosing expression, the value is never actually read from 'optidx'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 1537,
                    "column": 8,
                    "event": "note",
                    "message": "Although the value stored to 'optidx' is used in the enclosing expression, the value is never actually read from 'optidx'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1535|   \tcase I_VERSION:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1536|   \tcase I_PROGRESS:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1537|-> \t\tif ((optidx = parse_no_flags(cmd, argv, argc)) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1538|   \t\t\treturn -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1539|   \t\tbreak;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2143,
                    "column": 2,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'argv' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2143,
                    "column": 2,
                    "event": "note",
                    "message": "Value stored to 'argv' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2141|   \tmemcpy(line, lf->buffer, cursor);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2142|   \tline[cursor] = '\\0';",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2143|-> \targv = makeargv(line, &carg, 1, &quote, &terminated);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2144|   \tfree(line);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2145|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘connect_to_server’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2383,
                    "column": 20,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(c_out, 0)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2434,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘main’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2467,
                    "column": 60,
                    "event": "note",
                    "message": "(2) following ‘true’ branch (when ‘ch != -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2468,
                    "column": 17,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2467,
                    "column": 60,
                    "event": "note",
                    "message": "(4) following ‘false’ branch (when ‘ch == -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2596,
                    "column": 9,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2598,
                    "column": 14,
                    "event": "note",
                    "message": "(6) when ‘isatty’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2598,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2601,
                    "column": 12,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2606,
                    "column": 12,
                    "event": "note",
                    "message": "(9) following ‘false’ branch (when ‘sftp_direct’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2658,
                    "column": 26,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2658,
                    "column": 20,
                    "event": "note",
                    "message": "(11) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2660,
                    "column": 24,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2660,
                    "column": 20,
                    "event": "note",
                    "message": "(13) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2662,
                    "column": 17,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2662,
                    "column": 17,
                    "event": "note",
                    "message": "(15) calling ‘connect_to_server’ from ‘main’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2359,
                    "column": 1,
                    "event": "note",
                    "message": "(16) entry to ‘connect_to_server’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2374,
                    "column": 12,
                    "event": "note",
                    "message": "(17) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2376,
                    "column": 27,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2380,
                    "column": 12,
                    "event": "note",
                    "message": "(19) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2382,
                    "column": 25,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2382,
                    "column": 17,
                    "event": "note",
                    "message": "(21) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2383,
                    "column": 22,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2383,
                    "column": 22,
                    "event": "note",
                    "message": "(23) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2383,
                    "column": 20,
                    "event": "note",
                    "message": "(24) ‘dup2(c_out, 0)’ leaks here; was opened at (23)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2381|   \t\tfatal(\"fork: %s\", strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2382|   \telse if (sshpid == 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2383|-> \t\tif ((dup2(c_in, STDIN_FILENO) == -1) ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2384|   \t\t    (dup2(c_out, STDOUT_FILENO) == -1)) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2385|   \t\t\tfprintf(stderr, \"dup2: %s\\n\", strerror(errno));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2383,
                    "column": 54,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(c_out, 1)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2434,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘main’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2467,
                    "column": 60,
                    "event": "note",
                    "message": "(2) following ‘true’ branch (when ‘ch != -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2468,
                    "column": 17,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2467,
                    "column": 60,
                    "event": "note",
                    "message": "(4) following ‘false’ branch (when ‘ch == -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2596,
                    "column": 9,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2598,
                    "column": 14,
                    "event": "note",
                    "message": "(6) when ‘isatty’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2598,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2601,
                    "column": 12,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2606,
                    "column": 12,
                    "event": "note",
                    "message": "(9) following ‘false’ branch (when ‘sftp_direct’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2658,
                    "column": 26,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2658,
                    "column": 20,
                    "event": "note",
                    "message": "(11) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2660,
                    "column": 24,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2660,
                    "column": 20,
                    "event": "note",
                    "message": "(13) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2662,
                    "column": 17,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2662,
                    "column": 17,
                    "event": "note",
                    "message": "(15) calling ‘connect_to_server’ from ‘main’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2359,
                    "column": 1,
                    "event": "note",
                    "message": "(16) entry to ‘connect_to_server’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2374,
                    "column": 12,
                    "event": "note",
                    "message": "(17) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2376,
                    "column": 27,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2380,
                    "column": 12,
                    "event": "note",
                    "message": "(19) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2382,
                    "column": 25,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2382,
                    "column": 17,
                    "event": "note",
                    "message": "(21) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2383,
                    "column": 22,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2383,
                    "column": 20,
                    "event": "note",
                    "message": "(23) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2384,
                    "column": 22,
                    "event": "note",
                    "message": "(24) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2384,
                    "column": 22,
                    "event": "note",
                    "message": "(25) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2383,
                    "column": 54,
                    "event": "note",
                    "message": "(26) ‘dup2(c_out, 1)’ leaks here; was opened at (25)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2381|   \t\tfatal(\"fork: %s\", strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2382|   \telse if (sshpid == 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2383|-> \t\tif ((dup2(c_in, STDIN_FILENO) == -1) ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2384|   \t\t    (dup2(c_out, STDOUT_FILENO) == -1)) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2385|   \t\t\tfprintf(stderr, \"dup2: %s\\n\", strerror(errno));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 1341,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2389,
                    "column": 17,
                    "event": "warning[-Wanalyzer-fd-double-close]",
                    "message": "double ‘close’ of file descriptor ‘in’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2434,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘main’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2467,
                    "column": 60,
                    "event": "note",
                    "message": "(2) following ‘true’ branch (when ‘ch != -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2468,
                    "column": 17,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2467,
                    "column": 60,
                    "event": "note",
                    "message": "(4) following ‘false’ branch (when ‘ch == -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2596,
                    "column": 9,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2598,
                    "column": 14,
                    "event": "note",
                    "message": "(6) when ‘isatty’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2598,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2601,
                    "column": 12,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2606,
                    "column": 12,
                    "event": "note",
                    "message": "(9) following ‘false’ branch (when ‘sftp_direct’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2658,
                    "column": 26,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2658,
                    "column": 20,
                    "event": "note",
                    "message": "(11) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2660,
                    "column": 24,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2660,
                    "column": 20,
                    "event": "note",
                    "message": "(13) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2662,
                    "column": 17,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2662,
                    "column": 17,
                    "event": "note",
                    "message": "(15) calling ‘connect_to_server’ from ‘main’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2359,
                    "column": 1,
                    "event": "note",
                    "message": "(16) entry to ‘connect_to_server’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2374,
                    "column": 12,
                    "event": "note",
                    "message": "(17) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2376,
                    "column": 27,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2380,
                    "column": 12,
                    "event": "note",
                    "message": "(19) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2382,
                    "column": 25,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2382,
                    "column": 17,
                    "event": "note",
                    "message": "(21) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2383,
                    "column": 22,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2383,
                    "column": 20,
                    "event": "note",
                    "message": "(23) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2384,
                    "column": 22,
                    "event": "note",
                    "message": "(24) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2383,
                    "column": 54,
                    "event": "note",
                    "message": "(25) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2388,
                    "column": 17,
                    "event": "note",
                    "message": "(26) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2388,
                    "column": 17,
                    "event": "note",
                    "message": "(27) first ‘close’ here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2389,
                    "column": 17,
                    "event": "note",
                    "message": "(28) second ‘close’ here; first ‘close’ was at (27)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2387|   \t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2388|   \t\tclose(*in);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2389|-> \t\tclose(*out);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2390|   \t\tclose(c_in);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2391|   \t\tclose(c_out);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 1341,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2391,
                    "column": 17,
                    "event": "warning[-Wanalyzer-fd-double-close]",
                    "message": "double ‘close’ of file descriptor ‘c_out’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2434,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘main’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2467,
                    "column": 60,
                    "event": "note",
                    "message": "(2) following ‘true’ branch (when ‘ch != -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2468,
                    "column": 17,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2467,
                    "column": 60,
                    "event": "note",
                    "message": "(4) following ‘false’ branch (when ‘ch == -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2596,
                    "column": 9,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2598,
                    "column": 14,
                    "event": "note",
                    "message": "(6) when ‘isatty’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2598,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2601,
                    "column": 12,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2606,
                    "column": 12,
                    "event": "note",
                    "message": "(9) following ‘false’ branch (when ‘sftp_direct’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2658,
                    "column": 26,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2658,
                    "column": 20,
                    "event": "note",
                    "message": "(11) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2660,
                    "column": 24,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2660,
                    "column": 20,
                    "event": "note",
                    "message": "(13) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2662,
                    "column": 17,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2662,
                    "column": 17,
                    "event": "note",
                    "message": "(15) calling ‘connect_to_server’ from ‘main’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2359,
                    "column": 1,
                    "event": "note",
                    "message": "(16) entry to ‘connect_to_server’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2374,
                    "column": 12,
                    "event": "note",
                    "message": "(17) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2376,
                    "column": 27,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2380,
                    "column": 12,
                    "event": "note",
                    "message": "(19) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2382,
                    "column": 25,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2382,
                    "column": 17,
                    "event": "note",
                    "message": "(21) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2383,
                    "column": 22,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2383,
                    "column": 20,
                    "event": "note",
                    "message": "(23) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2384,
                    "column": 22,
                    "event": "note",
                    "message": "(24) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2383,
                    "column": 54,
                    "event": "note",
                    "message": "(25) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2388,
                    "column": 17,
                    "event": "note",
                    "message": "(26) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2390,
                    "column": 17,
                    "event": "note",
                    "message": "(27) first ‘close’ here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2391,
                    "column": 17,
                    "event": "note",
                    "message": "(28) second ‘close’ here; first ‘close’ was at (27)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2389|   \t\tclose(*out);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2390|   \t\tclose(c_in);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2391|-> \t\tclose(c_out);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2392|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2393|   \t\t/*",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 1341,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2415,
                    "column": 9,
                    "event": "warning[-Wanalyzer-fd-double-close]",
                    "message": "double ‘close’ of file descriptor ‘c_out’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2434,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘main’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2467,
                    "column": 60,
                    "event": "note",
                    "message": "(2) following ‘true’ branch (when ‘ch != -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2468,
                    "column": 17,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2467,
                    "column": 60,
                    "event": "note",
                    "message": "(4) following ‘false’ branch (when ‘ch == -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2596,
                    "column": 9,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2598,
                    "column": 14,
                    "event": "note",
                    "message": "(6) when ‘isatty’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2598,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2601,
                    "column": 12,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2606,
                    "column": 12,
                    "event": "note",
                    "message": "(9) following ‘false’ branch (when ‘sftp_direct’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2658,
                    "column": 26,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2658,
                    "column": 20,
                    "event": "note",
                    "message": "(11) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2660,
                    "column": 24,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2660,
                    "column": 20,
                    "event": "note",
                    "message": "(13) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2662,
                    "column": 17,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2662,
                    "column": 17,
                    "event": "note",
                    "message": "(15) calling ‘connect_to_server’ from ‘main’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2359,
                    "column": 1,
                    "event": "note",
                    "message": "(16) entry to ‘connect_to_server’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2374,
                    "column": 12,
                    "event": "note",
                    "message": "(17) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2376,
                    "column": 27,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2380,
                    "column": 12,
                    "event": "note",
                    "message": "(19) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2382,
                    "column": 25,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2382,
                    "column": 17,
                    "event": "note",
                    "message": "(21) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2407,
                    "column": 9,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2414,
                    "column": 9,
                    "event": "note",
                    "message": "(23) first ‘close’ here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sftp.c",
                    "line": 2415,
                    "column": 9,
                    "event": "note",
                    "message": "(24) second ‘close’ here; first ‘close’ was at (23)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2413|   \tssh_signal(SIGCHLD, sigchld_handler);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2414|   \tclose(c_in);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2415|-> \tclose(c_out);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2416|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2417|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sk-usbhid.c",
                    "line": 1394,
                    "column": 9,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sk-usbhid.c",
                    "line": 1394,
                    "column": 9,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1392|   \t\t\t\tsrk->flags |=  SSH_SK_USER_VERIFICATION_REQD;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1393|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1394|-> \t\t\tif ((r = pack_public_key(srk->alg, cred,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1395|   \t\t\t    &srk->key)) != 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1396|   \t\t\t\tskdebug(__func__, \"pack public key failed\");",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘add_file’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 303,
                    "column": 12,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘open(filename, 0)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 846,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘main’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 873,
                    "column": 9,
                    "event": "note",
                    "message": "(2) following ‘case 0:’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 885,
                    "column": 22,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 901,
                    "column": 25,
                    "event": "note",
                    "message": "(4) calling ‘stringlist_append’ from ‘main’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 713,
                    "column": 1,
                    "event": "note",
                    "message": "(5) entry to ‘stringlist_append’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 717,
                    "column": 12,
                    "event": "note",
                    "message": "(6) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 718,
                    "column": 26,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 901,
                    "column": 25,
                    "event": "note",
                    "message": "(8) returning to ‘main’ from ‘stringlist_append’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 887,
                    "column": 77,
                    "event": "note",
                    "message": "(9) following ‘false’ branch (when ‘ch == -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 982,
                    "column": 9,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 984,
                    "column": 12,
                    "event": "note",
                    "message": "(11) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 986,
                    "column": 17,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 986,
                    "column": 17,
                    "event": "note",
                    "message": "(13) following ‘false’ branch (when ‘xflag == 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 990,
                    "column": 19,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 990,
                    "column": 19,
                    "event": "note",
                    "message": "(15) following ‘false’ branch (when ‘lflag == 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 994,
                    "column": 19,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 994,
                    "column": 19,
                    "event": "note",
                    "message": "(17) following ‘false’ branch (when ‘Dflag == 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 1001,
                    "column": 12,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 1021,
                    "column": 12,
                    "event": "note",
                    "message": "(19) following ‘false’ branch (when ‘Tflag == 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 1029,
                    "column": 12,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 1029,
                    "column": 12,
                    "event": "note",
                    "message": "(21) following ‘false’ branch (when ‘pkcs11provider’ is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 1046,
                    "column": 12,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 1046,
                    "column": 12,
                    "event": "note",
                    "message": "(23) following ‘false’ branch (when ‘do_download == 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 1054,
                    "column": 12,
                    "event": "note",
                    "message": "(24) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 1054,
                    "column": 12,
                    "event": "note",
                    "message": "(25) following ‘true’ branch (when ‘argc == 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 1060,
                    "column": 27,
                    "event": "note",
                    "message": "(26) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 1060,
                    "column": 20,
                    "event": "note",
                    "message": "(27) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(28) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 1067,
                    "column": 29,
                    "event": "note",
                    "message": "(29) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 1068,
                    "column": 25,
                    "event": "note",
                    "message": "(30) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 1070,
                    "column": 28,
                    "event": "note",
                    "message": "(31) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 1072,
                    "column": 29,
                    "event": "note",
                    "message": "(32) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 1072,
                    "column": 29,
                    "event": "note",
                    "message": "(33) calling ‘do_file’ from ‘main’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 687,
                    "column": 1,
                    "event": "note",
                    "message": "(34) entry to ‘do_file’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 699,
                    "column": 12,
                    "event": "note",
                    "message": "(35) following ‘false’ branch (when ‘deleting == 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 704,
                    "column": 21,
                    "event": "note",
                    "message": "(36) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 704,
                    "column": 21,
                    "event": "note",
                    "message": "(37) calling ‘add_file’ from ‘do_file’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 277,
                    "column": 1,
                    "event": "note",
                    "message": "(38) entry to ‘add_file’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 291,
                    "column": 12,
                    "event": "note",
                    "message": "(39) following ‘false’ branch (when the strings are non-equal)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 294,
                    "column": 26,
                    "event": "note",
                    "message": "(40) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 294,
                    "column": 26,
                    "event": "note",
                    "message": "(41) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 294,
                    "column": 19,
                    "event": "note",
                    "message": "(42) assuming ‘open(filename, 0)’ is a valid file descriptor (>= 0)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 294,
                    "column": 19,
                    "event": "note",
                    "message": "(43) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-add.c",
                    "line": 303,
                    "column": 12,
                    "event": "note",
                    "message": "(44) ...to here (45) ‘open(filename, 0)’ leaks here; was opened at (41)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  301|   \t * will occur multiple times, so check perms first and bail if wrong.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  302|   \t */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  303|-> \tif (fd != STDIN_FILENO) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  304|   \t\tif (sshkey_perm_ok(fd, filename) != 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  305|   \t\t\tclose(fd);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 476,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘dup_dest_constraint_hop’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 273,
                    "column": 35,
                    "event": "warning[-Wanalyzer-null-dereference]",
                    "message": "dereference of NULL ‘0’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 1527,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘add_p11_identity.part.0’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 1544,
                    "column": 32,
                    "event": "note",
                    "message": "(2) calling ‘dup_dest_constraints’ from ‘add_p11_identity.part.0’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 278,
                    "column": 1,
                    "event": "note",
                    "message": "(3) entry to ‘dup_dest_constraints’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 283,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following ‘false’ branch (when ‘ndcs != 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 285,
                    "column": 15,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 286,
                    "column": 23,
                    "event": "note",
                    "message": "(6) following ‘true’ branch (when ‘i < ndcs’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 287,
                    "column": 59,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 287,
                    "column": 17,
                    "event": "note",
                    "message": "(8) calling ‘dup_dest_constraint_hop’ from ‘dup_dest_constraints’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 254,
                    "column": 1,
                    "event": "note",
                    "message": "(9) entry to ‘dup_dest_constraint_hop’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 260,
                    "column": 46,
                    "event": "note",
                    "message": "(10) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 260,
                    "column": 19,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 261,
                    "column": 54,
                    "event": "note",
                    "message": "(12) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 261,
                    "column": 23,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 264,
                    "column": 44,
                    "event": "note",
                    "message": "(14) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 264,
                    "column": 19,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 266,
                    "column": 49,
                    "event": "note",
                    "message": "(16) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 266,
                    "column": 24,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 266,
                    "column": 24,
                    "event": "note",
                    "message": "(18) ‘0’ is NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 268,
                    "column": 23,
                    "event": "note",
                    "message": "(19) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 269,
                    "column": 24,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 269,
                    "column": 20,
                    "event": "note",
                    "message": "(21) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 273,
                    "column": 40,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 273,
                    "column": 20,
                    "event": "note",
                    "message": "(23) ‘0’ is NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 273,
                    "column": 31,
                    "event": "note",
                    "message": "(24) ‘0’ is NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-agent.c",
                    "line": 273,
                    "column": 35,
                    "event": "note",
                    "message": "(25) dereference of NULL ‘*out.key_is_ca + (long unsigned int)i * 4’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  271|   \t\t    &(out->keys[i]))) != 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  272|   \t\t\tfatal_fr(r, \"copy key\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  273|-> \t\tout->key_is_ca[i] = dch->key_is_ca[i];",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  274|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  275|   }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-ed25519.c",
                    "line": 176,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'ret' is used in the enclosing expression, the value is never actually read from 'ret'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/ssh-ed25519.c",
                    "line": 176,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'ret' is used in the enclosing expression, the value is never actually read from 'ret'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  174|   \t\treturn SSH_ERR_ALLOC_FAIL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  175|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  176|-> \tif ((ret = crypto_sign_ed25519(sig, &smlen, data, datalen,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  177|   \t    key->ed25519_sk)) != 0 || smlen <= datalen) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  178|   \t\tr = SSH_ERR_INVALID_ARGUMENT; /* XXX better error? */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-keycat.c",
                    "line": 39,
                    "column": 9,
                    "event": "warning",
                    "message": "\"_GNU_SOURCE\" redefined",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   39 | #define _GNU_SOURCE",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |         ^~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "<command-line>",
                    "line": 0,
                    "event": "note",
                    "message": "this is the location of the previous definition",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   37|   */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   38|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   39|-> #define _GNU_SOURCE",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   40|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   41|   #include \"config.h\"",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘do_convert_to_ssh2’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 364,
                    "column": 41,
                    "event": "warning[-Wformat-truncation=]",
                    "message": "‘%s’ directive output may be truncated writing up to 1024 bytes into a region of size 39",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  364 |             \"%u-bit %s, converted by %s@%s from OpenSSH\",",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                         ^~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  365 |             sshkey_size(k), sshkey_type(k),",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  366 |             pw->pw_name, hostname);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                          ~~~~~~~~        ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/bits/stdio2.h",
                    "line": 68,
                    "column": 10,
                    "event": "note",
                    "message": "‘__snprintf_chk’ output 36 or more bytes (assuming 1060) into a destination of size 61",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   68 |   return __builtin___snprintf_chk (__s, __n, __USE_FORTIFY_LEVEL - 1,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |          ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   69 |                                    __glibc_objsize (__s), __fmt,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   70 |                                    __va_arg_pack ());",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                    ~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  362|   \t/* Comment + surrounds must fit into 72 chars (RFC 4716 sec 3.3) */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  363|   \tsnprintf(comment, sizeof(comment),",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  364|-> \t    \"%u-bit %s, converted by %s@%s from OpenSSH\",",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  365|   \t    sshkey_size(k), sshkey_type(k),",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  366|   \t    pw->pw_name, hostname);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 437,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 437,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  435|   \tif (stat(identity_file, &st) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  436|   \t\tfatal(\"%s: %s: %s\", __progname, identity_file, strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  437|-> \tif ((r = sshkey_load_public(identity_file, &k, NULL)) != 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  438|   \t\tk = load_identity(identity_file, NULL);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  439|   \tswitch (convert_format) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 781,
                    "column": 8,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 781,
                    "column": 8,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  779|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  780|   \tif (!private) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  781|-> \t\tif ((r = sshkey_write(k, stdout)) == 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  782|   \t\t\tok = 1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  783|   \t\tif (ok)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 898,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 898,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  896|   \tif ((ret = sshkey_new(KEY_UNSPEC)) == NULL)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  897|   \t\tfatal(\"sshkey_new failed\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  898|-> \tif ((r = sshkey_read(ret, cpp)) == 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  899|   \t\treturn ret;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  900|   \t/* Not a key */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘do_gen_all_hostkeys’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 1135,
                    "column": 55,
                    "event": "warning[-Wformat-truncation=]",
                    "message": "‘%s’ directive output may be truncated writing up to 1024 bytes into a region of size 1023",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1135 |                 snprintf(comment, sizeof comment, \"%s@%s\", pw->pw_name,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                                       ^~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1136 |                     hostname);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                     ~~~~~~~~                           ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/bits/stdio2.h",
                    "line": 68,
                    "column": 10,
                    "event": "note",
                    "message": "‘__snprintf_chk’ output 2 or more bytes (assuming 1026) into a destination of size 1024",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   68 |   return __builtin___snprintf_chk (__s, __n, __USE_FORTIFY_LEVEL - 1,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |          ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   69 |                                    __glibc_objsize (__s), __fmt,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   70 |                                    __va_arg_pack ());",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                    ~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1133|   \t\tif ((r = sshkey_from_private(private, &public)) != 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1134|   \t\t\tfatal_fr(r, \"sshkey_from_private\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1135|-> \t\tsnprintf(comment, sizeof comment, \"%s@%s\", pw->pw_name,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1136|   \t\t    hostname);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1137|   \t\tif ((r = sshkey_save_private(private, prv_tmp, \"\",",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 2311,
                    "column": 46,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'was_hash' is used in the enclosing expression, the value is never actually read from 'was_hash'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 2311,
                    "column": 46,
                    "event": "note",
                    "message": "Although the value stored to 'was_hash' is used in the enclosing expression, the value is never actually read from 'was_hash'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2309|   \t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2310|   \t\tlnum++;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2311|-> \t\twas_explicit_key = was_sha1 = was_sha256 = was_hash = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2312|   \t\tcp = line + strspn(line, \" \\t\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2313|   \t\t/* Trim trailing space, comments and strip \\n */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 2488,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 2488,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2486|   \tif (ssh_krl_to_blob(krl, kbuf) != 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2487|   \t\tfatal(\"Couldn't generate KRL\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2488|-> \tif ((r = sshbuf_write_file(identity_file, kbuf)) != 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2489|   \t\tfatal(\"write %s: %s\", identity_file, strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2490|   \tsshbuf_free(kbuf);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 2773,
                    "column": 8,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 2773,
                    "column": 8,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2771|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2772|   \tif (argc == 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2773|-> \t\tif ((r = sign_one(signkey, \"(stdin)\", STDIN_FILENO,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2774|   \t\t    sig_namespace, hashalg, signer, &agent_fd)) != 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2775|   \t\t\tgoto done;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 2785,
                    "column": 9,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 2785,
                    "column": 9,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2783|   \t\t\t\tgoto done;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2784|   \t\t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2785|-> \t\t\tif ((r = sign_one(signkey, argv[i], fd, sig_namespace,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2786|   \t\t\t    hashalg, signer, &agent_fd)) != 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2787|   \t\t\t\tgoto done;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 2831,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 2831,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2829|   \t\tgoto done;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2830|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2831|-> \tif ((r = sshsig_verify_fd(sigbuf, STDIN_FILENO, sig_namespace,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2832|   \t    &sign_key, &sig_details)) != 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2833|   \t\tgoto done; /* sshsig_verify() prints error */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 3901,
                    "column": 8,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 3901,
                    "column": 8,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3899|   \t\tbreak;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3900|   \tdefault:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3901|-> \t\tif ((r = sshkey_generate(type, bits, &private)) != 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3902|   \t\t\tfatal(\"sshkey_generate failed\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3903|   \t\tbreak;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘main’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/ssh-keygen.c",
                    "line": 3924,
                    "column": 55,
                    "event": "warning[-Wformat-truncation=]",
                    "message": "‘%s’ directive output may be truncated writing up to 1024 bytes into a region of size 1023",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3924 |                 snprintf(comment, sizeof comment, \"%s@%s\", pw->pw_name, hostname);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                                       ^~                ~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/bits/stdio2.h",
                    "line": 68,
                    "column": 10,
                    "event": "note",
                    "message": "‘__snprintf_chk’ output 2 or more bytes (assuming 1026) into a destination of size 1024",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   68 |   return __builtin___snprintf_chk (__s, __n, __USE_FORTIFY_LEVEL - 1,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |          ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   69 |                                    __glibc_objsize (__s), __fmt,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   70 |                                    __va_arg_pack ());",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                    ~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3922|   \t} else {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3923|   \t\t/* Create default comment field for the passphrase. */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3924|-> \t\tsnprintf(comment, sizeof comment, \"%s@%s\", pw->pw_name, hostname);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3925|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 3926|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘pkcs11_start_helper’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 580,
                    "column": 20,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(pair[1], 0)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 549,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘pkcs11_start_helper’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 556,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 41,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 101,
                    "column": 33,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 558,
                    "column": 9,
                    "event": "note",
                    "message": "in expansion of macro ‘debug3_f’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 559,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 563,
                    "column": 18,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 564,
                    "column": 13,
                    "event": "note",
                    "message": "(6) calling ‘pkcs11_start_helper_methods’ from ‘pkcs11_start_helper’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 512,
                    "column": 1,
                    "event": "note",
                    "message": "(7) entry to ‘pkcs11_start_helper_methods’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 535,
                    "column": 12,
                    "event": "note",
                    "message": "(8) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 537,
                    "column": 30,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 538,
                    "column": 12,
                    "event": "note",
                    "message": "(10) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 539,
                    "column": 14,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 538,
                    "column": 64,
                    "event": "note",
                    "message": "(12) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 540,
                    "column": 14,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 539,
                    "column": 59,
                    "event": "note",
                    "message": "(14) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 543,
                    "column": 25,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 564,
                    "column": 13,
                    "event": "note",
                    "message": "(16) returning to ‘pkcs11_start_helper’ from ‘pkcs11_start_helper_methods’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 564,
                    "column": 12,
                    "event": "note",
                    "message": "(17) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 568,
                    "column": 20,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 568,
                    "column": 12,
                    "event": "note",
                    "message": "(19) following ‘false’ branch (when ‘pid != -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 579,
                    "column": 19,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 579,
                    "column": 19,
                    "event": "note",
                    "message": "(21) following ‘true’ branch (when ‘pid == 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 580,
                    "column": 22,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 580,
                    "column": 22,
                    "event": "note",
                    "message": "(23) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 580,
                    "column": 20,
                    "event": "note",
                    "message": "(24) ‘dup2(pair[1], 0)’ leaks here; was opened at (23)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  578|   \t\treturn NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  579|   \t} else if (pid == 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  580|-> \t\tif ((dup2(pair[1], STDIN_FILENO) == -1) ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  581|   \t\t    (dup2(pair[1], STDOUT_FILENO) == -1)) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  582|   \t\t\tfprintf(stderr, \"dup2: %s\\n\", strerror(errno));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 580,
                    "column": 57,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(pair[1], 1)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 549,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘pkcs11_start_helper’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 556,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 101,
                    "column": 33,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 558,
                    "column": 9,
                    "event": "note",
                    "message": "in expansion of macro ‘debug3_f’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 559,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 563,
                    "column": 18,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 564,
                    "column": 13,
                    "event": "note",
                    "message": "(6) calling ‘pkcs11_start_helper_methods’ from ‘pkcs11_start_helper’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 512,
                    "column": 1,
                    "event": "note",
                    "message": "(7) entry to ‘pkcs11_start_helper_methods’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 535,
                    "column": 12,
                    "event": "note",
                    "message": "(8) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 537,
                    "column": 30,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 538,
                    "column": 12,
                    "event": "note",
                    "message": "(10) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 539,
                    "column": 14,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 538,
                    "column": 64,
                    "event": "note",
                    "message": "(12) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 540,
                    "column": 14,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 539,
                    "column": 59,
                    "event": "note",
                    "message": "(14) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 543,
                    "column": 25,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 564,
                    "column": 13,
                    "event": "note",
                    "message": "(16) returning to ‘pkcs11_start_helper’ from ‘pkcs11_start_helper_methods’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 564,
                    "column": 12,
                    "event": "note",
                    "message": "(17) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 568,
                    "column": 20,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 568,
                    "column": 12,
                    "event": "note",
                    "message": "(19) following ‘false’ branch (when ‘pid != -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 579,
                    "column": 19,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 579,
                    "column": 19,
                    "event": "note",
                    "message": "(21) following ‘true’ branch (when ‘pid == 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 580,
                    "column": 22,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 580,
                    "column": 20,
                    "event": "note",
                    "message": "(23) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 581,
                    "column": 22,
                    "event": "note",
                    "message": "(24) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 581,
                    "column": 22,
                    "event": "note",
                    "message": "(25) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 580,
                    "column": 57,
                    "event": "note",
                    "message": "(26) ‘dup2(pair[1], 1)’ leaks here; was opened at (25)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  578|   \t\treturn NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  579|   \t} else if (pid == 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  580|-> \t\tif ((dup2(pair[1], STDIN_FILENO) == -1) ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  581|   \t\t    (dup2(pair[1], STDOUT_FILENO) == -1)) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  582|   \t\t\tfprintf(stderr, \"dup2: %s\\n\", strerror(errno));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 662,
                    "column": 8,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11-client.c",
                    "line": 662,
                    "column": 8,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  660|   \t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  661|   \t} else if (type == SSH2_AGENT_FAILURE) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  662|-> \t\tif ((r = sshbuf_get_u32(msg, &nkeys)) != 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  663|   \t\t\tnkeys = -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  664|   \t} else {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 688,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘pkcs11_provider_lookup_module’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 211,
                    "column": 22,
                    "event": "warning[-Wanalyzer-possible-null-argument]",
                    "message": "use of possibly-NULL ‘module_path’ where non-null expected",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2049,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to ‘pkcs11_add_provider’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2056,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2059,
                    "column": 13,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2059,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2060,
                    "column": 13,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2059,
                    "column": 62,
                    "event": "note",
                    "message": "(6) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2061,
                    "column": 21,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2061,
                    "column": 20,
                    "event": "note",
                    "message": "(8) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2067,
                    "column": 17,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2067,
                    "column": 17,
                    "event": "note",
                    "message": "(10) calling ‘pkcs11_add_provider_by_uri’ from ‘pkcs11_add_provider’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2020,
                    "column": 1,
                    "event": "note",
                    "message": "(11) entry to ‘pkcs11_add_provider_by_uri’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2029,
                    "column": 17,
                    "event": "note",
                    "message": "(12) calling ‘pkcs11_register_provider_by_uri’ from ‘pkcs11_add_provider_by_uri’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1879,
                    "column": 1,
                    "event": "note",
                    "message": "(13) entry to ‘pkcs11_register_provider_by_uri’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1890,
                    "column": 12,
                    "event": "note",
                    "message": "(14) following ‘false’ branch (when ‘providerp’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1892,
                    "column": 20,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1894,
                    "column": 12,
                    "event": "note",
                    "message": "(16) following ‘false’ branch (when ‘keyp’ is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1897,
                    "column": 20,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1897,
                    "column": 20,
                    "event": "note",
                    "message": "(18) calling ‘pkcs11_initialize_provider’ from ‘pkcs11_register_provider_by_uri’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1716,
                    "column": 1,
                    "event": "note",
                    "message": "(19) entry to ‘pkcs11_initialize_provider’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1731,
                    "column": 12,
                    "event": "note",
                    "message": "(20) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1733,
                    "column": 35,
                    "event": "note",
                    "message": "(21) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1733,
                    "column": 35,
                    "event": "note",
                    "message": "(22) this call could return NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1744,
                    "column": 12,
                    "event": "note",
                    "message": "(23) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1748,
                    "column": 18,
                    "event": "note",
                    "message": "(24) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1748,
                    "column": 18,
                    "event": "note",
                    "message": "(25) calling ‘pkcs11_provider_lookup_module’ from ‘pkcs11_initialize_provider’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 205,
                    "column": 1,
                    "event": "note",
                    "message": "(26) entry to ‘pkcs11_provider_lookup_module’",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 35,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sys-queue.h",
                    "line": 533,
                    "column": 19,
                    "event": "note",
                    "message": "(27) following ‘true’ branch (when ‘p’ is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 209,
                    "column": 9,
                    "event": "note",
                    "message": "in expansion of macro ‘TAILQ_FOREACH’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 45,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 210,
                    "column": 56,
                    "event": "note",
                    "message": "(28) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 91,
                    "column": 100,
                    "event": "note",
                    "message": "in definition of macro ‘debug’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 211,
                    "column": 22,
                    "event": "note",
                    "message": "(29) argument 1 (‘module_path’) from (22) could be NULL where non-null expected",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 32,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/string.h",
                    "line": 156,
                    "column": 12,
                    "event": "note",
                    "message": "argument 1 of ‘strcmp’ must be non-null",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  209|   \tTAILQ_FOREACH(p, &pkcs11_providers, next) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  210|   \t\tdebug(\"check %p %s (%s)\", p, p->name, p->module->module_path);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  211|-> \t\tif (!strcmp(module_path, p->module->module_path))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  212|   \t\t\treturn (p->module);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  213|   \t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1378,
                    "column": 28,
                    "event": "warning[core.NullDereference]",
                    "message": "Dereference of null pointer (loaded from variable 'keysp')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2056,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'uri' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2056,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2059,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2059,
                    "column": 55,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2067,
                    "column": 47,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'keyp'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2067,
                    "column": 10,
                    "event": "note",
                    "message": "Calling 'pkcs11_add_provider_by_uri'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2029,
                    "column": 52,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'keyp'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2029,
                    "column": 10,
                    "event": "note",
                    "message": "Calling 'pkcs11_register_provider_by_uri'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1890,
                    "column": 6,
                    "event": "note",
                    "message": "'providerp' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1890,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1894,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'keyp' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1894,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1897,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1902,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'pin' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1902,
                    "column": 18,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1906,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming 'i' is < field 'nslots'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1906,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1908,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1908,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1913,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'token' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1913,
                    "column": 26,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1920,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'manuf' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1920,
                    "column": 26,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1927,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'serial' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1927,
                    "column": 27,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1943,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming field 'session' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1943,
                    "column": 8,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1944,
                    "column": 58,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1948,
                    "column": 28,
                    "event": "note",
                    "message": "Passing null pointer value via 3rd parameter 'keysp'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1948,
                    "column": 3,
                    "event": "note",
                    "message": "Calling 'pkcs11_fetch_certs'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1312,
                    "column": 11,
                    "event": "note",
                    "message": "Field 'id' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1312,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1318,
                    "column": 11,
                    "event": "note",
                    "message": "Field 'object' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1318,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1329,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'rv' is equal to CKR_OK",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1329,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1334,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1338,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'rv' is equal to CKR_OK",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1338,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1342,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'n' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1342,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1352,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'rv' is equal to CKR_OK",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1352,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1359,
                    "column": 3,
                    "event": "note",
                    "message": "Control jumps to 'case 0:'  at line 1360",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1361,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1361,
                    "column": 4,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1366,
                    "column": 4,
                    "event": "note",
                    "message": " Execution continues on line 1372",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1373,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1378,
                    "column": 28,
                    "event": "note",
                    "message": "Dereference of null pointer (loaded from variable 'keysp')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1376|   \t\t} else {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1377|   \t\t\t/* expand key array and add key */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1378|-> \t\t\t*keysp = xrecallocarray(*keysp, *nkeys,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1379|   \t\t\t    *nkeys + 1, sizeof(struct sshkey *));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1380|   \t\t\t(*keysp)[*nkeys] = key;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1506,
                    "column": 28,
                    "event": "warning[core.NullDereference]",
                    "message": "Dereference of null pointer (loaded from variable 'keysp')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2056,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'uri' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2056,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2059,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2059,
                    "column": 55,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2067,
                    "column": 47,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'keyp'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2067,
                    "column": 10,
                    "event": "note",
                    "message": "Calling 'pkcs11_add_provider_by_uri'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2029,
                    "column": 52,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'keyp'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 2029,
                    "column": 10,
                    "event": "note",
                    "message": "Calling 'pkcs11_register_provider_by_uri'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1890,
                    "column": 6,
                    "event": "note",
                    "message": "'providerp' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1890,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1894,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'keyp' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1894,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1897,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1902,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'pin' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1902,
                    "column": 18,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1906,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming 'i' is < field 'nslots'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1906,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1908,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1908,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1913,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'token' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1913,
                    "column": 26,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1920,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'manuf' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1920,
                    "column": 26,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1927,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'serial' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1927,
                    "column": 27,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1943,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming field 'session' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1943,
                    "column": 8,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1944,
                    "column": 58,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1947,
                    "column": 27,
                    "event": "note",
                    "message": "Passing null pointer value via 3rd parameter 'keysp'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1947,
                    "column": 3,
                    "event": "note",
                    "message": "Calling 'pkcs11_fetch_keys'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1430,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'id' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1430,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1436,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'object' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1436,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1447,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'rv' is equal to CKR_OK",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1447,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1452,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1457,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'rv' is equal to CKR_OK",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1457,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1461,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'n' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1461,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1474,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'rv' is equal to CKR_OK",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1474,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1481,
                    "column": 3,
                    "event": "note",
                    "message": "Control jumps to the 'default' case at line 1490",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1496,
                    "column": 7,
                    "event": "note",
                    "message": "'key' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1496,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1498,
                    "column": 4,
                    "event": "note",
                    "message": " Execution continues on line 1452",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1452,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1457,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'rv' is equal to CKR_OK",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1457,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1461,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'n' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1461,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1474,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'rv' is equal to CKR_OK",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1474,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1481,
                    "column": 3,
                    "event": "note",
                    "message": "Control jumps to the 'default' case at line 1490",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1496,
                    "column": 7,
                    "event": "note",
                    "message": "'key' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1496,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1498,
                    "column": 4,
                    "event": "note",
                    "message": " Execution continues on line 1452",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1452,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1457,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'rv' is equal to CKR_OK",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1457,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1461,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'n' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1461,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1474,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'rv' is equal to CKR_OK",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1474,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1481,
                    "column": 3,
                    "event": "note",
                    "message": "Control jumps to 'case 0:'  at line 1482",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1484,
                    "column": 4,
                    "event": "note",
                    "message": " Execution continues on line 1496",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1496,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'key' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1496,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1501,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1506,
                    "column": 28,
                    "event": "note",
                    "message": "Dereference of null pointer (loaded from variable 'keysp')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1504|   \t\t} else {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1505|   \t\t\t/* expand key array and add key */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1506|-> \t\t\t*keysp = xrecallocarray(*keysp, *nkeys,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1507|   \t\t\t    *nkeys + 1, sizeof(struct sshkey *));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1508|   \t\t\t(*keysp)[*nkeys] = key;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1944,
                    "column": 8,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'ret' is used in the enclosing expression, the value is never actually read from 'ret'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1944,
                    "column": 8,
                    "event": "note",
                    "message": "Although the value stored to 'ret' is used in the enclosing expression, the value is never actually read from 'ret'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1942|   \t\t */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1943|   \t\tif ((p->module->slotinfo[i].session != 0 ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1944|-> \t\t    (ret = pkcs11_open_session(p, i, pin, user)) != 0) && /* ??? */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1945|   \t\t    keyp == NULL)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1946|   \t\t\tcontinue;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 1164,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-pkcs11.c",
                    "line": 1993,
                    "column": 1,
                    "event": "warning[-Wunused-function]",
                    "message": "‘pkcs11_register_provider’ defined but not used",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1993 | pkcs11_register_provider(char *provider_id, char *pin, struct sshkey ***keyp,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      | ^~~~~~~~~~~~~~~~~~~~~~~~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1991|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1992|   static int",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1993|-> pkcs11_register_provider(char *provider_id, char *pin, struct sshkey ***keyp,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1994|       char ***labelsp, struct pkcs11_provider **providerp, CK_ULONG user)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1995|   {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘start_helper’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 87,
                    "column": 20,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(pair[1], 0)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 61,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 72,
                    "column": 13,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 72,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 76,
                    "column": 20,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 77,
                    "column": 12,
                    "event": "note",
                    "message": "(5) following ‘false’ branch (when ‘pid != -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 86,
                    "column": 12,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 86,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘true’ branch (when ‘pid == 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 87,
                    "column": 22,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 87,
                    "column": 22,
                    "event": "note",
                    "message": "(9) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 87,
                    "column": 20,
                    "event": "note",
                    "message": "(10) ‘dup2(pair[1], 0)’ leaks here; was opened at (9)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   85|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   86|   \tif (pid == 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   87|-> \t\tif ((dup2(pair[1], STDIN_FILENO) == -1) ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   88|   \t\t    (dup2(pair[1], STDOUT_FILENO) == -1)) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   89|   \t\t\terror_f(\"dup2: %s\", strerror(errno));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 87,
                    "column": 57,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(pair[1], 1)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 61,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 72,
                    "column": 13,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 72,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 76,
                    "column": 20,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 77,
                    "column": 12,
                    "event": "note",
                    "message": "(5) following ‘false’ branch (when ‘pid != -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 86,
                    "column": 12,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 86,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘true’ branch (when ‘pid == 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 87,
                    "column": 22,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 87,
                    "column": 20,
                    "event": "note",
                    "message": "(9) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 88,
                    "column": 22,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 88,
                    "column": 22,
                    "event": "note",
                    "message": "(11) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh-sk-client.c",
                    "line": 87,
                    "column": 57,
                    "event": "note",
                    "message": "(12) ‘dup2(pair[1], 1)’ leaks here; was opened at (11)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   85|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   86|   \tif (pid == 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   87|-> \t\tif ((dup2(pair[1], STDIN_FILENO) == -1) ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   88|   \t\t    (dup2(pair[1], STDOUT_FILENO) == -1)) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   89|   \t\t\terror_f(\"dup2: %s\", strerror(errno));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 159,
                    "column": 3,
                    "event": "warning[unix.Malloc]",
                    "message": "Use of memory after it is freed",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sys-queue.h",
                    "line": 597,
                    "column": 6,
                    "event": "note",
                    "message": "expanded from macro 'TAILQ_REMOVE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 90,
                    "column": 7,
                    "event": "note",
                    "message": "'called' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 90,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 95,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 95,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 97,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'is_server' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 97,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 101,
                    "column": 13,
                    "event": "note",
                    "message": "Assuming 'kex_params' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 101,
                    "column": 13,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 102,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 102,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 103,
                    "column": 3,
                    "event": "note",
                    "message": "Calling 'ssh_free'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 151,
                    "column": 6,
                    "event": "note",
                    "message": "'ssh' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 151,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 158,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 158,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 159,
                    "column": 3,
                    "event": "note",
                    "message": "Assuming field 'tqe_next' is equal to null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sys-queue.h",
                    "line": 597,
                    "column": 6,
                    "event": "note",
                    "message": "expanded from macro 'TAILQ_REMOVE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 159,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sys-queue.h",
                    "line": 597,
                    "column": 2,
                    "event": "note",
                    "message": "expanded from macro 'TAILQ_REMOVE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 159,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sys-queue.h",
                    "line": 596,
                    "column": 40,
                    "event": "note",
                    "message": "expanded from macro 'TAILQ_REMOVE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 160,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'kex' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 160,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 162,
                    "column": 3,
                    "event": "note",
                    "message": "Memory is released",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 158,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 159,
                    "column": 3,
                    "event": "note",
                    "message": "Use of memory after it is freed",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sys-queue.h",
                    "line": 597,
                    "column": 6,
                    "event": "note",
                    "message": "expanded from macro 'TAILQ_REMOVE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  157|   \t */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  158|   \twhile ((k = TAILQ_FIRST(&ssh->public_keys)) != NULL) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  159|-> \t\tTAILQ_REMOVE(&ssh->public_keys, k, next);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  160|   \t\tif (ssh->kex && ssh->kex->server)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  161|   \t\t\tsshkey_free(k->key);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 165,
                    "column": 3,
                    "event": "warning[unix.Malloc]",
                    "message": "Use of memory after it is freed",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sys-queue.h",
                    "line": 597,
                    "column": 6,
                    "event": "note",
                    "message": "expanded from macro 'TAILQ_REMOVE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 90,
                    "column": 7,
                    "event": "note",
                    "message": "'called' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 90,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 95,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 95,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 97,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'is_server' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 97,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 101,
                    "column": 13,
                    "event": "note",
                    "message": "Assuming 'kex_params' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 101,
                    "column": 13,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 102,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 102,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 103,
                    "column": 3,
                    "event": "note",
                    "message": "Calling 'ssh_free'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 151,
                    "column": 6,
                    "event": "note",
                    "message": "'ssh' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 151,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 158,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 158,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 164",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 164,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 164,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 165,
                    "column": 3,
                    "event": "note",
                    "message": "Assuming field 'tqe_next' is equal to null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sys-queue.h",
                    "line": 597,
                    "column": 6,
                    "event": "note",
                    "message": "expanded from macro 'TAILQ_REMOVE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 165,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sys-queue.h",
                    "line": 597,
                    "column": 2,
                    "event": "note",
                    "message": "expanded from macro 'TAILQ_REMOVE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 165,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sys-queue.h",
                    "line": 596,
                    "column": 40,
                    "event": "note",
                    "message": "expanded from macro 'TAILQ_REMOVE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 166,
                    "column": 3,
                    "event": "note",
                    "message": "Memory is released",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 164,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/ssh_api.c",
                    "line": 165,
                    "column": 3,
                    "event": "note",
                    "message": "Use of memory after it is freed",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sys-queue.h",
                    "line": 597,
                    "column": 6,
                    "event": "note",
                    "message": "expanded from macro 'TAILQ_REMOVE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  163|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  164|   \twhile ((k = TAILQ_FIRST(&ssh->private_keys)) != NULL) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  165|-> \t\tTAILQ_REMOVE(&ssh->private_keys, k, next);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  166|   \t\tfree(k);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  167|   \t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshbuf-getput-basic.c",
                    "line": 289,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf-getput-basic.c",
                    "line": 289,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  287|   \t\treturn SSH_ERR_INVALID_FORMAT;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  288|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  289|-> \tif ((r = sshbuf_skip_string(buf)) != 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  290|   \t\treturn -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  291|   \tif (valp != NULL) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshbuf-getput-basic.c",
                    "line": 378,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf-getput-basic.c",
                    "line": 378,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  376|   \tif ((r = sshbuf_reserve(buf, (size_t)len + 1, &p)) < 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  377|   \t\tgoto out;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  378|-> \tif ((r = vsnprintf((char *)p, len + 1, fmt, ap2)) != len) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  379|   \t\tr = SSH_ERR_INTERNAL_ERROR;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  380|   \t\tgoto out; /* Shouldn't happen */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 1341,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshbuf-io.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sshbuf_write_file’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf-io.c",
                    "line": 110,
                    "column": 17,
                    "event": "warning[-Wanalyzer-fd-double-close]",
                    "message": "double ‘close’ of file descriptor ‘open(path, 577, 420)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf-io.c",
                    "line": 105,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf-io.c",
                    "line": 107,
                    "column": 13,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf-io.c",
                    "line": 107,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf-io.c",
                    "line": 108,
                    "column": 52,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf-io.c",
                    "line": 108,
                    "column": 52,
                    "event": "note",
                    "message": "(5) first ‘close’ here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf-io.c",
                    "line": 108,
                    "column": 49,
                    "event": "note",
                    "message": "(6) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/includes.h",
                    "line": 154,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf-io.c",
                    "line": 18,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf-io.c",
                    "line": 109,
                    "column": 26,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf-io.c",
                    "line": 110,
                    "column": 17,
                    "event": "note",
                    "message": "(8) second ‘close’ here; first ‘close’ was at (5)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  108|   \t    sshbuf_len(buf)) != sshbuf_len(buf) || close(fd) != 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  109|   \t\toerrno = errno;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  110|-> \t\tclose(fd);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  111|   \t\tunlink(path);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  112|   \t\terrno = oerrno;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshbuf-misc.c",
                    "line": 291,
                    "column": 8,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf-misc.c",
                    "line": 291,
                    "column": 8,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  289|   \t/* Adjust the buffer to include only what was actually read */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  290|   \tif ((adjust = maxlen - (rr > 0 ? rr : 0)) != 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  291|-> \t\tif ((r = sshbuf_consume_end(buf, adjust)) != 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  292|   \t\t\t/* avoid returning uninitialised data to caller */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  293|   \t\t\tmemset(d + rr, '\\0', adjust);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sshbuf_new’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 96,
                    "column": 33,
                    "event": "warning[-Wcalloc-transposed-args]",
                    "message": "‘calloc’ sizes specified with ‘sizeof’ in the earlier argument and not in the later argument",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   96 |         if ((ret = calloc(sizeof(*ret), 1)) == NULL)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                 ^",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 96,
                    "column": 33,
                    "event": "note",
                    "message": "earlier argument should specify number of elements, later size of each element",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   94|   \tstruct sshbuf *ret;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   95|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   96|-> \tif ((ret = calloc(sizeof(*ret), 1)) == NULL)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   97|   \t\treturn NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   98|   \tret->alloc = SSHBUF_SIZE_INIT;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sshbuf_from’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 116,
                    "column": 33,
                    "event": "warning[-Wcalloc-transposed-args]",
                    "message": "‘calloc’ sizes specified with ‘sizeof’ in the earlier argument and not in the later argument",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  116 |             (ret = calloc(sizeof(*ret), 1)) == NULL)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                                 ^",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 116,
                    "column": 33,
                    "event": "note",
                    "message": "earlier argument should specify number of elements, later size of each element",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  114|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  115|   \tif (blob == NULL || len > SSHBUF_SIZE_MAX ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  116|-> \t    (ret = calloc(sizeof(*ret), 1)) == NULL)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  117|   \t\treturn NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  118|   \tret->alloc = ret->size = ret->max_size = len;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 153,
                    "column": 3,
                    "event": "warning[unix.Malloc]",
                    "message": "Potential leak of memory pointed to by 'ret'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 147,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 147,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 149,
                    "column": 13,
                    "event": "note",
                    "message": "Calling 'sshbuf_from'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 115,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'blob' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 115,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 115,
                    "column": 22,
                    "event": "note",
                    "message": "'len' is <= SSHBUF_SIZE_MAX",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 115,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 116,
                    "column": 13,
                    "event": "note",
                    "message": "Memory is allocated",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 116,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 115,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 149,
                    "column": 13,
                    "event": "note",
                    "message": "Returned allocated memory",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 149,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 151,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 152,
                    "column": 3,
                    "event": "note",
                    "message": "Calling 'sshbuf_free'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 161,
                    "column": 6,
                    "event": "note",
                    "message": "'buf' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 161,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 169,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 169,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 170,
                    "column": 3,
                    "event": "note",
                    "message": "Returning without deallocating memory or storing the pointer for later deallocation",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 152,
                    "column": 3,
                    "event": "note",
                    "message": "Returning from 'sshbuf_free'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshbuf.c",
                    "line": 153,
                    "column": 3,
                    "event": "note",
                    "message": "Potential leak of memory pointed to by 'ret'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  151|   \tif (sshbuf_set_parent(ret, buf) != 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  152|   \t\tsshbuf_free(ret);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  153|-> \t\treturn NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  154|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  155|   \treturn ret;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 396,
                    "column": 8,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 396,
                    "column": 8,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  394|   \t} else if (options.bind_interface != NULL) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  395|   #ifdef HAVE_IFADDRS_H",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  396|-> \t\tif ((r = getifaddrs(&ifaddrs)) != 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  397|   \t\t\terror(\"getifaddrs: %s: %s\", options.bind_interface,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  398|   \t\t\t    strerror(errno));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1050,
                    "column": 36,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'key' results in a dereference of a null pointer (loaded from variable 'host_found')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 962,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'no_host_authentication_for_localhost' is not equal to 1",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 962,
                    "column": 56,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 975,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 975,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 986,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'clobber_port' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 986,
                    "column": 6,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 992,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'check_host_ip' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 992,
                    "column": 28,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 997,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming 'i' is < 'num_user_hostfiles'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 997,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 997,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming 'i' is >= 'num_user_hostfiles'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 997,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 999",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 999,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming 'i' is >= 'num_system_hostfiles'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 999,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1001",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1001,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'hostfile_command' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1001,
                    "column": 31,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1007,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'want_cert' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1007,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1007,
                    "column": 20,
                    "event": "note",
                    "message": "Assuming field 'check_host_ip' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1007,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1009,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1009,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1011",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1011,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1013",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1013,
                    "column": 7,
                    "event": "note",
                    "message": "'hostfile_command' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1013,
                    "column": 32,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1028,
                    "column": 16,
                    "event": "note",
                    "message": "Value assigned to 'host_found'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1035,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'readonly' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1035,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1035,
                    "column": 20,
                    "event": "note",
                    "message": "'num_user_hostfiles' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1035,
                    "column": 20,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1036,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'host_found' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1036,
                    "column": 26,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1044,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'want_cert' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1044,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1044,
                    "column": 20,
                    "event": "note",
                    "message": "Assuming 'ip_hostkeys' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1044,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1047,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'host_status' is equal to HOST_CHANGED",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1047,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1048,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming 'ip_status' is equal to HOST_CHANGED",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1048,
                    "column": 8,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1049,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming 'ip_found' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1049,
                    "column": 8,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1050,
                    "column": 36,
                    "event": "note",
                    "message": "Access to field 'key' results in a dereference of a null pointer (loaded from variable 'host_found')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1048|   \t\t    (ip_status != HOST_CHANGED ||",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1049|   \t\t    (ip_found != NULL &&",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1050|-> \t\t    !sshkey_equal(ip_found->key, host_found->key))))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1051|   \t\t\thost_ip_differ = 1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1052|   \t} else",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1061,
                    "column": 7,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'file' results in a dereference of a null pointer (loaded from variable 'host_found')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 91,
                    "column": 88,
                    "event": "note",
                    "message": "expanded from macro 'debug'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 962,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'no_host_authentication_for_localhost' is not equal to 1",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 962,
                    "column": 56,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 975,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 975,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 986,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'clobber_port' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 986,
                    "column": 6,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 992,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'check_host_ip' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 992,
                    "column": 28,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 997,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming 'i' is < 'num_user_hostfiles'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 997,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 997,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming 'i' is >= 'num_user_hostfiles'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 997,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 999",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 999,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming 'i' is >= 'num_system_hostfiles'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 999,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1001",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1001,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'hostfile_command' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1001,
                    "column": 31,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1007,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'want_cert' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1007,
                    "column": 17,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1028,
                    "column": 16,
                    "event": "note",
                    "message": "Value assigned to 'host_found'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1035,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'readonly' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1035,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1035,
                    "column": 20,
                    "event": "note",
                    "message": "'num_user_hostfiles' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1035,
                    "column": 20,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1036,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'host_found' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1036,
                    "column": 26,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1044,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'want_cert' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1044,
                    "column": 17,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1055,
                    "column": 2,
                    "event": "note",
                    "message": "Control jumps to 'case HOST_OK:'  at line 1056",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1059,
                    "column": 19,
                    "event": "note",
                    "message": "'want_cert' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 91,
                    "column": 88,
                    "event": "note",
                    "message": "expanded from macro 'debug'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1059,
                    "column": 19,
                    "event": "note",
                    "message": "'?' condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1060,
                    "column": 31,
                    "event": "note",
                    "message": "'want_cert' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 91,
                    "column": 88,
                    "event": "note",
                    "message": "expanded from macro 'debug'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1060,
                    "column": 31,
                    "event": "note",
                    "message": "'?' condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1061,
                    "column": 7,
                    "event": "note",
                    "message": "Access to field 'file' results in a dereference of a null pointer (loaded from variable 'host_found')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 91,
                    "column": 88,
                    "event": "note",
                    "message": "expanded from macro 'debug'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1059|   \t\t    host, type, want_cert ? \"certificate\" : \"key\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1060|   \t\tdebug(\"Found %s in %s:%lu\", want_cert ? \"CA key\" : \"key\",",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1061|-> \t\t    host_found->file, host_found->line);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1062|   \t\tif (want_cert) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1063|   \t\t\tif (sshkey_cert_check_host(host_key,",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1259,
                    "column": 8,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'file' results in a dereference of a null pointer (loaded from variable 'host_found')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 91,
                    "column": 88,
                    "event": "note",
                    "message": "expanded from macro 'debug'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 962,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'no_host_authentication_for_localhost' is not equal to 1",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 962,
                    "column": 56,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 975,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 975,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 986,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'clobber_port' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 986,
                    "column": 6,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 992,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'check_host_ip' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 992,
                    "column": 28,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 997,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming 'i' is < 'num_user_hostfiles'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 997,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 997,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming 'i' is >= 'num_user_hostfiles'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 997,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 999",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 999,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming 'i' is >= 'num_system_hostfiles'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 999,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1001",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1001,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'hostfile_command' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1001,
                    "column": 31,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1007,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'want_cert' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1007,
                    "column": 17,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1028,
                    "column": 16,
                    "event": "note",
                    "message": "Value assigned to 'host_found'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1035,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'readonly' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1035,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1035,
                    "column": 20,
                    "event": "note",
                    "message": "'num_user_hostfiles' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1035,
                    "column": 20,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1036,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'host_found' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1036,
                    "column": 26,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1044,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'want_cert' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1044,
                    "column": 17,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1055,
                    "column": 2,
                    "event": "note",
                    "message": "Control jumps to 'case HOST_CHANGED:'  at line 1250",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1251,
                    "column": 7,
                    "event": "note",
                    "message": "'want_cert' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1251,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1259,
                    "column": 8,
                    "event": "note",
                    "message": "Access to field 'file' results in a dereference of a null pointer (loaded from variable 'host_found')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 91,
                    "column": 88,
                    "event": "note",
                    "message": "expanded from macro 'debug'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1257|   \t\t\tdebug(\"Host certificate authority does not \"",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1258|   \t\t\t    \"match %s in %s:%lu\", CA_MARKER,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1259|-> \t\t\t    host_found->file, host_found->line);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1260|   \t\t\tgoto fail;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1261|   \t\t}",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1292,
                    "column": 19,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'key' results in a dereference of a null pointer (loaded from variable 'host_found')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 94,
                    "column": 87,
                    "event": "note",
                    "message": "expanded from macro 'error'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 962,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'no_host_authentication_for_localhost' is not equal to 1",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 962,
                    "column": 56,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 975,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 975,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 986,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'clobber_port' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 986,
                    "column": 6,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 992,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'check_host_ip' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 992,
                    "column": 28,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 997,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming 'i' is < 'num_user_hostfiles'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 997,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 997,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming 'i' is >= 'num_user_hostfiles'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 997,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 999",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 999,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming 'i' is >= 'num_system_hostfiles'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 999,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1001",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1001,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'hostfile_command' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1001,
                    "column": 31,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1007,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'want_cert' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1007,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1007,
                    "column": 20,
                    "event": "note",
                    "message": "Assuming field 'check_host_ip' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1007,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1009,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1009,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1011",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1011,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1013",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1013,
                    "column": 7,
                    "event": "note",
                    "message": "'hostfile_command' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1013,
                    "column": 32,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1028,
                    "column": 16,
                    "event": "note",
                    "message": "Value assigned to 'host_found'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1035,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'readonly' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1035,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1035,
                    "column": 20,
                    "event": "note",
                    "message": "'num_user_hostfiles' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1035,
                    "column": 20,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1036,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'host_found' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1036,
                    "column": 26,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1044,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'want_cert' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1044,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1044,
                    "column": 20,
                    "event": "note",
                    "message": "Assuming 'ip_hostkeys' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1044,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1047,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'host_status' is equal to HOST_CHANGED",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1047,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1048,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming 'ip_status' is equal to HOST_CHANGED",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1048,
                    "column": 8,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1049,
                    "column": 8,
                    "event": "note",
                    "message": "Assuming 'ip_found' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1049,
                    "column": 25,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1055,
                    "column": 2,
                    "event": "note",
                    "message": "Control jumps to 'case HOST_CHANGED:'  at line 1250",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1251,
                    "column": 7,
                    "event": "note",
                    "message": "'want_cert' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1251,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1262,
                    "column": 7,
                    "event": "note",
                    "message": "'readonly' is not equal to ROQUIET",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1262,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1264,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'check_host_ip' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1264,
                    "column": 29,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1286,
                    "column": 7,
                    "event": "note",
                    "message": "'num_user_hostfiles' is > 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1286,
                    "column": 30,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1288,
                    "column": 28,
                    "event": "note",
                    "message": "'num_user_hostfiles' is > 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 94,
                    "column": 87,
                    "event": "note",
                    "message": "expanded from macro 'error'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1288,
                    "column": 28,
                    "event": "note",
                    "message": "'?' condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1292,
                    "column": 19,
                    "event": "note",
                    "message": "Access to field 'key' results in a dereference of a null pointer (loaded from variable 'host_found')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 94,
                    "column": 87,
                    "event": "note",
                    "message": "expanded from macro 'error'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1290|   \t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1291|   \t\terror(\"Offending %s key in %s:%lu\",",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1292|-> \t\t    sshkey_type(host_found->key),",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1293|   \t\t    host_found->file, host_found->line);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1294|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1708,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect.c",
                    "line": 1708,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1706|   \t\treturn;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1707|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1708|-> \tif ((r = ssh_get_authentication_socket(&auth_sock)) != 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1709|   \t\tdebug3(\"no authentication agent, not adding key\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1710|   \t\treturn;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 1677,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 1677,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1675|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1676|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1677|-> \tif ((r = sshkey_to_blob(id->key, &blob, &bloblen)) != 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1678|   \t\t/* we cannot handle this key */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1679|   \t\tdebug3_f(\"cannot handle key\");",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 1912,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 1912,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1910|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1911|   \t/* list of keys supported by the agent */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1912|-> \tif ((r = get_agent_identities(ssh, &agent_fd, &idlist)) == 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1913|   \t\tfor (j = 0; j < idlist->nkeys; j++) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1914|   \t\t\tif ((r = sshkey_check_rsa_length(idlist->keys[j],",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2022,
                    "column": 3,
                    "event": "warning[unix.Malloc]",
                    "message": "Use of memory after it is freed",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sys-queue.h",
                    "line": 597,
                    "column": 6,
                    "event": "note",
                    "message": "expanded from macro 'TAILQ_REMOVE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 534,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'preferred_authentications' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 534,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 557,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'method' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 557,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 560,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 560,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 561,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 560,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 562,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 560,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 570,
                    "column": 2,
                    "event": "note",
                    "message": "Calling 'pubkey_cleanup'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2016,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2016,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2020,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2022,
                    "column": 3,
                    "event": "note",
                    "message": "Assuming field 'tqe_next' is equal to null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sys-queue.h",
                    "line": 597,
                    "column": 6,
                    "event": "note",
                    "message": "expanded from macro 'TAILQ_REMOVE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2022,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sys-queue.h",
                    "line": 597,
                    "column": 2,
                    "event": "note",
                    "message": "expanded from macro 'TAILQ_REMOVE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2022,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sys-queue.h",
                    "line": 596,
                    "column": 40,
                    "event": "note",
                    "message": "expanded from macro 'TAILQ_REMOVE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2025,
                    "column": 3,
                    "event": "note",
                    "message": "Memory is released",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2020,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2022,
                    "column": 3,
                    "event": "note",
                    "message": "Use of memory after it is freed",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/openbsd-compat/sys-queue.h",
                    "line": 597,
                    "column": 6,
                    "event": "note",
                    "message": "expanded from macro 'TAILQ_REMOVE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2020|   \tfor (id = TAILQ_FIRST(&authctxt->keys); id;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2021|   \t    id = TAILQ_FIRST(&authctxt->keys)) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2022|-> \t\tTAILQ_REMOVE(&authctxt->keys, id, next);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2023|   \t\tsshkey_free(id->key);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2024|   \t\tfree(id->filename);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2211,
                    "column": 24,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘from[0]’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2209,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2213,
                    "column": 13,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2213,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 13,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 13,
                    "event": "note",
                    "message": "(5) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 12,
                    "event": "note",
                    "message": "(6) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 13,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 13,
                    "event": "note",
                    "message": "(8) opened here as read-write",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 13,
                    "event": "note",
                    "message": "(9) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 12,
                    "event": "note",
                    "message": "(10) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2225,
                    "column": 20,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2225,
                    "column": 12,
                    "event": "note",
                    "message": "(12) following ‘true’ branch (when ‘pid == -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2226,
                    "column": 46,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 106,
                    "column": 99,
                    "event": "note",
                    "message": "in definition of macro ‘error_f’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2211,
                    "column": 24,
                    "event": "note",
                    "message": "(14) ‘from[0]’ leaks here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2209|   \tif (stat(_PATH_SSH_KEY_SIGN, &st) == -1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2210|   \t\terror_f(\"not installed: %s\", strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2211|-> \t\treturn -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2212|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2213|   \tif (fflush(stdout) != 0) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2211,
                    "column": 24,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘from[1]’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2209,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2213,
                    "column": 13,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2213,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 13,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 13,
                    "event": "note",
                    "message": "(5) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 12,
                    "event": "note",
                    "message": "(6) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 13,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 13,
                    "event": "note",
                    "message": "(8) opened here as read-write",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 13,
                    "event": "note",
                    "message": "(9) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 12,
                    "event": "note",
                    "message": "(10) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2225,
                    "column": 20,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2225,
                    "column": 12,
                    "event": "note",
                    "message": "(12) following ‘true’ branch (when ‘pid == -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2226,
                    "column": 46,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 106,
                    "column": 99,
                    "event": "note",
                    "message": "in definition of macro ‘error_f’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2211,
                    "column": 24,
                    "event": "note",
                    "message": "(14) ‘from[1]’ leaks here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2209|   \tif (stat(_PATH_SSH_KEY_SIGN, &st) == -1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2210|   \t\terror_f(\"not installed: %s\", strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2211|-> \t\treturn -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2212|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2213|   \tif (fflush(stdout) != 0) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘ssh_keysign’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2211,
                    "column": 24,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘to[0]’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2209,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2213,
                    "column": 13,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2213,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 13,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 13,
                    "event": "note",
                    "message": "(5) opened here as read-write",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 13,
                    "event": "note",
                    "message": "(6) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 13,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 13,
                    "event": "note",
                    "message": "(9) when ‘pipe’ fails",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 12,
                    "event": "note",
                    "message": "(10) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 65,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2222,
                    "column": 46,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 106,
                    "column": 99,
                    "event": "note",
                    "message": "in definition of macro ‘error_f’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2211,
                    "column": 24,
                    "event": "note",
                    "message": "(12) ‘to[0]’ leaks here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2209|   \tif (stat(_PATH_SSH_KEY_SIGN, &st) == -1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2210|   \t\terror_f(\"not installed: %s\", strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2211|-> \t\treturn -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2212|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2213|   \tif (fflush(stdout) != 0) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2211,
                    "column": 24,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘to[1]’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2209,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2213,
                    "column": 13,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2213,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 13,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 13,
                    "event": "note",
                    "message": "(5) opened here as read-write",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 13,
                    "event": "note",
                    "message": "(6) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 12,
                    "event": "note",
                    "message": "(7) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 13,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 13,
                    "event": "note",
                    "message": "(9) when ‘pipe’ fails",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 12,
                    "event": "note",
                    "message": "(10) following ‘true’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2222,
                    "column": 46,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/log.h",
                    "line": 106,
                    "column": 99,
                    "event": "note",
                    "message": "in definition of macro ‘error_f’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2211,
                    "column": 24,
                    "event": "note",
                    "message": "(12) ‘to[1]’ leaks here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2209|   \tif (stat(_PATH_SSH_KEY_SIGN, &st) == -1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2210|   \t\terror_f(\"not installed: %s\", strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2211|-> \t\treturn -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2212|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2213|   \tif (fflush(stdout) != 0) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2232,
                    "column": 20,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(from[1], 1)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2209,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2213,
                    "column": 13,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2213,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 13,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 13,
                    "event": "note",
                    "message": "(5) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 12,
                    "event": "note",
                    "message": "(6) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 13,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 13,
                    "event": "note",
                    "message": "(8) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 12,
                    "event": "note",
                    "message": "(9) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2225,
                    "column": 20,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2225,
                    "column": 12,
                    "event": "note",
                    "message": "(11) following ‘false’ branch (when ‘pid != -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2229,
                    "column": 20,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2230,
                    "column": 12,
                    "event": "note",
                    "message": "(13) following ‘true’ branch (when ‘pid == 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2231,
                    "column": 17,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2232,
                    "column": 21,
                    "event": "note",
                    "message": "(15) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2232,
                    "column": 20,
                    "event": "note",
                    "message": "(16) ‘dup2(from[1], 1)’ leaks here; was opened at (15)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2230|   \tif (pid == 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2231|   \t\tclose(from[0]);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2232|-> \t\tif (dup2(from[1], STDOUT_FILENO) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2233|   \t\t\tfatal_f(\"dup2: %s\", strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2234|   \t\tclose(to[1]);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2235,
                    "column": 20,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(to[0], 0)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2209,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2213,
                    "column": 13,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2213,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 13,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 13,
                    "event": "note",
                    "message": "(5) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 12,
                    "event": "note",
                    "message": "(6) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 13,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 13,
                    "event": "note",
                    "message": "(8) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 12,
                    "event": "note",
                    "message": "(9) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2225,
                    "column": 20,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2225,
                    "column": 12,
                    "event": "note",
                    "message": "(11) following ‘false’ branch (when ‘pid != -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2229,
                    "column": 20,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2230,
                    "column": 12,
                    "event": "note",
                    "message": "(13) following ‘true’ branch (when ‘pid == 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2231,
                    "column": 17,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2232,
                    "column": 20,
                    "event": "note",
                    "message": "(15) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2234,
                    "column": 17,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2235,
                    "column": 21,
                    "event": "note",
                    "message": "(17) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2235,
                    "column": 20,
                    "event": "note",
                    "message": "(18) ‘dup2(to[0], 0)’ leaks here; was opened at (17)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2233|   \t\t\tfatal_f(\"dup2: %s\", strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2234|   \t\tclose(to[1]);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2235|-> \t\tif (dup2(to[0], STDIN_FILENO) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2236|   \t\t\tfatal_f(\"dup2: %s\", strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2237|   \t\tclose(from[1]);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 775,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2240,
                    "column": 20,
                    "event": "warning[-Wanalyzer-fd-leak]",
                    "message": "leak of file descriptor ‘dup2(ssh_packet_get_connection_in(ssh), 3)’",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2209,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2213,
                    "column": 13,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2213,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 13,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 13,
                    "event": "note",
                    "message": "(5) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2217,
                    "column": 12,
                    "event": "note",
                    "message": "(6) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 13,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 13,
                    "event": "note",
                    "message": "(8) when ‘pipe’ succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2221,
                    "column": 12,
                    "event": "note",
                    "message": "(9) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2225,
                    "column": 20,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2225,
                    "column": 12,
                    "event": "note",
                    "message": "(11) following ‘false’ branch (when ‘pid != -1’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2229,
                    "column": 20,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2230,
                    "column": 12,
                    "event": "note",
                    "message": "(13) following ‘true’ branch (when ‘pid == 0’)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2231,
                    "column": 17,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2232,
                    "column": 20,
                    "event": "note",
                    "message": "(15) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2234,
                    "column": 17,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2235,
                    "column": 20,
                    "event": "note",
                    "message": "(17) following ‘false’ branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2237,
                    "column": 17,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2240,
                    "column": 21,
                    "event": "note",
                    "message": "(19) opened here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2240,
                    "column": 20,
                    "event": "note",
                    "message": "(20) ‘dup2(ssh_packet_get_connection_in(ssh), 3)’ leaks here; was opened at (19)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2238|   \t\tclose(to[0]);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2239|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2240|-> \t\tif (dup2(sock, STDERR_FILENO + 1) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2241|   \t\t\tfatal_f(\"dup2: %s\", strerror(errno));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2242|   \t\tsock = STDERR_FILENO + 1;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2411,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshconnect2.c",
                    "line": 2411,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2409|   \tsshbuf_dump(b, stderr);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2410|   #endif",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2411|-> \tif ((r = ssh_keysign(ssh, private, &sig, &siglen,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2412|   \t    sshbuf_ptr(b), sshbuf_len(b))) != 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2413|   \t\terror(\"sign using hostkey %s %s failed\",",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1380,
                    "column": 5,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'pid' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1380,
                    "column": 5,
                    "event": "note",
                    "message": "Value stored to 'pid' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1378|   \t\t\t\tclose(startup_p[1]);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1379|   \t\t\t\tstartup_pipe = -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1380|-> \t\t\t\tpid = getpid();",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1381|   \t\t\t\tif (rexec_flag) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1382|   \t\t\t\t\tsend_rexec_state(config_s[0], cfg);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1924,
                    "column": 25,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'pw_passwd' results in a dereference of a null pointer (loaded from variable 'privsep_pw')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1666,
                    "column": 14,
                    "event": "note",
                    "message": "'i' is < 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1666,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1666,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming 'i' is >= 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1666,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1668",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1676,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1676,
                    "column": 21,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1686,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1686,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1800",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1800,
                    "column": 6,
                    "event": "note",
                    "message": "'rexeced_flag' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1800,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1800,
                    "column": 22,
                    "event": "note",
                    "message": "'inetd_flag' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1800,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1802,
                    "column": 7,
                    "event": "note",
                    "message": "'test_flag' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1802,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1802,
                    "column": 21,
                    "event": "note",
                    "message": "'do_dump_cfg' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1802,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1802,
                    "column": 36,
                    "event": "note",
                    "message": "'rexec_flag' is 1",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1802,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1802,
                    "column": 50,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1802,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1804,
                    "column": 6,
                    "event": "note",
                    "message": "'rexeced_flag' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1804,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1812,
                    "column": 6,
                    "event": "note",
                    "message": "'logfile' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1812,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1819,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'log_level' is equal to SYSLOG_LEVEL_NOT_SET",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1819,
                    "column": 6,
                    "event": "note",
                    "message": "'?' condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1821,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'log_facility' is equal to SYSLOG_FACILITY_NOT_SET",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1821,
                    "column": 6,
                    "event": "note",
                    "message": "'?' condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1823,
                    "column": 6,
                    "event": "note",
                    "message": "'log_stderr' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1823,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1823,
                    "column": 21,
                    "event": "note",
                    "message": "'inetd_flag' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1823,
                    "column": 32,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1829,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1838,
                    "column": 6,
                    "event": "note",
                    "message": "'test_flag' is < 2",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1838,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1838,
                    "column": 23,
                    "event": "note",
                    "message": "'connection_info' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1838,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1843,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1843,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1845,
                    "column": 6,
                    "event": "note",
                    "message": "'rexeced_flag' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1845,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1857,
                    "column": 9,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1860,
                    "column": 32,
                    "event": "note",
                    "message": "'rexeced_flag' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1860,
                    "column": 32,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1864,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'use_pam' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1864,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1868,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'moduli_file' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1868,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1876,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'authorized_keys_command_user' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1876,
                    "column": 51,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1881,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'authorized_principals_command_user' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1881,
                    "column": 57,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1893,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'num_auth_methods' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1893,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1905,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'BSDoptind' is >= 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/defines.h",
                    "line": 664,
                    "column": 29,
                    "event": "note",
                    "message": "expanded from macro 'optind'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1905,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1912,
                    "column": 6,
                    "event": "note",
                    "message": "'do_dump_cfg' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1912,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1916,
                    "column": 19,
                    "event": "note",
                    "message": "'use_privsep' is -1",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1916,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1916,
                    "column": 35,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1916,
                    "column": 49,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1917,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1917,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1923,
                    "column": 3,
                    "event": "note",
                    "message": "Null pointer value stored to 'privsep_pw'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1924,
                    "column": 25,
                    "event": "note",
                    "message": "Access to field 'pw_passwd' results in a dereference of a null pointer (loaded from variable 'privsep_pw')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1922|   \t\tprivsep_pw = pwcopy(privsep_pw);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1923|   \t\tfreezero(privsep_pw->pw_passwd, strlen(privsep_pw->pw_passwd));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1924|-> \t\tprivsep_pw->pw_passwd = xstrdup(\"*\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1925|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1926|   \tendpwent();",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1990,
                    "column": 7,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'sk_flags' results in a dereference of a null pointer (loaded from variable 'key')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1666,
                    "column": 14,
                    "event": "note",
                    "message": "'i' is < 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1666,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1666,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming 'i' is >= 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1666,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1668",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1676,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1676,
                    "column": 21,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1686,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1686,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1800",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1800,
                    "column": 6,
                    "event": "note",
                    "message": "'rexeced_flag' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1800,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1800,
                    "column": 22,
                    "event": "note",
                    "message": "'inetd_flag' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1800,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1802,
                    "column": 7,
                    "event": "note",
                    "message": "'test_flag' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1802,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1802,
                    "column": 21,
                    "event": "note",
                    "message": "'do_dump_cfg' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1802,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1802,
                    "column": 36,
                    "event": "note",
                    "message": "'rexec_flag' is 1",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1802,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1802,
                    "column": 50,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1802,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1804,
                    "column": 6,
                    "event": "note",
                    "message": "'rexeced_flag' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1804,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1812,
                    "column": 6,
                    "event": "note",
                    "message": "'logfile' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1812,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1819,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'log_level' is equal to SYSLOG_LEVEL_NOT_SET",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1819,
                    "column": 6,
                    "event": "note",
                    "message": "'?' condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1821,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'log_facility' is equal to SYSLOG_FACILITY_NOT_SET",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1821,
                    "column": 6,
                    "event": "note",
                    "message": "'?' condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1823,
                    "column": 6,
                    "event": "note",
                    "message": "'log_stderr' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1823,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1823,
                    "column": 21,
                    "event": "note",
                    "message": "'inetd_flag' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1823,
                    "column": 32,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1829,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1838,
                    "column": 6,
                    "event": "note",
                    "message": "'test_flag' is < 2",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1838,
                    "column": 6,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1838,
                    "column": 23,
                    "event": "note",
                    "message": "'connection_info' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1838,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1843,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1843,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1845,
                    "column": 6,
                    "event": "note",
                    "message": "'rexeced_flag' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1845,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1857,
                    "column": 9,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1860,
                    "column": 32,
                    "event": "note",
                    "message": "'rexeced_flag' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1860,
                    "column": 32,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1864,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'use_pam' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1864,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1868,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'moduli_file' is equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1868,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1876,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'authorized_keys_command_user' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1876,
                    "column": 51,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1881,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'authorized_principals_command_user' is not equal to NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1881,
                    "column": 57,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1893,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'num_auth_methods' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1893,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1905,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming 'BSDoptind' is >= 'ac'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/defines.h",
                    "line": 664,
                    "column": 29,
                    "event": "note",
                    "message": "expanded from macro 'optind'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1905,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1912,
                    "column": 6,
                    "event": "note",
                    "message": "'do_dump_cfg' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1912,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1916,
                    "column": 19,
                    "event": "note",
                    "message": "'use_privsep' is -1",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1916,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1916,
                    "column": 35,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1916,
                    "column": 35,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1916,
                    "column": 52,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1917,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1917,
                    "column": 2,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1918,
                    "column": 7,
                    "event": "note",
                    "message": "'privsep_chroot' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1918,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1918,
                    "column": 25,
                    "event": "note",
                    "message": "Assuming field 'kerberos_authentication' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1918,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1934,
                    "column": 6,
                    "event": "note",
                    "message": "Assuming field 'host_key_agent' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1934,
                    "column": 2,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1945,
                    "column": 14,
                    "event": "note",
                    "message": "Assuming 'i' is < field 'num_host_key_files'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1945,
                    "column": 2,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1946,
                    "column": 12,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1946,
                    "column": 12,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1949,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1949,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1951,
                    "column": 12,
                    "event": "note",
                    "message": "Value assigned to 'key'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1951,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1952,
                    "column": 25,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1955,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/openssl/fips.h",
                    "line": 21,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'FIPS_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1955,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1962,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'key' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1962,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1975,
                    "column": 7,
                    "event": "note",
                    "message": "'key' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1975,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1989,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1989,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "openssh-9.6p1/sshd.c",
                    "line": 1990,
                    "column": 7,
                    "event": "note",
                    "message": "Access to field 'sk_flags' results in a dereference of a null pointer (loaded from variable 'key')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1988|   \t\t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1989|   \t\tif (sshkey_is_sk(key) &&",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1990|-> \t\t    key->sk_flags & SSH_SK_USER_PRESENCE_REQD) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1991|   \t\t\tdebug(\"host key %s requires user presence, ignoring\",",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1992|   \t\t\t    options.host_key_files[i]);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshkey.c",
                    "line": 0,
                    "event": "internal warning",
                    "message": "child 12646 timed out after 30s",
                    "verbosity_level": 0
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 483,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshkey.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sshkey_sign’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/sshkey.c",
                    "line": 2309,
                    "column": 9,
                    "event": "warning[-Wmisleading-indentation]",
                    "message": "this ‘if’ clause does not guard...",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2309 |         if (datalen > SSH_KEY_MAX_SIGN_DATA_SIZE)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |         ^~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/sshkey.c",
                    "line": 2311,
                    "column": 17,
                    "event": "note",
                    "message": "...this statement, but the latter is misleadingly indented as if it were guarded by the ‘if’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2311 |                 if (FIPS_mode() && ((key->type == KEY_ED25519_SK) || (key->type == KEY_ED25519_SK_CERT))) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                 ^~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2307|   \tif (lenp != NULL)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2308|   \t\t*lenp = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2309|-> \tif (datalen > SSH_KEY_MAX_SIGN_DATA_SIZE)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2310|   \t\treturn SSH_ERR_INVALID_ARGUMENT;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2311|   \t\tif (FIPS_mode() && ((key->type == KEY_ED25519_SK) || (key->type == KEY_ED25519_SK_CERT))) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 483,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshkey.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function ‘sshkey_verify’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/sshkey.c",
                    "line": 2350,
                    "column": 9,
                    "event": "warning[-Wmisleading-indentation]",
                    "message": "this ‘if’ clause does not guard...",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2350 |         if (siglen == 0 || dlen > SSH_KEY_MAX_SIGN_DATA_SIZE)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |         ^~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/sshkey.c",
                    "line": 2352,
                    "column": 17,
                    "event": "note",
                    "message": "...this statement, but the latter is misleadingly indented as if it were guarded by the ‘if’",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2352 |                 if (FIPS_mode() && ((key->type == KEY_ED25519_SK) || (key->type == KEY_ED25519_SK_CERT))) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |                 ^~",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2348|   \tif (detailsp != NULL)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2349|   \t\t*detailsp = NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2350|-> \tif (siglen == 0 || dlen > SSH_KEY_MAX_SIGN_DATA_SIZE)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2351|   \t\treturn SSH_ERR_INVALID_ARGUMENT;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2352|   \t\tif (FIPS_mode() && ((key->type == KEY_ED25519_SK) || (key->type == KEY_ED25519_SK_CERT))) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshsig.c",
                    "line": 111,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshsig.c",
                    "line": 111,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  109|   \t\tgoto done;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  110|   \t}",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  111|-> \tif ((r = sshbuf_cmp(sbuf, 0, \"\\r\\n\", 2)) == 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  112|   \t\teoffset = 2;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  113|   \telse if ((r = sshbuf_cmp(sbuf, 0, \"\\n\", 1)) == 0)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshsig.c",
                    "line": 113,
                    "column": 12,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshsig.c",
                    "line": 113,
                    "column": 12,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  111|   \tif ((r = sshbuf_cmp(sbuf, 0, \"\\r\\n\", 2)) == 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  112|   \t\teoffset = 2;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  113|-> \telse if ((r = sshbuf_cmp(sbuf, 0, \"\\n\", 1)) == 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  114|   \t\teoffset = 1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  115|   \telse {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshsig.c",
                    "line": 650,
                    "column": 8,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshsig.c",
                    "line": 650,
                    "column": 8,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  648|   \twhile (*opts && *opts != ' ' && *opts != '\\t') {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  649|   \t\t/* flag options */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  650|-> \t\tif ((r = opt_flag(\"cert-authority\", 0, &opts)) != -1) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  651|   \t\t\tret->ca = 1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  652|   \t\t} else if (opt_match(&opts, \"namespaces\")) {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshsig.c",
                    "line": 904,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshsig.c",
                    "line": 904,
                    "column": 7,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  902|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  903|   \t/* Parse the line */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  904|-> \tif ((r = parse_principals_key_and_options(path, linenum, line,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  905|   \t    principal, &principals, &found_key, &sigopts)) != 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  906|   \t\t/* error already logged */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/sshsig.c",
                    "line": 917,
                    "column": 9,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/sshsig.c",
                    "line": 917,
                    "column": 9,
                    "event": "note",
                    "message": "Although the value stored to 'r' is used in the enclosing expression, the value is never actually read from 'r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  915|   \t\tif (principal) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  916|   \t\t\t/* Match certificate CA key with specified principal */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  917|-> \t\t\tif ((r = sshkey_cert_check_authority(sign_key, 0, 1, 0,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  918|   \t\t\t    verify_time, principal, &reason)) != 0) {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  919|   \t\t\t\terror(\"%s:%lu: certificate not authorized: %s\",",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "openssh-9.6p1/umac128.c",
                    "line": 10,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "openssh-9.6p1/umac.c",
                    "line": 520,
                    "column": 9,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'k8' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/umac.c",
                    "line": 520,
                    "column": 9,
                    "event": "note",
                    "message": "Value stored to 'k8' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  518|           k0 = k8; k1 = k9; k2 = k10; k3 = k11;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  519|           k4 = k12; k5 = k13; k6 = k14; k7 = k15;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  520|->         k8 = k16; k9 = k17; k10 = k18; k11 = k19;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  521|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  522|           d += 8;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/umac.c",
                    "line": 520,
                    "column": 19,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'k9' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/umac.c",
                    "line": 520,
                    "column": 19,
                    "event": "note",
                    "message": "Value stored to 'k9' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  518|           k0 = k8; k1 = k9; k2 = k10; k3 = k11;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  519|           k4 = k12; k5 = k13; k6 = k14; k7 = k15;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  520|->         k8 = k16; k9 = k17; k10 = k18; k11 = k19;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  521|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  522|           d += 8;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/umac.c",
                    "line": 520,
                    "column": 29,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'k10' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/umac.c",
                    "line": 520,
                    "column": 29,
                    "event": "note",
                    "message": "Value stored to 'k10' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  518|           k0 = k8; k1 = k9; k2 = k10; k3 = k11;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  519|           k4 = k12; k5 = k13; k6 = k14; k7 = k15;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  520|->         k8 = k16; k9 = k17; k10 = k18; k11 = k19;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  521|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  522|           d += 8;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "openssh-9.6p1/umac.c",
                    "line": 520,
                    "column": 40,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'k11' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "openssh-9.6p1/umac.c",
                    "line": 520,
                    "column": 40,
                    "event": "note",
                    "message": "Value stored to 'k11' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  518|           k0 = k8; k1 = k9; k2 = k10; k3 = k11;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  519|           k4 = k12; k5 = k13; k6 = k14; k7 = k15;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  520|->         k8 = k16; k9 = k17; k10 = k18; k11 = k19;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  521|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  522|           d += 8;",
                    "verbosity_level": 1
                }
            ]
        }
    ]
}
